2017-05-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSFileHandle.h:
	* Source/GSSocketStream.m:
	* Source/GSTLS.h:
	* Source/GSTLS.m:
	* Source/NSFileHandle.m:
	Add code to make the issuer and owner of a client certificate
	available when we require/verify an incoming certificate.

2017-05-10  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Tools/gdomap.c (nameServer, donames): Fix incorrect use
	addresses returned from getaddrinfo.

2017-04-24  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSOutput.m: When generating class/method links, treat '['
	as the start of a class/method only if it's the start of a comment
	or is preceded by white space ... allows array syntax like foo[x] to
	be used in a comment without attempting to link to a class named 'x'.

2017-04-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Version: 1.25.0 release
	* Documentation/ReleaseNotes.gsdoc: update for release
	* Documentation/news.texi: update for release
	* ANNOUNCE: regenerate
	* INSTALL: regenerate
	* NEWS: regenerate
	* README: regenerate

2017-04-09  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSPredicate.m:
        * Tests/base/NSPredicate/basic.m:
	Fixes for bug #47618.

2017-04-09  Richard Frith-Macdonald <rfm@gnu.org>

   	* Headers/Foundation/NSTask.h:
   	* Source/NSTask.m:
	Apply OSX compatibility fix for NSTask notifications (bug #49021)
	by Larry Campbell.

2017-04-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSOperation.m: Fix leak spotted by David Lobron.

2017-04-01 Riccardo Mottola <rm@gnu.org>

	* Source/NSConnection.m
	Correct format specifier to char*

2017-03-17 Riccardo Mottola <rm@gnu.org>

	* Source/NSFileManager.m:(nextObject of Enumerator)
	Skip file if no valid filename could be retrieved most probably due
	to Charset mismatches, this is is more a last resort: probably a
	lossy conversion should be attempted before.

2017-03-17  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSTimeZones/NSTimeZones.tar: Updated with latest information.

2017-03-17  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/Unicode.m: Implement NSNonLossyASCIIStringEncoding
	in a manner compatible with OSX.  Added regression tests.

2017-02-11  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Source/GSICUString.m (UTextNSStringAccess,
	UTextInitWithNSMutableString, UTextInitWithNSString):
	Fix a serious misunderstanding of the icu string access API: The
	value of nativeIndexingLimit must not exceed the length of the
	current chunk. Otherwise icu library macros could miss to properly
	reinitialize chunks, which, for instance, could lead to returning
	regular expression matches outside the selected range.

2017-01-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gdomap.c: Use getaddrinfo rather than gethostbyname if 
	available (bug #50032).

2016-12-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSParser.m: Fix missing line preventing documentation of
	enumeration constants.

2016-11-28  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Source/Additions/NSCalendarDate+GNUstepBase.m (weekOfYear): Fix
	an off by 1 calculation which meant that weekOfYear would return 2
	for the first week of a year whenever the first Thursday of that
	year is 7 Jan, for instance 2016.

2016-11-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPortCoder.m:
	* Source/NSUnarchiver.m:
	Fix for logic error decoding archives created by a machine with a
	different word size.  Was checking the size of the encoded scalar
	item, but not against the *local* size of the same type.

2016-11-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Fix error in last mod ... was calculating opbject
	layout incorrectly when fast-ARC moce used on 64bit system.
	Also simplified by removing special case optimising for single-threaded
	programs and use inline decrement to improve performance of release.

2016-10-28  Niels Grewe <niels.grewe@halbordnung.de>

	* Source/NSObject.m: Re-enable fast-ARC mode when memory layout
	and atomic operations support permit. This changes the size of the
	field where the reference count is stored to the size of a pointer
	in some configurations.
	The effective maximum reference count is still 2^24 - 1.

2016-10-27  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Source/NSObject.m: Comment out _ARCCompliantRetainRelease for
	now because the retain count representation in gnustep-base and
	libobjc2 differs causing space leaks on 64-bit architectures.

2016-10-24  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSData.m: Only atempt to read regular files into NSData,
	* Source/NSMessagePortNameServer.m: Ignore lock directories in the
	'names' directory.
	* Source/NSTask.m Increase files to close from 256 to 2048 to better
	reflect typical modern system limits.
	All changes for problems spotted by Wolfgang.

2016-10-21  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSDate.h: Add documentation
	* Source/NSDate.m: Tidy up and remove a little redundant code.
	* Source/NSRunLoop.m: Tidy up and empty autorelease pool more often.
	* Source/NSTimer.m: Tidy a little and improvde -description

2016-10-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/GNUstepBase/GSTLS.h:
	* Source/GSTLS.m:
	Fix for double free issues when assigning certificat/key to
	credentials fails.

2016-10-12  Niels Grewe <niels.grewe@halbordnung.de>

	* Source/NSRegularExpression.m: Fix crashes in libicu due to
        * ignored error codes. Also fix a few memory leaks.
	* Tests/base/NSRegularExpression/basic.m: Test cases for this.

2016-10-11  Niels Grewe <niels.grewe@halbordnung.de>

	* Source/GSTLS.m
	* configure.ac
	* Headers/GNUstepBase/config.h.in:
	Check for gnutls_x509_privkey_import2() and use it if
	available.
	* configure: Regenerate
	* Tests/base/GSTLS:
	Test case for loading an OpenSSL encrypted private key.

2016-10-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m: Check for modification of source file
	during copy.

2016-10-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/Unicode.m: Permit noncharacter unicode codepoints
	* Source/GSString.m: Permit noncharacter unicode codepoints
	* Source/NSNotificationQueue.m: Call GSPrivateCheckTasks()
	* Source/NSRunLoop.m: Let GSPrivateNotifyASAP() check for task exit.

2016-09-19  Niels Grewe <niels.grewe@halbordnung.de>>

	* Source/Additions/GSMime.m (charsetForXml):
	Fix detection of charset in XML document.
	* Tests/base/GSMime/xml-charset.m: Test case.

2016-09-16  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Source/Additions/GSMime.m (convertTo7BitSafe):
	Add missing checks to avoid calling caseInsensitiveCompare: with a
	nil argument.

2016-09-16  Niels Grewe <niels.grewe@halbordnung.de>

	* Source/GSTLS.m: Fix bug removing mapped certificates.

2016-09-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSScanner.h:
	* Source/NSScanner.m:
	* Tests/base/NSScanner/test01.m:
	Add support for scanHexLongLong method inspired/based on patch from
	Abbas Raza, but with minor bugfixes, reduced code duplication, and
	avoiding compiler warnings.

2016-08-30  Abbas Raza <abbas.raza.1707@gmail.com>

	* Source/NSJSONSerialization.m: Generate NSError rather than raising
	exception if the trailing '"' in the dsocument is missing.

2016-08-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSMime.m: Fix typo which was causing premature termination of
	long headers.

2016-08-19  Richard Frith-Macdonald <rfm@gnu.org>

	* config/objc-common.g: Darwin patch by David Wetzel
	* Source/CompatibilityHeaders.make: Delete obsolete file
	* configure.ac: Check for libdispatch runloop integration functions
	* Headers/GNUstepBase/GSConfig.h.in: New define for libdispatch
	* config.mak.in: New define for libdispatch
	* Tests/base/NSRunLoop/dispatch.m: Use new define
	* configure: Regenerate
	* Source/Additions/Makefile.preamble:
	* Source/GNUmakefile:
	* Source/Makefile.postamble:
	* Source/Makefile.preamble:
	* Source/ObjectiveC2/Makefile.preamble:
	* Source/unix/Makefile.preamble:
	* Source/win32/Makefile.preamble:
	* Tools/Makefile.preamble:
	* Tools/make_strings/GNUmakefile.preamble:
	Mostly tweaks for building cleanly non-flattened and removal of a few
	long deprecated directories/headers.
	Configuration time change by David Wetzel for building on OSX

2016-07-27  Niels Grewe <niels.grewe@halbordnung.de>

	* Header/Foundation/NSData.h
	* Source/NSData.m:
	Make the deallocator block a direct ivar of NSDataMalloc
	(or NSMutableDataMalloc respectively). Breaks binary 
	compatibility but avoids reallocating objects based on 
	the initializer used.

2016-07-26  Niels Grewe <niels.grewe@halbordnung.de>

	* Source/NSDictionary.m
	* Tests/base/NSDictionary/general.m:
	Fix -getObjects:andKeys:
	
2016-07-26  Niels Grewe <niels.grewe@halbordnung.de>

	* Headers/Foundation/NSData.h
	* Source/NSData.m
	* Tests/base/NSData/general.m:
	Implement OS X 10.9 method -initWithBytesNoCopy:length:deallocator:
	that allows customising data deallocation based on a caller
	supplied block. Also adds test cases for this functionality.

2016-07-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSStream.m:
	* Source/GSSocketStream.m:
	In -close we should close the underlying file descriptor (even if the
	stream has not formally been opened yet) to ensure we don't leak it.
	In -dealloc, if the file descriptor still exists, we should call the
	-close method.

2016-07-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/NSObject+GNUstepbase.m: use separate lock to
	protect at exit methods ... avoid conflict/deadlock with multithreaded
	notification change.

2016-07-18  Larry Campbell <lcampbel@akamai.com>

	* Source/NSThread.m: Send notification about becoming multithreaded
	when the new thread is registered from outside our API.

2016-07-18  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSOperation.m: avoid sorting the queue ... keep the array of
	waiting operations sorted by inserting new operations at the correct
	position and observing the queuePriority of waiting operations (and
	re-positiuoning them in the waiting array as necessary).
	Fix for scalability problem (bug #47926)

2016-07-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/win32/GSRunLoopCtxt.m: fix bug in return value when polling.
	The poll method must return YES if any input source fired, including
	handling of windows messages which are already available and require
	no wait.

2016-07-15  Richard Frith-Macdonald <rfm@gnu.org>

        * configure.ac:
        * Headers/GNUstepBase/config.h.in:
        * Source/GSQuickSort.m:
        * Source/GSShellSort.m:
        * Source/GSSorting.h:
        * Source/GSTimSort.m:
        * Source/NSSortDescriptor.m:
	Make sorting algorithms selectable at runtime rather than compile
	time.

2016-07-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSRunLoop.m (-acceptInputForMode:beforeDate:):
	Closer to OSX behavior ... when accepting input we should fire all
	timers (possibly repeatedly) since a timer is not counted as an
	input source.  Also simplify housekeeping timer so that it will
	keep loops running as it does on OSX.

2016-07-12  Niels Grewe <niels.grewe@halbordnung.de>

	* Headers/Foundation/NSObjCRuntime.h
	* Headers/GNUstepBase/GNUstep.h:

	Add NS_DESIGNATED_INITIALIZER macro

2016-07-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSICUString.m (UTextNSStringAccess):
	Fix to use signed integer variables so all the comparisons with zero
	as a boundary actually work as intended etc (spotted by Wolfgang).
	* Source/NSRunLoop.m: Closer to OSX behavior ... a nil date is treated
	like a date in the distant past (ie loop terminates at once), and the
	(-runUntilDate:) method fires any pending timers when given a date in
	the past.

2016-07-12  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Source/GSICUString.m (UTextNSStringAccess): Fix unsigned
	comparison to properly detect integer underflows.

2016-07-06  Niels Grewe <niels.grewe@halbordnung.de>

	* Tests/base/NSRegularExpression/basic.m: Test for -pattern
	double free.

2016-07-06  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Source/NSRegularExpression.m (-pattern): Fix bug where a UText
	structure owned by the icu library is incorrectly closed, which
	was causing a crash when -pattern is called more than once for the
	same NSRegularExpression.

2016-07-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSKeyValueObserving.m: Remove some unnecessary locking
	* Source/NSOperation.m: Simplify handling of finishing of operation
	to avoid occasional deadlock if an operation finishes in one thread
	while in another thread we are waiting for it.

2016-07-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSICUString.m: For immutable strings, cache the string
	length in the UText structure to avoid repeated calls to -length

2016-06-30  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSICUString.m: Re-implement the function to let ICU access
	the contents of an NSString.  The original version looks like it was
	broken for cases where an algorithm is moving backwards in the string
	(reverse search and regular expression parsing).
	I hope the new implementation is correct (or at least clearer); the
	ICU documentation is minimal and I didn't find any reference/example
	implementations to work from.

2016-06-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDebug.m: Yse setjmp/longjmp from NSException.h
	* Headers/Foundation/NSException.h: On mingw-w64 use the builtin
	setjmp/longjmp provided by gcc since the mingw version sometimes
	crashes.

2016-06-28  Richard Frith-Macdonald <rfm@gnu.org>

	* SSL: Openssl bundle directory deleted
	* GNUmakefile: Don't build openssl bundle
	* Source/NSFileHandle.m: Don't load openssl bundle
	* configure.ac: remove option to build bundle
	* configure: regenerate
	* Documentation/ReleaseNotes.gsdoc:
	* Documentation/install.texi:
	* Documentation/news.texi:
	* Documentation/readme.texi:
	Updates to note that the obsolete openssl bundle has been removed.

2016-06-26  Richard Frith-Macdonald <rfm@gnu.org>

        * Headers/Foundation/NSTask.h:
        * Source/NSTask.m:
        * Tests/base/NSTask/general.m:
        * Tests/base/NSTask/notify.m:
	Add -terminationReason method from OSX10.5

2016-06-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSMessagePort.m:
	* config/config.reuseaddr.c:
	Hack to work around Hurd local domain socket bug.
	Plus don't try to set SO_REUSEADDR on local domain sockets anyway.

2016-06-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Documentation/Base.gsdoc:
	* Documentation/ReleaseNotes.gsdoc:
	* Documentation/news.texi:
	* Source/Makefile.postamble:
	* Source/NSBundle.m:
	* Source/NSPathUtilities.m:
	* Source/NSTask.m:
	* Source/NSThread.m:
	* configure:
	* configure.ac:
       When using  non-flattened environment, the subdirectory name for
       libraries/binaries is changed for Debian compatibility (and simplicity)
       to use a directory whose name is of the form architecture/library-combo
       rather than nested directories of the form cpu/os-abi/library-combo.
       The architecture name format is a sanitised triplet cpu-os-abi (where
       previously we had cpu/os-abi).
       These changes are the first step in making GNUstep work seamlessly
       with Debian multiarch.  To use them you will need to rebuild your
       entire gnustep installation using a version of gnustep-make which
       has correspoinding changes to know where to install bbinaries and
       resources.  However, the changes should have no effect on a flattened
       installation (currently the default).

2016-06-24  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDistributedNotificationCenter.m: Double timeout from five
	to ten seconds when waiting for the server to become reachable.
	* Tools/gdnc.m: Auto-stop 15 seconds after the last client disconnects
	rather than immediately ... allowing other clients time to connect.
	Changes to reduce the chance of gdnc failure on a slow system where
	the server is not running as a daemon.

2016-06-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: Optimise getting ascii or utf8 characters
	from a literal string.

2016-06-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Make sure we treat the reference count as a
	32bit integer everywhere, so that atomic operations operate on the
	correct value on big endian CPUs with different word sizes.
	* Source/NSOperation.m: When starting an operation, have it retain
	itself in case it'ss removed from the queue and released while
	running.
	* Headers/Foundation/NSDistributedLock.h: Add lock ivar.
	* Source/NSDistributedLock.m: Make class thread-safe using lock.
	* Source/Tests/base/KVC/mutable.m: Fix 64bit error in method types.

2016-06-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/cifframe.m: Use sizeof(NSInteger) as the buffer size for
	small scalars if we are on an LP64 machine.
	* Source/NSOperation.m: Retain operation while taking it from queue,
	releasing after it is finished.  Prevent crash if the original owner
	of the operation releases it while it's in the queue.

2016-06-17  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSHTTPURLHandle.m:
	* Source/NSURLprotocol.m:
	When sending HTTP headers, use RFC2047 rules (as specified in HTTP/1.1
	RFC2616) to encode non-ascii characters.

2016-06-17  Niels Grewe <niels.grewe@halbordnung.de>

	* Headers/Foundation/NSRegularExpression.h
	* Source/NSRegularExpression.m
	* Tests/base/NSRegularExpression/basic.m:

	Implement resource limits for regular expression evaluation. Tweaked
	to roughly match the Cocoa behaviour, but can be changed through
	the GSRegularExpressionWorkLimit user default.

2016-06-17  Niels Grewe <niels.grewe@halbordnung.de>

	* Source/NSRegularExpression.m: Implement -isEqual: and -hash
	* Tests/base/NSRegularExpression/basic.m: Test NSCopying

2016-06-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSSocketStream.m: Fix for failure of connect() call.
	* Source/GSStream.m: Fix event handling for failed streams.
	* Tests/NSURLConnection/test01.m: Add testcases, fix reset of delegate.
	Fixes for kfreebsd network stack being clever enough to fail the
	connect() call if the remote port is on the same machine and has
	no process listening on it.  Reported by Heintzmann

2016-06-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Documentation/Base.gsdoc:
	* Documentation/ReleaseNotes.gsdoc:
	* Documentation/news.texi:
	Documentation/release notes preparation for next release.

	* Source/Makefile.postamble:
	* Source/NSBundle.m:
	* Source/NSPathUtilities.m:
	* Source/NSString.m:
	* Source/NSTask.m:
	* configure.ac:
	Changes to use the new multiarch path component cpu-host rather
	than a host subdirectory inside a cpu directory.
	* configure: Regenerate

2016-06-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m:
	Fix output conversion to 7bit to work for quoted-printable.
	Also, when generating headers, generate conventionally
	capitalised names.

2016-06-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m:
	Conversion of multipart document between base64 and binary encoding
	should use quoted-printable rather than base64 for text parts.
	Rename -convertToBase64 to be -convertTo7BitSafe instead.

2016-05-27  Niels Grewe <niels.grewe@halbordnung.de>

  	* Tools/AGSParser.m: Ignore __asm__ directives

2016-05-19 Seong Gu Lee <sgleehd@gmail.com>

	* GNUmakefile:
	* Source/Additions/Makefile.preamble:
	* Source/ObjectiveC2/Makefile.preamble:
	* Source/unix/Makefile.preamble:
	* Source/win32/Makefile.preamble:
	mingw64 tweaks

2016-05-18  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPredicate.m: attempt fix for bug #47619

2016-05-18  Eric Heintzmann <heintzmann.eric@free.fr>

	* ChangeLog.2:
	* Documentation/news.texi:
	* Headers/Foundation/NSAutoreleasePool.h:
	* NEWS:
	* Source/GSSocksParser/GSSocksParser.m:
	* Source/NSAutoreleasePool.m:
	* Source/NSConnection.m:
	* Source/NSKeyedUnarchiver.m:
	* Tools/AGSParser.m:
	Fix typos andss spelling erros, including the setPoolCountThreshold:
	method.

2016-05-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Documentation/manual/manual.texi:
	* Source/GSSocksParser/GSSocks4Parser.m:
	* Source/GSSocksParser/GSSocks5Parser.m:
	* Tools/pldes.1:
	Trivial fixes based on debian package.

2016-05-14  Richard Frith-Macdonald <rfm@gnu.org>

        * Headers/GNUstepBase/config.h.in:
        * Source/NSException.m:
        * configure.ac:
        * configure:
	Make USE_BFD control usage of libbfd and replace runtime warning with
	a configure time warning about the license issue.

2016-05-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSNotification.h:
	* Headers/Foundation/NSZone.h:
	* Headers/GNUstepBase/GSConfig.h.in:
	* Source/GSQuickSort.m:
	* Source/GSString.m:
	* Source/GSTimSort.m:
	* Source/NSAutoreleasePool.m:
	* Source/NSConcretePointerFunctions.h:
	* Source/NSGarbageCollector.m:
	* Source/NSNotificationCenter.m:
	* Source/NSObject.m:
	* Source/NSThread.m:
	* Source/NSZone.m:
	Completed(?) removal of GC support.
	Plus various minor reorganisations to avoid compiler warnings.

2016-05-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m:
	Fix bug encoding very long headers with no whitespace to fold on.
	* Source/NSThread.m:
	Avoid use of autorelease pool when setting the name of the thread
	(fix pointless warnings logs spotted by Wolfgang).

2016-05-06 18:03-EDT Gregory John Casamento <greg.casamento@gmail.com>

	* Headers/Foundation/NSString.h: Add containsString:
	* Headers/GNUstepBase/GSVersionMacros.h: Add 10.10 and 10.11 macros.
	* Source/NSString.m: Add containsString: implementation.

2016-04-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSAutoreleasePool.m:
	Check for a pool being deallocated when it has already been
	deallocated (and raise an exception).

2016-04-23  Marcus Mueller <znek@mulle-kybernetik.com>

	* Source/GSAvahiNetService.m: Avahi-based NSNetServices did crash
	upon publishing if Avahi daemon did not run. Hardened code for this
	case which also works correctly if daemon is started later on.

2016-04-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m:
	Remove redundant code.  Log domain names when debug is enabled.

2016-04-08 Riccardo Mottola <rm@gnu.org>

	* Source/NSUserDefaults.m:
	Skip nil domains explicitely and do not use nil values to look them up.

2016-04-04  Niels Grewe <niels.grewe@halbordnung.de>

	* configure.ac: Check for runloop integration hooks in libdispatch
	* configure
	* Headers/GNUstepBase/config.h.in
	* SSL/config.h.in
	* SSL/configure:
	Regenerate
	* Source/NSRunLoop.m: If available, monitor the file descriptor for
	the libdispatch main queue and drain it when it becomes readable.
	* Tests/base/NSRunLoop/dispatch.m
	* Tests/base/NSRunLoop/GNUmakefile.preamble:
	Tests for libdispatch runloop integration

2016-03-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSObject.h:
	* Headers/GNUstepBase/GNUstep.h:
	* Headers/GNUstepBase/GSConfig.h.in:
	* Headers/GNUstepBase/GSIArray.h:
	* Headers/GNUstepBase/GSIMap.h:
	* Source/Additions/GCDictionary.m:
	* Source/Additions/GSLock.m:
	* Source/Additions/GSMime.m:
	* Source/Additions/GSObjCRuntime.m:
	* Source/Additions/Unicode.m:
	* Source/GSArray.m:
	* Source/GSAttributedString.m:
	* Source/GSConcreteValueTemplate.m:
	* Source/GSCountedSet.m:
	* Source/GSDictionary.m:
	* Source/GSHTTPAuthentication.m:
	* Source/GSRunLoopCtxt.h:
	* Source/GSSet.m:
	* Source/GSString.m:
	* Source/NSArchiver.m:
	* Source/NSArray.m:
	* Source/NSAutoreleasePool.m:
	* Source/NSCalendar.m:
	* Source/NSConcreteHashTable.m:
	* Source/NSConcreteMapTable.m:
	* Source/NSConcretePointerFunctions.h:
	* Source/NSConcretePointerFunctions.m:
	* Source/NSConnection.m:
	* Source/NSCountedSet.m:
	* Source/NSData.m:
	* Source/NSDebug.m:
	* Source/NSDictionary.m:
	* Source/NSDistributedNotificationCenter.m:
	* Source/NSFileManager.m:
	* Source/NSGarbageCollector.m:
	* Source/NSHashTable.m:
	* Source/NSIndexSet.m:
	* Source/NSKeyValueObserving.m:
	* Source/NSKeyedArchiver.m:
	* Source/NSKeyedUnarchiver.m:
	* Source/NSMapTable.m:
	* Source/NSMessagePort.m:
	* Source/NSNotificationCenter.m:
	* Source/NSNotificationQueue.m:
	* Source/NSObject.m:
	* Source/NSPointerArray.m:
	* Source/NSPortCoder.m:
	* Source/NSProxy.m:
	* Source/NSRunLoop.m:
	* Source/NSSerializer.m:
	* Source/NSSet.m:
	* Source/NSSocketPort.m:
	* Source/NSString.m:
	* Source/NSThread.m:
	* Source/NSTimeZone.m:
	* Source/NSURL.m:
	* Source/NSURLConnection.m:
	* Source/NSURLProtocol.m:
	* Source/NSUnarchiver.m:
	* Source/NSZone.m:
	* Source/callframe.m:
	* Source/unix/GSRunLoopCtxt.m:
	* Source/win32/GSRunLoopCtxt.m:
	* Tools/AGSHtml.m:
	* Tools/AGSOutput.m:
	* Tools/AGSParser.m:
	* Tools/autogsdoc.m:
	* Tools/gdnc.m:
	* Tools/make_strings/make_strings.m:
	* configure.ac:
	* macosx/config.h:
	Removal of garbage collection support.

2016-03-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSNumber.m: Attempt to fix endianness archiving issue.

2016-03-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPropertyList.m: Remove unused function.  Change binary
	plist generation to return NO if our index table needs to grow,
	rather than raising exceptions during normal operation.

2016-03-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Documentation/ReleaseNotes.gsdoc:
	* Documentation/news.texi:
	* ANNOUNCE:
	* NEWS:
	* NSTimeZones/NSTimeZones.tar:
	* Tools/AGSParser.m:
	* Version:
	Update version for new release. Add short news/announce entries.
	Update timezone information to latest IANA data.
	Add simple support for generics to autogsdoc.

2016-03-18  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: Wait longer for locks on slow systems
	Improve tracking of changes in persistent domains.

2016-03-17  Richard Frith-Macdonald <rfm@gnu.org>

        * Headers/GNUstepBase/GSXML.h:
        * Source/Additions/GSXML.m:
        * Source/GSHTTPURLHandle.m:
        * Source/NSConnection.m:
        * Source/NSDistantObject.m:
        * Source/NSURLHandle.m:
        * Source/NSURLRequest.m:
	Make -setDebug: consistently set/return an integer even if the
	underlying meaning is boolean.  Avoid compiler warnings when
	calling the method on an id and signature is not known.

2016-03-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSCalendarDate.m:
	* Source/NSTimeZone.m:
	Use NSInteger conmsistently (don't mix with int).

2016-03-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: Log if we break the lock.
	* Source/NSDistributedLock.m: Unlock if dealloc'ed while locked.

2016-03-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: Remove five year old code for converting
	old style single defaults file to new style (one file per domain).
	Add some thread safety locks for distriobuted locking in case some
	thread issue is causing Riccardo's problem.

2016-03-11	Niels Grewe <niels.grewe@halbordnung.de>

	* Headers/Foundation/NSPredicate.h:
	Include NSString.h so that we the header knows about NSString
	conforming to NSCopying.

2016-03-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/GNUstepBase/NSObject+GNUstepBase.h:
	* Source/Additions/GSInsensitiveDictionary.m:
	* Source/Additions/GSMime.m:
	* Source/Additions/NSObject+GNUstepBase.m:
	* Source/GSArray.m:
	* Source/GSDictionary.m:
	* Source/GSSet.m:
	* Source/GSString.m:
	* Source/NSArray.m:
	* Source/NSBundle.m:
	* Source/NSFileManager.m:
	* Source/NSJSONSerialization.m:
	* Source/NSPointerArray.m:
	* Source/NSPredicate.m:
	* Source/NSPropertyList.m:
	* Source/NSSerializer.m:
	* Source/NSSet.m:
	* Source/NSSortDescriptor.m:
	* Source/NSString.m:
	* Source/NSTimeZone.m:
	* Source/NSUserDefaults.m:
	Deprecate -makeImmutableCopyOnFail: and replace with -makeImmutable.
	The new method has the essential functionality of the old one,
	but omits the confusing ownership semantics and is therefore less
	likely to cause errors (and more amenable to use with ARC.)

2016-03-10  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Headers/Foundation/NSLocale.h:
	* Source/NSLocale.m (+localeWithLocaleIdentifier:):
	Add trivial method introduced in OS X 10.6.

2016-03-09 Riccardo Mottola <rm@gnu.org>

	* Headers/Foundation/NSPathUtilities.h
	* Source/NSPathUtilities.m
	Add some new path values.

2016-03-09	Niels Grewe <niels.grewe@halbordnung.de>

	* Headers/Foundation/NSPredicate.h
	* Source/NSPredicate.m
	* Tests/base/NSPredicate/basic.m:
	Implementation and tests for +predicateWithBlock: and
	-evaluateWithObject:substitutionVariables:

2016-03-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSSocketPortNameServer.m:
	* Source/GSSocketStream.h:
	* Source/NSTimeZone.m:
	* Source/GSSocketStream.m:
	* Source/NSCalendarDate.m:
	* Source/NSBundle.m:
	* Source/NSPathUtilities.m:
	* Source/NSProcessInfo.m:
	* Source/NSSocketPort.m:
	* Source/GSRunLoopWatcher.m:
	* Source/NSUserDefaults.m:
	* Source/GSStream.m:
	* Source/NSDebug.m:
	* Source/GSTLS.m:
	* Source/NSFileHandle.m:
	* Source/GSHTTPURLHandle.m:
	* Source/NSPage.m:
	* Source/GSRunLoopCtxt.h:
	* Source/GSPrivate.h:
	* Source/NSInvocation.m:
	* Source/NSFileManager.m:
	* Source/objc-load.m:
	* Source/NSException.m:
	* Source/NSURL.m:
	* Source/NSObject.m:
	* Source/NSString.m:
	* Source/cifframe.h:
	* Source/Additions/NSData+GNUstepBase.m:
	* Source/Additions/NSError+GNUstepBase.m:
	* Source/Additions/NSTask+GNUstepBase.m:
	* Source/NSConnection.m:
	* Source/GSPortPrivate.h:
	* Source/NSThread.m:
	* Source/NSData.m:
	* Source/NSHost.m:
	* Source/GSNetwork.h:
	* Source/NSPipe.m:
	* Source/GSFileHandle.h:
	* Source/NSLog.m:
	* Source/GSFileHandle.m:
	* Source/NSTask.m:
	* Tests/base/NSTask/launch.m:
	* Tests/base/NSURL/basic.m:
	* Tests/base/NSURL/mystep.m:
	* Tests/base/NSString/test02.m:
	More changes to standardise on using _WIN32 define for windows.

2016-03-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSCalendar.m: Fix 64bit issue with undefined components.
	* Source/NSBundle.m:
	* Source/NSFileManager.m:
	* SSL/GSSSLHandle.m:
	* Headers/GNUstepBase/GSConfig.h.in:
	* macosx/GNUstepBase/preface.h:
	Standardise on using _WIN32 and _WIN64 defines, following the
	informal convention used by all the compilers we might be compiled with.
	* Source/win32/GSFileHandle.m: Various network/file bugfixes.

2016-03-01  Richard Frith-Macdonald <rfm@gnu.org>

	Modifications to last batch of changes in order to get the code to
	build again on 32bit msys/mingw

2016-03-01  Seong Gu Lee <sgleehd@gmail.com>

        * Headers/GNUstepBase/GSConfig.h.in:
        * Headers/GNUstepBase/GSTypeEncoding.h:
        * Source/GSFileHandle.h:
        * Source/win32/GSFileHandle.m:
	Tweaks for WIN64 build

2016-02-29  Richard Frith-Macdonald <rfm@gnu.org>

        * configure.ac:
        * configure:
	* NSCalendar.m:
	Don't require recent ICU just for the method
	([-components:fromDate:toDate:options:]).
	Leave the method as a no-op if older versions are used.

2016-02-29  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m: Based on testplant patch, fix bug with
	ownership when copying subdirectories.
	* Source/NSTask.m OSX compatibility tweak .. raise an exception if
	the task can't be launched.
	* Source/NSNumberFormatter.m: Fixes for symbol indexes.

2016-02-26 	Niels Grewe <niels.grewe@halbordnung.de>

	* Headers/Foundation/NSObjCRuntime.h: Declare the FOUNDATION_EXPORT
	macro as an alias for GS_EXPORT.

2016-02-24  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSArray.h:
	* Source/NSArray.m:
	Correct argument types in ([-objectAtIndexedSubscript:]) and
	([setObject:atIndexedSubscript:]) to match OSX.
	Apply patch by Patrick Laurent <plaurent@me.com> to fix bug setting
	an object at the end of the array.

2016-02-22	Niels Grewe <niels.grewe@halbordnung.de>

	* Headers/Foundation/NSObjCRuntime.h: Add macros for backwards-
	compatible generics annotations. Also define instancetype if necessary.
	* Headers/Foundation/NSArray.h:
	* Headers/Foundation/NSCache.h:
	* Headers/Foundation/NSDictionary.h:
	* Headers/Foundation/NSEnumerator.h:
	* Headers/Foundation/NSSet.h: Update interfaces for instancetype and
	generics.
	* Source/NSCache.m: Use NSMapTable instead of NSMutableDictionary.
	The API contract for NSCache stipulates that keys are not copied, so
	using a dictionary wasn't apropriate.
	* Source/NSConnection.m:
	* Source/NSData.m: Small type safety improvements (mostly to keep the
	compiler happy).
	* Source/NSDictionary.m: Change id to id<NSCopying> in a few places to
	avoid compiler warnings.
	* Tests/base/NSCache:
	* Tests/base/NSCache/TestInfo:
	* Tests/base/NSCache/basic.m:
	* Tests/base/NSCache/cache.m:
	Test cases eviction from NSCache. Turns out we currently only evict
	NSDiscardableContent, while the API documentation seems to suggest
	that cost and count based eviction without NSDiscardableContent is
	also possible.

2016-02-18  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m:
	Fold using tabs between key=value tokens in structured headers
	in the hope that it will improve compatibility with code which
	doesn't cope well with a space as the folding character.

2016-02-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m: Use NSDebugLog for most debug warnings
	* Source/NSUserDefaults.m: Restructure to cache flag information
	from NSProcessInfo directly on initialization, so it can be used
	when parsing property lists in the argument domain, avoiding any
	recursion trying to parse arguments.  Remove obsolete code for
	for parsing -GS and --GS argument prefixes specially.
	Make sure that argument parsiong behavior matches OSX apart from
	The handling of a lone '-' used as key/value, and for this case
	document the difference (since the GNUstep behavior is more useful
	and changing it would have a real chance of breaking existing code).

2016-02-12  Niels Grewe <niels.grewe@halbordnung.de>

	* Headers/Foundation/NSObjCRuntime.h: Define macros for
	non-null sections if available.

2016-02-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSThread.m: In GSCurrentThread() the check for exiting
	thread needs to NOT be wrapped in an exception handler, since the
	exception handling code can attempt to get the current thread,
	causing recursion.

2016-02-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m:
	Remove dependency on NSUserDefaults in order to parse property list
	in program arguments ... get boolean defaults settings from the
	argument domain

2016-02-09  Larry Campbell <lcampbel@akamai.com>

	* Source/NSUserDefaults.m: Fix for bug #46956

2016-02-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gdomap.c: Use uint32_t rather than unsigned long ... we are
	actually dealing with 4 byte values (from htonl), not native longs,
	and this can result in buffer overrun when we try copying a 64bit
	value into a 32bit buffer on a 64bit system.

2016-02-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSData.m: Fix for decoding base64 with unknown characters
	after a trailing '='

2016-01-29  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m: keep key=value pairs in structured fields
	on the same line if possible.

2016-01-29	Niels Grewe <niels.grewe@halbordnung.de>

	* Source/NSThread.m: Automatic 'late' unregistration of thread objects:
	When +exit is not called, we no longer log a warning and leak the
	thread object.
	Instead, we add it to a map table, keyed under the current thread ID,
	and use that in GSCurrentThread() to find the correct NSThread object
	if pthread_getspecific wont return it to us.
	* Tests/base/NSThread/late_unregister.m: Test case for late
	unregistration.

2016-01-21	Niels Grewe <niels.grewe@halbordnung.de>

	* Source/Additions/GSMime.m: Fix folding of headers containing
	a '_' character.

2016-01-21	Niels Grewe <niels.grewe@halbordnung.de>

	* Tests/base/GSMime/general.m: Test case for quoted boundary
	parameter failure.

2016-01-21  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: Fix errors in conversion from a constant utf-8
	string containing non-ascii characters to latin1 encoded data.
	* Source/Additions/GSMime.m: Change line folding code to preserve
	exact whitespace (using encoded words if necessary). Add support
	for generating more readable 'q' encoded words rather than just
	base64 encoded.  Uses old behavior of folding with a tab character
	if the GSMimeOldStyleFolding user default is set to YES, though
	it's likely that this backward compatibility feature will be removed
	in future.

2015-12-30  Marcus Mueller <znek@mulle-kybernetik.com>

	* Source/NSNumberFormatter.m: fixed a subtle off-by-one formatter
	bug in conjunction with zero padding and NSNumberFormatterBehavior10_0.

	* Tests/base/NSNumberFormatter/basic.m: added a test for this
	particular issue

2015-12-29  Marcus Mueller <znek@mulle-kybernetik.com>

	* Source/NSUserNotification.m: "NSUserNotificationDefaultSoundName"
	constant string was declared but missing, fixed

2015-12-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSXMLElement.m: For OSX compatibility, raise an exception
	it we attempt to insert an element which is already the child of
	some other element.

2015-11-30: Niels Grewe <niels.grewe@halbordnung.de>

	* Source/NSCalendar.m:
	* Headers/Foundation/NSCalendar.h:
	Implement -components:fromDate:toDate:options:. (Not handling
	NSWrapCalendarComponents yet.)
	* Tests/base/NSCalendar/component-diff.m:
	Test case for new functionality.

2015-11-22 Riccardo Mottola <rm@gnu.org>

	* Source/NSFileManager.m (createDirectoryAtPath)
	Should return success even if all path components do exist,
	as by Apple spec.

2015-11-13 Riccardo Mottola <rm@gnu.org>

	* Source/NSRange.m: (NSRangeFromString)
	Parse length and location with scanInteger and not scanInt
	(suggested by Fred Kiefer to fix 64bit)

2015-11-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSXMLElement.m: (insertChild:atIndex:) if the child already
	has a parent, detach from that before adding to the new parent.
	OSX compatibility fix.

2015-11-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSXMLDocument.m: When libxml2 is not enabled, create a
	stub class which will raise an exception on instantiation.

2015-10-31  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: Fix for fastpath code for literal string
	comparison which was ignoring the case insensititve option.
	Problems spotted by Fred, triggered by a Testplant change.

2015-10-21  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSBundle.m: remove declaration of unused methods.

2015-10-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSSocketPortNameServer.m: Fix retain/release error causing
	crash on failure to launch gdomap.

2015-10-05 Niels Grewe <niels.grewe@halbordnung.de>

	* Headers/GNUstepBase/GNUstep.h: Define __has_extension() if the
	compiler does not support it.
	* Headers/Foundation/NSObjCRuntime.h: Provide definitions for
	NS_ENUM and NS_OPTIONS.

2015-10-03  Fred Kiefer <fredkiefer@gmx.de>

	* Source/NSPropertyList.m (GSBinaryPLGenerator-storeCount:): Use
	0x12 instead of 0x13 for integer count.
	* Source/NSPropertyList.m (GSBinaryPLParser-readCountAt:): Handle
	0x12 correctly. Use same code for 0x13 to read old incorrect
	written data.
	Based on change by Josh Freeman <pikopixel@twilightedge.com>

2015-09-23  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Source/NSXMLParser.m:
	* Tests/base/NSXMLParser/ParseData/quoted-entities.result
	* Tests/base/NSXMLParser/ParseData/quoted-entities.xml
	Turn on substitution of entities to match OSX behavior, add tests.

2015-09-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSData.h:
	* Source/Additions/GSObjCRuntime.m:
	* Source/GSFFCallInvocation.m:
	* Source/GSFormat.m:
	* Source/GSValue.m:
	* Source/NSArchiver.m:
	* Source/NSData.m:
	* Source/NSDecimalNumber.m:
	* Source/NSKeyValueObserving.m:
	* Source/NSKeyedArchiver.m:
	* Source/NSKeyedUnarchiver.m:
	* Source/NSMethodSignature.m:
	* Source/NSPortCoder.m:
	* Source/NSUnarchiver.m:
	* Source/cifframe.m:
	Implement support for C99 _Bool type.

2015-09-22 Riccardo Mottola <rm@gnu.org>

	* Headers/GNUstepBase/GSBlocks.h
	Do not enable weak on mingw, because it works only with ELF.

2015-09-18 Riccardo Mottola <rm@gnu.org>

	* Headers/Foundation/NSError.h
	* Source/NSError.m
	Add some 10.6 URL errors

2015-09-16  Richard Frith-Macdonald <rfm@gnu.org>

	* configure.ac: fix check for pthread setname to work with older
	versions of clang which object to autoconf checking for the
	existence of a function by calling it without args.

2015-09-16 Riccardo Mottola <rm@gnu.org>

	* Headers/Foundation/NSFileManager.h
	* Source/NSFileManager.m
	Add simple (files only and no keys handling) implementation
	of 10.6 method contentsOfDirectoryAtURL.

2015-09-08 Niels Grewe <niels.grewe@halbordnung.de>

	* Source/NSPropertyList.m: Fix writing base64 data.

2015-09-04 Niels Grewe <niels.grewe@halbordnung.de>

	* Source/GSString.m: Optimisation for formatting strings that are
	stored as UTF-16 (use memcpy instead of looping over the characters).
	* Tests/base/NSString/unichar_format.m: Test cases for formatting.

2015-09-01 Niels Grewe <niels.grewe@halbordnung.de>

	* Source/NSRegularExpression.m: Fix handling of empty capture groups.

2015-08-30  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSOperation.m: Fix potential deadlock with adding observers.
	* Source/NSPropertyList.m: Fix a few mutability errors.  Improve
	parsing NSData performance. Add support for parsing base64 encoded
	data in text property lists (delimited by <[ and ]>).

2015-08-29  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m: Improve descriptions for debug.
	* Source/Additions/NSData+GNUstepBase.m: Add escaped representation.
	* Source/GSHTTPURLHandle.m: Use escaped text format for debug log
	(and plist armored format) to ensure that we safely log binary data

2015-08-24  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/win32/GSFileHandle.m: include winsock2.h earlier for msys2

2015-08-17  Fred Kiefer <fredkiefer@gmx.de>

	* Resources/Korean.lproj/Localizable.string: Correct encoding
	* Resources/Languages/Korean: Add missing quotes.
	Patch by Seong-Gu Lee <sgleehd@gmail.com>

2015-08-17  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/GNUstepBase/NSData+GNUstepBase.h: Simple gzip API
	* Source/Additions/NSData+GNUstepBase.m: Use zlib to zip/unzip data
	* Tests/base/NSData/additions.m: tests for NSData additions (gzip)
	* Tests/base/NSData/Lorum: Data file for compress/uncompress tests

2015-08-16  Richard Frith-Macdonald <rfm@gnu.org>

	* configure.ac: Use the compiler provided by gnustep-make unless
	it's specifically overridden in the environment.

2015-08-07 Niels Grewe <niels.grewe@halbordnung.de>

	* Source/NSPropertyList.m: Cope with certain malformed binary
	property lists.
	* Tests/PropertyLists/test01.m
	* Tests/PropertyLists/cyclic.plist:
	Test case for binary plists.

2015-08-05 Riccardo Mottola <rm@gnu.org>

	* Source/NSArray.m:
	Minor cast fixes.

2015-07-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSStream.m: Fix failure to unschedule from run loop if a
	stream is opened more than once.

2015-07-24  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/GNUstepBase/GSIMap.h: add GSI_MAP_TABLE_S
	* Source/NSConcreteHashTable.m:
	* Source/NSConcreteMapTable.m:
	Pass variable holding run time size calculation as GSI_MAP_TABLE_S

2015-07-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSConcreteHashTable.m:
	* Source/NSConcreteMapTable.m:
	Get instance size at run time, so we can compile using nonfragile-abi

2015-07-16 Niels Grewe <niels.grewe@halbordnung.de>

	* Source/GSSet.m
	* Source/GSCountedSet.m:
	Fix a few more names.

2015-07-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/GNUstepBase/GSIMap.h:
	* Headers/GNUstepBase/NSObject+GNUstepBase.h:
	* Source/Additions/GSMime.m:
	* Source/Additions/NSObject+GNUstepBase.m:
	* Source/GSArray.m:
	* Source/GSCountedSet.m:
	* Source/GSDictionary.m:
	* Source/GSPrivate.h:
	* Source/GSSet.m:
	* Source/GSString.m:
	* Source/NSArray.m:
	* Source/NSData.m:
	* Source/NSDictionary.m:
	* Source/NSObject.m:
	* Source/NSSet.m:
	* Source/NSString.m:
	Rewriting naive implementations to improve efficiency and fix a few
	bugs as well as renaming to avoid conflict with old GSCache.

2015-07-16 Niels Grewe <niels.grewe@halbordnung.de>

	* Headers/GNUstepBase/NSHashTable+GNUstepBase.h
	* Source/Additions/GNUmakefile
	* Source/Additions/NSHashTable+GNUstepBase.m
	* Source/GNUmakefile
	* Tests/base/NSHashTable/additions.m:
	Implement -addObjectsFromArray: on NSHashTable.

2015-07-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/GNUstepBase/GSIMap.h:
	* Headers/GNUstepBase/NSObject+GNUstepBase.h:
	* Source/Additions/GSMime.m:
	* Source/Additions/NSObject+GNUstepBase.m:
	* Source/GSArray.m:
	* Source/GSCountedSet.m:
	* Source/GSDictionary.m:
	* Source/GSPrivate.h:
	* Source/GSSet.m:
	* Source/GSString.m:
	* Source/NSArray.m:
	* Source/NSData.m:
	* Source/NSDictionary.m:
	* Source/NSObject.m:
	* Source/NSSet.m:
	* Source/NSString.m:
	Extension API to interrogate object memory usage (stolen from
	GSCache and modified a bit).

2015-07-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPropertyList.m: Write xml document headers referring to
	the current location of Apple's property list dtd for compatibility
	with software expecting to validate using that dtd.
	Stefan Bidigaray pointed out that the heading we currently write is
	very out of date.
	* Source/NSThread.m: On premature thread exist, log native thread ID.
	* Source/NSLog.m: Optimisations to make logging a little quicker.

2015-07-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDebug.m: List memory allocation statistics in alphabetical
	order (by class name) for easier interpretation.
	Fix bug where the counter for differences was updated when difference
	listing was not requested.

2015-07-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSLock.h:
	* Source/NSLock.m:
	Add extension method -isLockedByCurrentThread for debug purposes.
	Also make description report the OS thread id of the thread which
	holds the lock (if any).

2015-07-08 Riccardo Mottola <rm@gnu.org>

	* Headers/GNUstepBase/GSConfig.h.in
	On NetBSD, undefine the system __weak first.

2015-07-03 Niels Grewe <niels.grewe@halbordnung.de>

        * Tests/base/NSXMLParser/ParseData/namespaced-attributes.xml:
        * Tests/base/NSXMLParser/ParseData/namespaced-attributes.result:
        Test case for attribute namespace prefixes.

2015-07-03 Niels Grewe <niels.grewe@halbordnung.de>

        * Source/Additions/GSXML.m: Fix reporting namespace prefixes
        of attributes when using the SAX2 parser.

2015-06-30  Richard Frith-Macdonald <rfm@gnu.org>

        * configure.ac:
        * configure:
        * Headers/GNUstepBase/config.h.in:
        Add test for pthread_mutex_t.__data.__owner
        Update various tests to silence autoconf warnings.
	* Source/NSLock.m: If available, use pthread_mutex_t.__data.__owner
	to print the owning thread ID in the -description method.

2015-06-26 Riccardo Mottola <rm@gnu.org>

	* Source/NSMethodSignature.m
	* Source/cifframe.m
	Minor include fixes to avoid malloc.h warnings on OpenBSD.

	* Source/NSScanner.m
	Remove set but unused variable.

2015-06-22  Richard Frith-Macdonald <rfm@gnu.org>

        * Headers/GNUstepBase/Additions.h:
        * Headers/GNUstepBase/GSConfig.h.in:
        * Headers/GNUstepBase/GSVersionMacros.h:
        Minor tweaks to build and avoid warnings in Yosemite

2015-06-14 Riccardo Mottola <rm@gnu.org>

	* Headers/Foundation/NSData.h
	* Source/NSData.m
	base64EncodedDataWithOptions, base64EncodedStringWithOptions:
	first implementation

2015-06-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSData.m: be strict about '=' padding only occurring at end
	of base64 encoded data.

2015-06-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSArray.m: Use NSUInteger rather than unsigned, use memory
	management macros.
	* Source/NSConnection.m: Changes to avoid compiler warnings.
	* Headers/Foundation/NSData.h:
	* Source/NSData.m: add base64 initialisation methods (bug #45240)

2015-06-01 Riccardo Mottola <rm@gnu.org>

	* Headers/Foundation/NSArray.h
	* Source/NSArray.m
	Add firstObject: method existing since 10.6

2015-05-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSURLConnection.m: Fix leak of limit date
	* Source/NSXMLParser.m: Fix leak of string

2015-05-26: Sebastian Reitenbach <sebastia@l00-bugdead-prods.de>

	* Source/Additions/Unicode.m
	* Tools/AGSOutput.m
	  return NULL or nil instead of NO where pointers are to
	  be returned

2015-05-26  Richard Frith-Macdonald <rfm@gnu.org>

	* GSString.m: Fix sign extension bug
	* Source/NSXMLParser.m: Update to more exactly match OSX behavior
	* Source/NSDateFormatter.m: attempt to fix functionality broken
	by additional call to set date format during reset.

2015-05-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSXMLParser.m: Use libxml2 if available.

2015-05-24  Richard Frith-Macdonald <rfm@gnu.org>

	* GSString.m:
	* NSDebug.m:
	* NSZone.m:
	Minor optimisations and tidyups

2015-05-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: Fix failure to check free when done flag before
	freeing memory.

2015-05-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m:
	* Source/GSString.m:
	Some optimisation.  Fix -hasPrefix: and -hasSuffix: to use literal
	search as on OSX.

2015-05-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Documentation/install.texi:
	* ANNOUNCE:
	* INSTALL:
	* NEWS:
	Final updates for 1.24.8 release

2015-05-13  Richard Frith-Macdonald <rfm@gnu.org>

	* configure.ac: Tidy compiler and preprocessor  detection and use
	warning for potentially broken compiler selection.
	* configure: regenerate

2015-05-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Version:
	* Documentation/news.texi:
	* Documentation/ReleaseNotes.gsdoc:
	Update in preparation for release
	* Source/Makefile.postamble:
	* Makefile.postamble:
	* GNUmakefile:
	Apply Yavor Doganov's patch to avoid re-run of configure when we do
	multiple 'make distclean' invocations (bug #29730).

2015-05-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSTimeZones/NSTimeZones.tar: updated

2015-05-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m:
	Fix for 64bit systems using TinyString objects ... missing
	implementations for common methods were making performance dire.

2015-05-02 Niels Grewe <niels.grewe@halbordnung.de>

	* Source/GSSet.m
	* Source/NSCountedSet.m
	* Source/NSSet.m:
	Implement a private method -_countForObject: that enables to correctly
	check equality of NSSet and NSCountedSet (behaviour verified to match
	OS X). Fixes bug #43915.
	* Tests/base/NSCountedSet/equality.m: Test cases for equality behaviour.

2015-04-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSTimeZone.m: Improve caching of common absolute timezones.

2015-04-28  Niels Grewe <niels.grewe@halbordnung.de>

	* Source/NSDateFormatter.m: Properly reinstall the user provided
	date format when we need to recreate the icu-based date formatter.

2015-04-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSThread.m: If an exception occurs while performing a
	selector in another thread, catch it and cleanup (and if the
	caller is waiting, pass the exception back to it).

2015-04-01  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* configure.ac: Fix comment syntax and use standard operator in
	test command.

	* configure: Regenerated.

2015-03-31  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSPrivate.h: Internal function to get OS thread ID
	* Source/NSThread.m: Report thread name and ID in description
	* Source/NSLog.m: Use new function for thread ID
	* configure.ac: Detect getaddrinfo and bsd thread id extensions
	* Headers/GNUstepBase/config.h.in: regenerate
	* configure: regenerate
	* Source/NSHost.m: Start of code to use getaddrinfo

2015-03-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSAutoreleasePool.m: Fix a bug leading to crashes on thread
	exit in cases where deallocation of something in the thread dictionary
	causes further use of the thread's autorelease pool (which has already
	been deallocated).

2015-03-10 Niels Grewe <niels.grewe@halbordnung.de>

	* Source/GSTimSort.m: Fix a DoS vulnerability discovered in the
	Timsort algorithm. For information about the problem please refer to
	http://www.envisage-project.eu/proving-android-java-and-python-sorting
	-algorithm-is-broken-and-how-to-fix-it/

2015-03-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileHandle.m: ([-sslHandshakeEstablished:outgoing:])
	If we can't create a session, the handshake should fail rather
	than being retried.  Fix infinite loop establish session on closed
	handle.

2015-02-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/GNUstepBase/NSDebug+GNUstepBase.h:
	Define DLog() and ALog() as suggested by Amr Aboelela

2015-02-28  Richard Frith-Macdonald <rfm@gnu.org>

	* configure.ac: Check for gettid availability
	* configure: Regenerate
	* Headers/GNUstepBase/config.h.in: Regenerate
	* Source/GSPrivate.h: Update comment on GSLogThread
	* Documentation/Base.gsdoc: Update doc of GSLogThread
	* Source/NSLog.m: Change to log thread ID (to match OSX which now
	logs the thread ID along with the process ID).  Change the meaning
	of the GSLogThread user default (which used to turn on logging of
	the thread ID) so that it now turns on logging of the thread name
	(where a thread name has been set) and the NSThread address if no
	name has been set.

2015-02-16  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Source/NSData.m (writeToFile:options:error:): Fix leak of open
	file descriptor on systems where mkstemp is defined.

2015-02-15  Richard Frith-Macdonald <rfm@gnu.org>

	* config/objc-sys-dynamic.m4: Check for windows before anything else
	* configure: regenerate
	Apparently recent mingw implements headers which folled configure
	into using dlopen() with doesn't support native windows paths ...
	change order of checks so we still use the native API.

2015-02-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSThread.m: Be more agressive about releasing thread
	resources when a thread exists (in particular release the
	thread's runloop repeatedly for bug #44240) in case of the
	deallocation of objects causing re-population of thread data.

2015-02-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSData.m: Simplify mingw/unixy ifdefs for writing a file.
	* Source/NSThread.m: Simplify mingw/unixy ifdefs for sleeping.

2015-02-05 	Niels Grewe <niels.grewe@halbordnung.de>

	* Source/GSTLS.m: Use path standardization when setting up TLS data
	to be mapped to a specific filesystem location.

2015-01-13  Marcus Mueller <znek@mulle-kybernetik.com>

	* Headers/Foundation/Foundation.h: added NSUUID.h

2014-12-28  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* configure.ac:
	* Source/NSThread.m (PTHREAD_SETNAME):
	Fix detection of the proper pthread_setname_np and
	pthread_set_name_np variants on FreeBSD, OpenBSD and Darwin.

	* configure: Regenerated.

2014-12-28  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Source/GSSocketStream.m: Add necessary GSTLSHandler methods when
	TLS is disabled.
	* Source/GSTLS.m (standardizedPath): Define private function only
	when TLS is enabled.

2014-12-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSTimeZone.m:
	* Source/nstzfile.h:
	Remove unused include of (possibly) non existent file.

2014-12-23 Riccardo Mottola <rm@gnu.org>

	* Source/GSSocketStream.m
	Fix code-path for non AF_INET6

	* Source/NSDate.m
	Provide NAN constant for Solaris if not available.

2014-11-29  Sergei Golovin <Golovin.SV@gmail.com>

	* Tests/base/NSURLConnection: Test helper tool plus a load of
	tests for NSURLConnection.

2014-11-29  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSScanner.m: Fixup error in scanning doubles with excess
	precision (bug #43722).

2014-11-28  johannes@brilliantservice.co.jp

	* Source/NSThread.m: Set thread name visible to OS
	* configure.ac: test for pthread_set_name_np()
	Integrated Johannes patch with some changes to make things work if
	we set the name before starting the thread.  Commend out ms-windows
	code which doesn't work yet.

2014-11-20  Sergei Golovin <Golovin.SV@gmail.com>

	* Source/GSSocketStream.m:
	* Tests/base/NSURL/Helpers/capture.m:
	* Tests/base/NSURL/testKey.pem:
	* Tests/base/NSURL/test02.m:
	* Tests/base/NSURL/testCert.pem:
	Implement TLS on server socket and make use of it in HTTPS URL helper
	code. Also, permit NSStream zero length write (it seems OSX allows
	it).

2014-11-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSRunLoop.m: Avoind some unnecessary retain/release cycles.

2014-11-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSTLS.m: If a user default value is removed while running,
	revert to the value from the environment or the hard coded fallback
	rather than continuing to use the previous value from the defaults
	system.

2014-11-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSThread.m: When handling perform in another thread, check
	more carefully for inter-thread communications (pipe on unix, event
	on windows) and make sure we invalidate performers safely outside
	the lock protected region when I/O is complete.

2014-11-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSHTTPURLHandle.m: Fix leak of handle when starting a new
	connection after an older one is dropped by the remote end.

2014-10-30  Sergei Golovin <Golovin.SV@gmail.com>

	* Source/NSURLProtocol.m: Fix memory leak and possible hang on retry
	(bug #43461).

2014-10-17  Richard Frith-Macdonald <rfm@gnu.org>

	* Documentation/news.texi:
	* Documentation/ReleaseNotes.gsdoc:
	* Version: Bump subminor version for bugfix release
	* NSTimeZones/NSTimeZones.tar: update
	* Source/NSProcessInfo.m: Use separate lock for globally unique
	string rather than sharing lock intended for other purposes.
	* Source/GSTLS.m: Change default TLS 'priority' to disable SSLv3.0
	as it renders things open to the 'POODLE' attack.
	Also, print warning if it is expressly requested from the code
	(though the use of the GSTLSPriority user default will still
	allow complete control without warnings).

2014-10-11  Marcus Mueller <znek@mulle-kybernetik.com>

	* Headers/GNUstepBase/GSVersionMacros.h: UNAVAILABLE_ATTRIBUTE added

2014-08-19  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* configure.ac:
	* Headers/GNUstepBase/config.h.in: Add test for grantpt function.

	* configure: Regenerated.

2014-07-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Tools/gdomap.c: Unless running on windows, allow new -j
	command-line argument to specify the path in which the process should
	be jailed (chroot).  The default remains to jail the process in /tmp
	since there doesn't seem to be a general, portable alternative.

2014-07-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSSocketStream.m: Fix handling TLS handshake in the case
	where there is a network failure during the handshake (bug#42781).
	* Source/GSTLS.m: Fix erroneous attempt to load revocation lists.
	* Tests/base/NSURLConnection/test01.m: https test contributed by
	Sergei Golovin.

2014-07-25  Richard Frith-Macdonald <rfm@gnu.org>

        * configure.ac: Remove compiler charset options
        * config.mak.in: Remove compiler charset options
        * configure: regenerate:
        Yavor pointed out that the gcc manual is wrong and gcc (all the
        versions we support anyway) always uses utf-8 (as does clang),
        so we can get rid of stuff intended to try to force it to use utf8

2014-07-13  Yavor Doganov  <yavor@gnu.org>

	Add large file support (LFS) for NSData.
	* configure.ac: Call AC_FUNC_FSEEKO/AC_SYS_LARGEFILE.
	* Source/NSData.m (readContentsOfFile): Use fseeko/ftello and
	off_t as appropriate.
	(-initWithContentsOfFile:): Define fileLength of type off_t.
	* Source/GSFileHandle.m:
	* Source/win32/GSFileHandle.m:
	* Source/NSFileManager.m: Remove _FILE_OFFSET_BITS define (now
	defined globally in config.h).

2014-07-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSRunLoop.m: ([-runMode:beforeDate:]) check performers as
	well as notifications etc ... should fix bug #39107

2014-02-17  Larry Campbell <lcampbel@akamai.com>

	* Source/NSJSONSerialization.m:
	* Tests/base/NSJSONSerialization/tests00.m:
	Fixes for bug #41628

2014-07-12 Yavor Doganov  <yavor@gnu.org>

	* Tests/GNUmakefile:
	* Tests/base/Functions/NSGeometry1.m:
	* Tests/base/NSRunLoop/performers.m:
	Tweaks for running in sandbox (bug #42740)

2014-07-07  Yunqiang Su  <wzssyqa@gmail.com>  (tiny change)

	* config/config.trampoline.c:
	* Source/NSObject.m (GSAtomicIncrement, GSAtomicDecrement):
	Use __mips64 to distinguish MIPS64.

2014-06-30  Yavor Doganov  <yavor@gnu.org>

	* Tools/GNUmakefile (CONFIG_SYSTEM_LIBS):
	* Tools/make_strings/GNUmakefile (CONFIG_SYSTEM_LIBS): Define
	to the empty string to avoid linking the tools against
	external libraries.

2014-06-30 Yavor Doganov  <yavor@gnu.org>

	* base.make.in: make base dependencies explicit only when statically
	linnking (bug #42423)

2014-06-30 Yavor Doganov  <yavor@gnu.org>

	* GNUmakefile: Use -include for deb.make (for backward compatibility
	with old versions of gnustep-make).
	* Documentation/GNUmakefile:
	* Documentation/General/GNUmakefile:
	* Source/DocMakefile:
	* Tools/DocMakefile:
	Flags alterations to build documentation before base/autogsdoc is
	installed.
        * configure.ac: Test whether gnutls needs libgcrypt
        * Source/GSTLS.h: Use test
        * Source/GSTLS.m: Use test
        * configure: regenerate

2014-06-26 Riccardo Mottola <rm@gnu.org>

	* Headers/GNUstepBase/GSTypeEncoding.h
	* Headers/GNUstepBase/GSVersionMacros.h
	Substitute #import with #include so that the header can be used in
	a pure C file without gcc warnings.

2014-06-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSSocketPortNameServer.m:
	* Source/NSMessagePortNameServer.m:
	Maps of ports to names modified to treat the ports as non owned
	pointers rather than non retained objects ... so we simply do
	pointer comparisons (faster and also safer if we are removing
	a port which is being deallocated).

2014-06-20  Richard Frith-Macdonald <rfm@gnu.org>

        * configure.ac: Temporarily add -O0 to turn off optimisation while
        checking for the need for shorts to be word-aligned ... should fix
        the case where the optimiser breaks the test by 'correcting' the
        misaligned access.
        * configure: regenerate

2014-06-19 Riccardo Mottola <rm@gnu.org>

	* Source/common.h
	Include and do not import pure-C header, guard against re-inclusion

2014-06-18 Riccardo Mottola <rm@gnu.org>

	* Source/unix/NSStream.m
	Add missing includes (in correct order) for open() on most OS,
	including Solaris.

2014-06-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/Unicode.m: Fix buffer overrun.
	* Source/GSString.m: Fix uninitialised variable.
	Cure for bug #42483

2014-05-28  Manuel Guesdon <mguesdon@orange-concept.com>
	* Source/NSUndoManager.m
	  Assert sig is not null in registerUndoWithTarget:selector:object:

2014-05-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSInvocation.h:
	* Source/NSInvocation.m:
	* Headers/Foundation/NSInvocation.h:
	* Tests/base/NSInvocation/test02.m:
	Reinstate lost code for NS_MESSAGE and NS_INVOCATION macros

2014-05-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSHTTPURLHandle.m:
	* Source/NSURLProtocol.m:
	When creating the 'Host' header, omit the port part if the scheme is
	http/https and the port is the normal 80/443.  A workaround for buggy
	software which doesn't understand the spec saying that the port is
	'optional', not 'omitted' in these cases.

2014-05-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDebug.m:
	* Headers/Foundation/NSDebug.h:
	Add GSDebugAllocationRecordObjects()
	and deprecate GSDebugAllocationActiveRecordingObjects()
	so we can turn individual object tracking on and off.
	Move documentation from source to header.

2014-05-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gdomap.m: Fix ifdefs for MINGW to avoid fork relatred code.

2014-05-05  Ivan Vucica <ivan@vucica.net>

	* GNUmakefile: gnustep-make's Master/deb.make now included.
	* Tests/GNUmakefile: gnustep-tests --clean is now permitted to
	fail. This helps in case 'make {dist,}clean' is called by some
	automation.

2014-05-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSSocketStream.m: Set initial state of accepted incoming
	connection streams to be open (otherwise we can't close them).

2014-04-26  Manuel Guesdon <mguesdon@orange-concept.com>
	* Source/NSKeyValueCoding.m
	  Fix exception msg in setValue:forUndefinedKey:

2014-04-18  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSHost.h:
	* Source/NSHost.m:
	Add OSX 10.6 -localizedName method.

2014-04-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSRegularExpression.m: Check for bad range from ICU and
	flag an internal error if we see it; mimic OSX behavior when a
	range limited match fails.

2014-04-11  Fred Kiefer <fredkiefer@gmx.de>

	* Headers/Foundation/NSXMLNodeOptions.h: Add new 10.7 options.
	* Source/NSXMLDocument.m: Use XML_PARSE_NONET as the default
	option for xmlReadMemory. Add XML_PARSE_NOENT when
	NSXMLNodeLoadExternalEntitiesNever is set.

2014-03-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSXMLParser.m: If parsing something which contains data
	which can't be utf-8, generate a parse error.

2014-03-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSConnection.m: handle invalidation of connection while
	getting root proxy.

2014-03-26 Riccardo Mottola <rm@gnu.org>

	* Source/NSProcessInfo.m (determineOperatingSystem):
	uname() on solaris may return a positive value on success, not just 0

2014-03-25  Fred Kiefer <fredkiefer@gmx.de>

	* Tools/NSOperation.m: ([_finish]) fix logic of 'executing' flag.

2014-03-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gdomap.c: Don't open syslog connection until after we have
	forked and closed old descriptors .. fix for bug #41751
	* Headers/Foundation/NSData.h:
	* Source/NSData.m:
	* Source/NSString.m:
	Fix for bug #41626
	* Source/Additions/GSObjCRuntime.m: patch by Mathias Bauer
	for bool encoding/decoding.

2014-03-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m:
	When generating document with a header containing adjacent non-ascii
	words which need to be encoded, omit the space between those words
	for consistency with the change on Fe 3rd.

2014-02-18  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSDateFormatter.m
	(-initWithDateFormat:allowNaturalLanguage:):
	Use method -setDateFormat: to get correct behaviour.
	* Source/NSDateFormatter.m (-setDateFormat:):
	Use ASSIGNCOPY for _dateFormat.

2014-02-14  Quentin Mathe <quentin.mathe@gmail.com>

	* Headers/Foundation/NSNotification.h
	* Source/NSNotificationCenter.m
	(-addObserverForName:selector:queue:usingBlock:):
	Added new Mac OS X 10.6 method.

2014-02-14  Quentin Mathe <quentin.mathe@gmail.com>

	* Headers/Foundation/NSSortDescriptor.h
	* Source/Foundation/NSSortDescriptor.m
	(+sortDescriptorWithKey:ascending:selector:,
	+sortDescriptorWithKey:ascending,
	-[NSSet sortedArrayUsingDescriptors:]): Added missing Mac OS X 10.6
	methods.

2014-02-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSFormat.m: Fix to cope with cases where a format specifies
	a field width larger than can reasonably fit on the strack ... use
	the heap.

2014-02-13  Larry Campbell <lcampbel@akamai.com>

	* Source/NSCalendarDate.m: Fixup millisecond formatting to match OSX

2014-02-12  Quentin Mathe <quentin.mathe@gmail.com>

	* Tools/gsdoc-1_0_4.dtd: Added new DTD version that declares 'package'
	visibility as a valid ivar qualifier.
	* Tools/AGSParser.m: Added 'package' visibility parsing.
	* Tools/AGSOutput.m:
	* Tools/autogsdoc.m:
	* Tools/GNUmakefile.m:
	Updated to refer to the latest DTD version.

2014-02-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: Fix standardising a path to use unix separators
	consistently with appending a pathc component ... paths should be
	(as far as possible) portable, and the filesystem representation
	methods convert to backslashes as necessary on windows anyway.

2014-02-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m:
	* Headers/GNUstepBase/GSMime.h:
	Add support for stripping white space between encoded words (RFC2047)

2014-02-02 Yavor Doganov  <yavor@gnu.org>

	* configure.ac: Force use for fake main on kfreebsd to work around bug
	handling large number of arguments.
	* Documentation/coding-standards.texi:
	* Documentation/manual/manual.texi:
	* Tools/cvtenc.1:
	* Tools/pldes.1:
	* Tools/defaults.1:
	* Tools/autogsdoc.1:
	* Tools/gdomap.8:
	Minor cosmetic tweaks

2014-02-02 Riccardo Mottola <rm@gnu.org>

	* Source/NSString.m (stringByResolvingSymlinksInPath)
	On GLIBC and FreeBSD use sysconf(_SC_SYMLOOP_MAX) instead of just
	MAXSYMLINKS. For HURD this is necessary, since the latter is not
	defined.

2014-01-31  Marcus Mueller <znek@mulle-kybernetik.com>

	* Source/NSUserNotification.m:
	Implemented repetitions, moved "presented" flagging to the appropriate
	method (subclassers may have different opinions about presentation,
	i.e. gnustep-gui might want to prevent presentation if application
	is already frontmost [the OSX behavior]). Improved -description
	(similar to OSX's output, eases cross-platform debugging).
	* Headers/Foundation/Foundation.h:
	added NSUserNotification.h

2014-01-30  Marcus Mueller <znek@mulle-kybernetik.com>

	* Headers/Foundation/NSUserNotification.h:
	* Source/NSUserNotification.m:
	Added default implementation which provides infrastructure but no real
	transport mechanisms. An implementation utilizing DBus
	(Desktop Notifications Specification) is provided via DBusKit.

2014-01-26  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/Foundation/NSKeyValueObserving.h,
	* Source/NSKeyValueObserving.m: Add method
	-keyPathsForValuesAffectingValueForKey:.

2014-01-25  Frederik <ego@frederikseiffert.de>

	* Source/NSKeyValueObserving.m: When using
	(NSKeyValueObservingOptionInitial | NSKeyValueObservingOptionNew)
	as option for observeValueForKeyPath:ofObject:change:context:,
	we should use -valueForKeyPath: instead of -valueForKey: to retrieve
	the current (initial) value.

2014-01-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSFFCallInvocation.m:
	* Source/GSFFIInvocation.m:
	* Source/Additions/GSTypeEncoding.c:
	* Headers/GNUstepBase/GSIArray.h:
	* Headers/GNUstepBase/GSTypeEncoding.h:
	* Headers/GNUstepBase/GSIMap.h:
	Fixup to use GS_STATIC_INLINE consistently.
	* Tools/autogsdoc.m:
	Set up default work map for public macros whose use in headers
	would otherwise confuse documentation generation.

2014-01-21  Pirmin Braun <pb@intars.de>

	* Source/NSDecimal.m: Fix for rounding precision.

2014-01-20  Quentin Mathe <quentin.mathe@gmail.com>

	* Source/NSSet.m: Added missing ([-valueForKey:]) method.

2014-01-20  Quentin Mathe <quentin.mathe@gmail.com>

	* Source/NSKeyValueMutableArray.m:
	* Source/NSKeyValueMutableSet.m:
	Don't post KVO notifications if +automaticallyNotifiesObserversForKey:
	returns NO, this ensures we match Cocoa behavior.

2014-01-18  Quentin Mathe <quentin.mathe@gmail.com>

	* Source/NSObject.m (-respondsToSelector,
	+instancesRespondToSelector:): Fixed to check +resolveInstanceMethod:
	and +resolveClassMethod: as documented in Cocoa NSObject API.

2014-01-16  Niels Grewe <niels.grewe@halbordnung.de>

	* Source/NSScanner.m: Implement -scanInteger: by conditionally
	calling -scanInt: or -scanLongLong: based on the pointer size
	detected at configure time.

2014-01-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSKeyValueObserving.m:
	Path info lifetime fixups to avoid crashes of the kind reported
	by Mathias Bauer <mathias_bauer@gmx.net>

2014-01-14  Lubos Dolezel <lubos@dolezel.info>
	* Source/NSBundle.m:
	* Headers/Foundation/NSBundle.h: add -resourceURL

2014-01-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPathUtilities.m:
	* Documentation/Base.gsdoc:
	Add GNUSTEP_DEVELOPER_DIR to allow definition of the native path
	to the msys/mingw development tools on windows.
	Also improve/fix lookup heuristics.

2014-01-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: Revert last change to get -isAbsolutePath working
	on mingw again ... need to analyse startup problem.

2014-01-13  Marcus Mueller <znek@mulle-kybernetik.com>

	* Source/NSString.m: absolute paths on __MINGW__ can also start
	with "/" if GSPathHandlingRight() is YES, otherwise GNUstep config
	paths can't be used during startup.

2014-01-11  Marcus Mueller <znek@mulle-kybernetik.com>

	* Source/GSMDNSNetServices.m: minor fixes - does now properly compile
	on Windows, too.
	NOTE:
	If you want to link against Apple's Bonjour SDK on Windows, you have
	to convert the dnssd.lib from MSVC/__stdcall format to GCC/__cdecl
	and provide the result as libdns_sd.a. Also, DNSSD_API in dns_sd.h
	needs to be defined empty.

2014-01-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPathUtilities.m: The NSDeveloperDirectory key is deprecated
	on OSX, but lets use it for the development system root.
	On windows systems this should be the native windows path at which
	the msys system is installed, found relative to the current process
	if possible, but otherwise with the GNUstep packages installed,
	found relative to the package installation directory.
	In other cases (no specific development environment found) the
	system root directory is returned.

2014-01-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m:
	On mingw a file is executable if its extension is in the list
	provided by the PATHEXT environment variable.
	* Source/NSTask.m:
	Simplification/clarification suggested by Riccardo

2014-01-08  Quentin Mathe <quentin.mathe@gmail.com>

	* Source/NSValueTransformer (+valueTransformerForName:): Fixed to
	automatically register any available NSValueTransformer subclass that
	matches  the given name and is not yet registered. This behavior is
	described in the Cocoa API documentation.

2014-01-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUUID.m:
	* Source/Additions/NSData+GNUstepBase.m:
	* Headers/GNUstepBase/NSData+GNUstepBase.h:
	Move random data generation out to the NSData(GNUstepBase) category.

2014-01-07  Quentin Mathe <quentin.mathe@gmail.com>

	* Source/NSJSONSerialization.m (writeObject()): Fixed double number
	serialization to encode 17 significant digits (this matches the max
        number of significant digits in the double-precision floating point
        format). This prevents a loss of precision, in case the number has
        more than 3 digits after the decimal point.
	* Tests/base/NSJSONSerialization/json.m: Updated to test double number
	serialization.

2014-01-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSOperation.m: Make sure current queue is set for threads
	owned by a queue (and return the main queue for the main thread).
	Avoid needing to create the main queue in the main thread.

2014-01-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Fixed logic error in David's libobjc2 integration
	for deallocation; should use object_getClass() if the object is NOT a
	small object, use isa otherwise.

2013-12-31  Marcus Mueller <znek@mulle-kybernetik.com>

	* Headers/Foundation/NSMetadata.h: use GS_PROTOCOLS_HAVE_OPTIONAL for
	NSMetadataQueryDelegate. Always define the protocol, even if it's empty
	(so we don't have to adjust any headers), but fallback to the informal
	protocol if OS version < 10.6 OR compiler doesn't support @optional
	keyword in protocols.

2013-12-30  Marcus Mueller <znek@mulle-kybernetik.com>

	* Headers/GNUstepBase/GSVersionMacros.h: added macros
	GS_GCC_MINREQ(maj,min) and GS_CLANG_MINREQ(maj,min) to check for
	minimum required versions of GCC and CLANG compilers. Changed several
	occurrences of previous macros to improve readability.
	Added GS_PROTOCOLS_HAVE_OPTIONAL to correctly mark all appropriate
	declarations.
	* Headers/Foundation/NSNetServices.h,
	* Headers/Foundation/NSStream.h,
	* Headers/Foundation/NSXMLParser.h,
	* Headers/GNUstepBase/NSNetServices+GNUstepBase.h,
	* Source/GSNetServices.h:
	use GS_PROTOCOLS_HAVE_OPTIONAL macro where appropriate

2013-12-26  Marcus Mueller <znek@mulle-kybernetik.com>

	* Headers/Foundation/NSNetServices.h:
	* Source/GSAvahiNetService.m:
          added NSNetServiceListenForConnections option (introduced in
	  OSX 10.9) and accompanying delegate method, currently implemented in
	  GSAvahiNetService.m only.
	* Headers/Foundation/NSStream.h: fixed typo (_clang_ -> __clang__)

2013-12-24  Richard Frith-Macdonald <rfm@gnu.org>

        * Version: make ready for 1.24.6 release
        * Documentation/news.texi: 1.24.6 news
        * Documentation/ReleaseNotes.gsdoc: 1.24.6 release notes

2013-12-20 Graham Lee <graham@iamleeg.com>

	* Headers/Foundation/NSUUID.h:
	* Source/NSUUID.m: implemented for unix
	* Tests/base/NSUUID: testcases

2013-12-20 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: initialise defaults system at end of NSObject
	initialisation, in the hope of preventing deadlocks if the +initialize
	methods of other classes in different threads try to use defaults.
	May fix #39125

2013-12-20  Marcus Müller <znek@mulle-kybernetik.com>

	* Headers/Foundation/NSStream.h: OSX compatibilityy ... use formal
	protocol if possible (bug #40925).
	* Headers/GNUstepBase/GSVersionMacros.h: OSX 10.9 define added.
	* Headers/Foundation/NSRunLoop.h:
	* Source/NSRunLoop.m: Implement ([+mainRunLoop])

2013-12-13  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/Foundation/NSArray.h,
	* Source/NSArray.m: Move -setValue:forKey: from NSMutableArray to
	NSArray.
	Patch by Marcian Lytwyn <marcian.lytwyn@advcsi.com>.

2013-12-07  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Source/Additions/Unicode.m (GSPrivateDefaultCStringEncoding):
	Use correct feature test for presence of ucnv functions.

2013-12-05  Quentin Mathe <quentin.mathe@gmail.com>

	* Headers/Foundation/NSDictionary.h:
	* Source/NSDictionary.m:
	* Source/Additions/GCDictionary.m:
	* Source/Additions/GSInsensitiveDictionary.m:
	* Source/GSDictionary.m:
	Changed keys argument type to (const id <NSCopying>[]) in
	-initWithObjects:forKeys:count: and
	+dictionaryWithObjects:forKeys:count:,
	to follow the current Cocoa API.

2013-12-04 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSURLCredential.m: ([-isEqual:]) needs to take the password
	and persistence into account, not just the username.

2013-11-29 Riccardo Mottola <rm@gnu.org>

	* Headers/ObjectiveC2/objc/runtime.h
	* Headers/Foundation/NSObjCRuntime.h
	Insert some kludge for PTR stuff on systems with fake C99
	compatible headers.

2013-11-26 Riccardo Mottola <rm@gnu.org>

	* Headers/GNUstepBase/GSConfig.h.in
	* configure.ac
	Detect broken PTR limits (notably solaris 8) and provide replacements

	* configure
	regenerated

2013-11-25 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GNUstepBase/GSConfig.h.in: temporarily redefine BOOL while
	including windows headers, so we don't get conflict between windows
	and objc booleans.
	* base.make.in:
	Add to CONFIG_SYSTEM_LIBS, CONFIG_SYSTEM_LIB_DIR, CONFIG_SYSTEM_INCL
	So that the libraries/headers used to build base are available for
	software using base.

2013-11-22 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSTLS.m:
	Set errno to EAGAIN if TLS layer fails in a non-fatal way during
	read/write.
	Add more/better debug logging.

2013-11-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: Fix for bug 40620
	Prevent recursion while parsing process arguments.

2013-11-19  Saso Kiselkov <skiselkov>

	Releasing a GSTLSHandle (created from +[NSFileHandle sslClass]) after
	the TLS handshake will result in a segfault. Fix it.

2013-11-18  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Headers/GNUstepBase/NSCalendarDate+GNUstepBase.m:
	* Source/Additions/NSCalendarDate+GNUstepBase.m:
	Add -isoYear method for compatibility with -weekOfYear

2013-11-07 Riccardo Mottola <rm@gnu.org>

	* Source/GSFormat.m
	* Source/NSException.m
	* Source/NSConnection.m
	Openbsd malloc.h warning fix.

2013-11-05 German Arias <germanandre@gmx.es>

	* Source/NSUndoManager.m (-undoActionName): Try first with the name
	of current group. If not, with the name of last object in undo stack.

2013-11-03 German Arias <germanandre@gmx.es>

	* Source/NSUndoManager.m (-redoMenuTitleForUndoActionName:):
	* Source/NSUndoManager.m (-undoMenuTitleForUndoActionName:):
	Return "Redo" and "Undo", respectively, if actionName is null.
	If not, it removes the item title.

2013-11-01  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/GSAttributedString.m: Use exact equality test when removing
        attribute dictionary from cache.  Prevents possibly removing the
        wrong dictionary in cases where dictionary contents are mutated
        while in the cache, such that two dictionaries become equal.

2013-10-30  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/GSDictionary.m: Add private class GSCachedDictionary which
        will raise an exception if deallocated without being uncached.
        * Source/GSAttributedString.m: Use GSCachedDictionary for attributes
        to aid in detection of things improperly releasing them.

2013-10-29  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/GSAttributedString.m:
        Simplify dictionary caching code and add check to ensure we don't
        uncache a dictionary which isn't cached.

2012-10-29  Riccardo Mottola <rm@gnu.org>

        * configure.ac:
        * Headers/GNUstepBase/GSConfig.h.in:
        * Headers/GNUstepBase/GSTypeEncoding.h:
        * Headers/GNUstepBase/GNUstep.h:
        * Headers/Foundation/NSString.h:
        * Headers/Foundation/NSObjCRuntime.h:
        * configure: regenerate
        Use inttypes.h rather than stdint.h as it's more inclusive and works
        on Solaris where some defines are in the wrong place.

2013-10-29  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSTimeZone.m: Implement -hash as the hash of the time zone
        name so that we can find equal timezones in a set/dictionary as we
        should, rather than onlyn finding identical time zones.

2013-10-28  Richard Frith-Macdonald <rfm@gnu.org>

        * Tools/AGSParser.m: Add code to ignore NS_FORMAT_ARGUMENT and
        NS_FORMAT_FUNCTION macros inside variable declarations.

2013-10-27  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/GSFileHandle.m: Fix retention of singletons and add exception
        if an attempt is made to release too many times.
        * Tools/make_strings/make_strings.m: fix minor coding standard errrors.
        * Tests/base/NSFileHandle/basic.m:
        * Tests/base/NSFileHandle/singleton.m:
        Correct faulty tests.
        * Source/NSPredicate.m: ([_evaluateLeftValue:rightValue:object:])
        Add missing check for NSNotEqualToPredicateOperatorType spotted by Fred

2013-10-26  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSPredicate.m: ([_evaluateLeftValue:rightValue:object:])
        should return either YES or NO in all cases.

2013-10-25  Richard Frith-Macdonald <rfm@gnu.org>

        * Tools/make_strings/StringsFile.m:
        Fix bogus space after semicolon.

2013-10-25  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/GSSocketStream.m:
        * Source/GSTLS.m:
        Attempt to better handle TLS handshake failure.

2013-10-24  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/GSHTTPURLHandle.m:
        Close socket immediately on SSL handlshake failure, rather than
        waiting for cleanup on dealloc.

2013-10-18  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSPredicate.m: Fix faulty casts of immutable array to mutable.

2013-10-17  Eric Wasylishen <ewasylishen@gmail.com>

	* Source/NSException.m:
	* Headers/Foundation/NSThread.h: Add trivial implementation of
	+[NSThread callStackSymbols] that uses GSStackTrace.

2013-10-15  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/Foundation/NSDate.h,
	* Source/NSDate.m:
	Add 10.6 class method dateWithTimeInterval:sinceDate:
	Patch by Marcian Lytwyn <marcian.lytwyn@advcsi.com>

2013-10-04  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSTimeZone.m: Fix bug with byte swapping ... use NSByteOrder.h

2013-10-01  Richard Frith-Macdonald <rfm@gnu.org>

        * config/config.align.c: Try to more reliably detect whether word
        alignment is needed.
        * Source/NSUserDefaults.m: Fix failure to send notification when
        defaults are updated.

2013-09-18  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/GSTLS.h:
        * Source/GSTLS.m:
        * Source/NSFileHandle.m:
        * Headers/Foundation/NSFileHandle.h:
        Add mechanism to set the contents of TLS certificate and key files
        in memory rather than reading from disk.  Expose TLS property keys
        in the NSFileHandle header to allow more control over certificates.

2013-09-10  Richard Frith-Macdonald <rfm@gnu.org>

        * configure.ac: Check for another unicode header
        * Headers/GNUstepBase/config.h.in: regenerate
        * configure: regenerate
        * Source/Additions/Unicode.m: If ICU is available, use it to obtain
        default C-string encoding.

2013-09-09  Pirmin Braun <pb@intars.de>

        * Source/Additions/GSMime.m: When creating a child parser, pass on
        the flag to say we are parsing HTTP rather than MIME.

2013-09-09  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/Additions/GSMime.m: Add comments and a further fallback
        mechanism for parsing HTTP when the default encoding is set.
        * Source/NSUnarchiver.m: Fix integer size values to use constants
        from stdint.h

2013-09-06  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSUserDefaults.m: Update cache when we synchronise a new
        domain to disk (was only updating on changes to existing domains).
        Should fix bug #39300

2013-08-30  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/GNUstepBase/GSVersionMacros.h: Fix usage of __APPLE__ macro.
	Patch by Graham Lee <iamleeg@gmail.com>

2013-08-22  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSScanner.m: GSScanDouble() permit overlong mantissa (more
        digits than can be represented in a double) and ignore excess digits
        for compatibility with OSX.  Inspired by testplant branch r37004
        which tries to allow more digits at the cost of breaking parsing
        in locales where the decimal point is a comma rather than a dot.

2013-08-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSIndexPath.m:
	* Source/NSMapTable.m:
	* Source/NSSocketPortNameServer.m:
	* Source/GSLocale.m:
	* Source/NSNetServices.m:
	* Source/NSTimeZone.m:
	* Source/NSHashTable.m:
	* Source/GSSocketStream.m:
	* Source/NSValueTransformer.m:
	* Source/NSBundle.m:
	* Source/NSURLHandle.m:
	* Source/NSPropertyList.m:
	* Source/NSAffineTransform.m:
	* Source/NSPathUtilities.m:
	* Source/NSScanner.m:
	* Source/NSDistributedNotificationCenter.m:
	* Source/NSProcessInfo.m:
	* Source/NSNotificationQueue.m:
	* Source/NSSocketPort.m:
	* Source/NSAttributedString.m:
	* Source/NSRunLoop.m:
	* Source/NSOperation.m:
	* Source/NSObject+NSComparisonMethods.m:
	* Source/NSFormatter.m:
	* Source/NSUserDefaults.m:
	* Source/NSArray.m:
	* Source/NSMessagePortNameServer.m:
	* Source/GSStream.m:
	* Source/NSKeyedArchiver.m:
	* Source/NSDebug.m:
	* Source/NSXMLPrivate.h:
	* Source/NSKeyedUnarchiver.m:
	* Source/NSPortMessage.m:
	* Source/NSFileHandle.m:
	* Source/NSDistributedLock.m:
	* Source/GSTLS.m:
	* Source/NSPredicate.m:
	* Source/NSKeyValueObserving.m:
	* Source/NSAssertionHandler.m:
	* Source/GSHTTPURLHandle.m:
	* Source/GSDispatch.h:
	* Source/NSPort.m:
	* Source/NSSortDescriptor.m:
	* Source/NSMessagePort.m:
	* Source/win32/NSMessagePort.m:
	* Source/win32/NSMessagePortNameServer.m:
	* Source/NSInvocation.m:
	* Source/NSFileManager.m:
	* Source/common.h:
	* Source/NSURLProtocol.m:
	* Source/NSURLCache.m:
	* Source/NSNotificationCenter.m:
	* Source/GSAttributedString.m:
	* Source/externs.m:
	* Source/NSCoder.m:
	* Source/NSHTTPCookieStorage.m:
	* Source/NSURL.m:
	* Source/NSString.m:
	* Source/NSObject.m:
	* Source/NSDecimalNumber.m:
	* Source/NSConcreteMapTable.m:
	* Source/NSPointerFunctions.m:
	* Source/GSSorting.h:
	* Source/NSPointerArray.m:
	* Source/Additions/GCObject.m:
	* Source/Additions/GSMime.m:
	* Source/Additions/NSObject+GNUstepBase.m:
	* Source/Additions/GSXML.m:
	* Source/Additions/GSObjCRuntime.m:
	* Source/NSNotification.m:
	* Source/NSNumber.m:
	* Source/GSTimSort.m:
	* Source/NSConnection.m:
	* Source/GSString.m:
	* Source/NSHTTPCookie.m:
	* Source/NSData.m:
	* Source/NSHost.m:
	* Source/NSDate.m:
	* Source/NSMetadata.m:
	* Source/NSDictionary.m:
	* Source/GSMDNSNetServices.m:
	* Source/GSHTTPAuthentication.m:
	* Source/NSClassDescription.m:
	* Source/NSSerializer.m:
	* Source/NSNull.m:
	* Source/NSValue.m:
	* Source/NSCountedSet.m:
	* Source/GSFileHandle.h:
	* Source/GSFileHandle.m:
	* Source/NSLock.m:
	* Source/NSSet.m:
	* Source/NSLocale.m:
	* Source/NSTask.m:
	* Source/NSJSONSerialization.m:
	* Source/NSCharacterSet.m:
	* Source/NSPortNameServer.m:
	* Source/NSXMLParser.m:
	* Source/NSConcreteHashTable.m:
	* Source/NSTextCheckingResult.m:
	* Source/NSEnumerator.m:
	* Source/GSFTPURLHandle.m:
        Improve atExit/leak handling to be executed with a thread and an
        autorelease pool in place.
        Record as deliberately 'leaked', objects created in +initialize
        methods and intended to persist until exit.
        Fix a couple of bugs exposed by turning on clean up of leaked objects.

2013-08-14  Lubos Dolezel <lubos@dolezel.info>

	* Source/NSBundle.m: add NSBundle pathForAuxiliaryExecutable: and
	-privateFrameworksPath and their URL counterparts
	* Headers/GNUstepBase/GSBlocks.h: Fixed the DEFINE_BLOCK_TYPE macro
	for certain GCC versions

2013-08-12  Richard Frith-Macdonald <rfm@gnu.org>

        * Headers/Foundation/NSThread.h:
        * Source/NSThread.m:
        Added ([-performSelectorInBackground:withObject:]) convenience method
        from OSX 10.5

2013-08-10  Ivan Vucica <ivan@vucica.net>

	* Source/NSPathUtilities.m:
	Disabled check for secure temporary directories under Cygwin. Refer
	to:
	  http://stackoverflow.com/q/9561759/39974
	for a possible cause of problems.

	* Source/objc-load.m:
	Codepaths used for MinGW are now also used for Cygwin. Even in
	case of some functionality that should be standard under UNIX systems,
	it turns out that this functionality is, sadly, not present under
	Cygwin (e.g. dladdr()).

2013-08-10  Lubos Dolezel <lubos@dolezel.info>

	* Source/NSBundle.m: add NSBundle bundleURL, builtInPlugInsURL,
	executableURL

2013-07-26  Richard Frith-Macdonald <rfm@gnu.org>

        * Version: make ready for 1.24.5 release
        * Documentation/news.texi: 1.24.5 news
        * Documentation/ReleaseNotes.gsdoc: 1.24.5 release notes
        * NSTimeZones/NSTimeZones.tar: new timezone data
        * Source/NSTimeZone.m: fix error in zone directory name

2013-07-14  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* config/objc-common.g: Add +initialize to fake NSObject class
	when compiling with the Apple runtime, since it expects	that
	method to be defined.

2013-07-11  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Headers/GNUstepBase/GSVersionMacros.h: Fix definition of
	GS_OSX_ADJUST, which got things backward (converting a GNUstep
	style version into an OS X version instead of the other way
	around). Also make sure that MAC_OS_X_VERSION_MAX_ALLOWED gets
	converted when used in the definition of GS_OPENSTEP_V.

2013-07-09  Graham Lee <iamleeg@gmail.com>

        * Source/GNUmakefile:
        * Source/NSInvocationOperation.m:
        * Headers/Foundation/Foundation.h:
        * Headers/Foundation/NSInvocationOperation.h:
        New invocation operation class

2013-07-09  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/GSTLS.m: Fix memory leak (credentials)

2013-07-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/GNUstepBase/GSVersionMacros.h:
        Re-add define to set MAC_OS_X_VERSION_MAX_ALLOWED for OSX compatibility.

2013-07-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/cifframe.m: Fix possible incorrect free of non-malloc'ed
	memory.
	* Source/NSHost.m: fix uninitialised data warning
	* Source/NSMethodSignature.m: fix uninitialised variable
	* Source/NSPropertyList.m: avoid static analyser warning
	* Tools/gdomap.c: fix uninitialised data warning
	* Source/NSObject.m: fixup error in alignment calculation;
	was assuming that the alignment of a double would do but that's
	not good enough. On GCC we use the __BIGGEST_ALIGNMENT__ used on
	the machine, but clang has no support for that, so if it's not
	defined we now guess 16 rather than __alignof__(double).

2013-07-05  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSObject.m: Fix error creating instasnce when using the
        objc2 runtime and garbage collection.
        * Source/ObjectiveC2/runtime.c: implement class_createInstance()
        by calling NSAllocateObject() .. perhaps it should be the other
        way round though.
        configure.ac: Fix directory order error.
        configure: regenerate

2013-07-05  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/GNUstepBase/GSTypeEncoding.h
	Include objc.h otherwise __GNU_LIBOBJC__ isn't defined.

2013-07-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSSocksParser/GSSocksParser.h:
	* Source/GSSocksParser/GSSocksParserPrivate.m:
	* Source/GSSocksParser/GSSocks4Parser.m:
	* Source/GSSocksParser/GSSocks5Parser.m:
	More portability fixes ... this time for mswindows.

2013-07-04  Ibadinov Marat <ibadinov@me.com>

        * GSSocksParser/GSSocks5Parser.m:
        * GSSocksParser/GSSocks5Parser.h:
        * GSSocksParser/GSSocksParserPrivate.h:
        * GSSocksParser/GSSocksParser.m:
        * GSSocksParser/GSSocksParserPrivate.m:
        * GSSocksParser/GSSocksParser.h:
        * GSSocksParser/GSSocks4Parser.m:
        * GSSocksParser/GSSocks4Parser.h:
        Parsing code for SOCKS versions 4 and 5.

2013-07-03  Sebastian Reitenbach <sebastia@l00-bugdead-prods.de>

	* Source/Additions/GSMime.m

2013-07-03  Ibadinov Marat <ibadinov@me.com>

        * Source/Additions/GNUmakefile:
        * Headers/GNUstepBase/GSTypeEncoding.c:
        * Headers/GNUstepBase/GSTypeEncoding.h:
        New type encoding parser.

2013-07-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSException.h:
	* Headers/Foundation/NSObjCRuntime.h:
	* Headers/Foundation/NSString.h:
	* Headers/GNUstepBase/GSVersionMacros.h:
	* Headers/GNUstepBase/NSString+GNUstepBase.h:
	* Source/Additions/GCArray.m:
	* Source/Additions/GSMime.m:
	* Source/Additions/GSXML.m:
	* Source/Additions/NSObject+GNUstepBase.m:
	* Source/GSArray.m:
	* Source/GSHTTPURLHandle.m:
	* Source/GSNetServices.h:
	* Source/GSSocketStream.m:
	* Source/GSStream.m:
	* Source/GSString.m:
	* Source/GSTLS.m:
	* Source/NSAssertionHandler.m:
	* Source/NSCalendarDate.m:
	* Source/NSCallBacks.m:
	* Source/NSConnection.m:
	* Source/NSData.m:
	* Source/NSFileManager.m:
	* Source/NSIndexPath.m:
	* Source/NSIndexSet.m:
	* Source/NSJSONSerialization.m:
	* Source/NSKeyValueCoding.m:
	* Source/NSKeyedUnarchiver.m:
	* Source/NSLog.m:
	* Source/NSMessagePort.m:
	* Source/NSNetServices.m:
	* Source/NSNumber.m:
	* Source/NSObject.m:
	* Source/NSOperation.m:
	* Source/NSPointerArray.m:
	* Source/NSPortCoder.m:
	* Source/NSPortMessage.m:
	* Source/NSRange.m:
	* Source/NSSocketPort.m:
	* Source/NSSortDescriptor.m:
	* Source/NSString.m:
	* Source/NSThread.m:
	* Source/NSTimeZone.m:
	* Source/NSURLResponse.m:
	* Source/NSUnarchiver.m:
	* Source/NSXMLParser.m:
	* Source/unix/GSRunLoopCtxt.m:
	* Tools/AGSParser.m:
        Fixes for errors in printf style formats, (mostly 64bit issues)
        inspired by work done by Ibadinov Marat.

2013-07-01  Richard Frith-Macdonald <rfm@gnu.org>

        * configure.ac: Add test for another libicu header
        * configure: regenerate
        * Headers/GNUstepBase/config.h.in: regenerate
        * Source/NSString.m: Add decompose/precompose methods derived from
        change in testplant branch.
        * Headers/GNUstepBase/GSVersionMacros.h: OSX compatibility tweak ...
        handle OSX style 4 digit versionn constants.
	* Headers/Foundation/NSArray.h:
	* Headers/Foundation/NSAutoreleasePool.h:
	* Headers/Foundation/NSBundle.h:
	* Headers/Foundation/NSCoder.h:
	* Headers/Foundation/NSComparisonPredicate.h:
	* Headers/Foundation/NSCompoundPredicate.h:
	* Headers/Foundation/NSConnection.h:
	* Headers/Foundation/NSData.h:
	* Headers/Foundation/NSDate.h:
	* Headers/Foundation/NSDictionary.h:
	* Headers/Foundation/NSError.h:
	* Headers/Foundation/NSException.h:
	* Headers/Foundation/NSExpression.h:
	* Headers/Foundation/NSHTTPCookie.h:
	* Headers/Foundation/NSHTTPCookieStorage.h:
	* Headers/Foundation/NSIndexPath.h:
	* Headers/Foundation/NSIndexSet.h:
	* Headers/Foundation/NSKeyValueObserving.h:
	* Headers/Foundation/NSLock.h:
	* Headers/Foundation/NSNetServices.h:
	* Headers/Foundation/NSObjCRuntime.h:
	* Headers/Foundation/NSOperation.h:
	* Headers/Foundation/NSPathUtilities.h:
	* Headers/Foundation/NSPointerArray.h:
	* Headers/Foundation/NSPointerFunctions.h:
	* Headers/Foundation/NSPredicate.h:
	* Headers/Foundation/NSProcessInfo.h:
	* Headers/Foundation/NSPropertyList.h:
	* Headers/Foundation/NSScanner.h:
	* Headers/Foundation/NSSet.h:
	* Headers/Foundation/NSSortDescriptor.h:
	* Headers/Foundation/NSSpellServer.h:
	* Headers/Foundation/NSStream.h:
	* Headers/Foundation/NSString.h:
	* Headers/Foundation/NSTimeZone.h:
	* Headers/Foundation/NSTimer.h:
	* Headers/Foundation/NSURL.h:
	* Headers/Foundation/NSURLAuthenticationChallenge.h:
	* Headers/Foundation/NSURLCache.h:
	* Headers/Foundation/NSURLConnection.h:
	* Headers/Foundation/NSURLCredential.h:
	* Headers/Foundation/NSURLCredentialStorage.h:
	* Headers/Foundation/NSURLDownload.h:
	* Headers/Foundation/NSURLError.h:
	* Headers/Foundation/NSURLProtectionSpace.h:
	* Headers/Foundation/NSURLProtocol.h:
	* Headers/Foundation/NSURLRequest.h:
	* Headers/Foundation/NSURLResponse.h:
	* Headers/Foundation/NSValueTransformer.h:
	* Headers/Foundation/NSXMLElement.h:
	* Headers/Foundation/NSXMLParser.h:
        Replace numeric version constants with OSX compatibility macros.

2013-06-27  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSConcreteMapTable.m: attempt to fix double retain bug
        introduced by clang/ARC changes.

2013-06-24  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Tools/AGSIndex.m (mergeDictionaries): Fix typo in warning.

2013-06-23  Ivan Vucica <ivan@vucica.net>

        * Source/NSFileManager.m: Fixed syntax error.

2013-06-23  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSFileManager.m: Don't attempt to set ownership of copied
        file.  The code was already doing this right for directories, but
        not for other file types.

2013-06-21 Lubos Dolezel <lubos@dolezel.info>

	* Headers/GSBlocks.h: weakly import _Block_copy and _Block_release

2013-06-08 Lubos Dolezel <lubos@dolezel.info>

	* Source/NSTimeZone.m
	  Implement nextDaylightSavingTimeTransitionAfterDate:

2013-06-06 Sebastian Reitenbach <sebastia@l00-bugdead-prods.de>

	* Source/Additions/Unicode.m
	  Headers/Foundation/NSString.h
	  revert my change from 2013-05-29
	  breaks decoding of .gorm files in NSString for me on amd64

2013-05-31  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSLock.m: ([-lockWhenCondition:beforeDate:])
        Lock mutex using -lockBeforeDate: so that we can abandon the wait
        for the condition at the spacified date in the case where we can't
        even obtain a lock before that date.
        Fix for bug #39126

2013-05-29 Sebastian Reitenbach <sebastia@l00-bugdead-prods.de>

	* Headers/Foundation/NSString.h
	  make NSStringEncoding enum typdef to NSUInteger
	* Source/Additions/Unicode.m
	  fix format string to print out NSStringEncoding

2013-05-17  Ivan Vučica <ivan@vucica.net>

	* Source/NSDate.m:
	In case NAN macro is defined in math.h, prefer that over
	using the nan() function call.

2013-05-17  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSMessagePortNameServer.m: fix error in line count check
        in last change.

2013-05-16  Ivan Vučica <ivan@vucica.net>

	* Source/GSLocale.m:
	* configure.ac:
	Added check for whether there is any useful information in
	struct lconv. Android doesn't have anything there, despite
	having locale.h, so it makes little sense to try to access
	the nonexistent fields in GSLocale.m

2013-05-16  Ivan Vučica <ivan@vucica.net>

	* configure.ac:
	* cross.config:
	When cross-compiling, obeying an additional setting for
	Objective-C 2.0 support. Fixed a missing '$' in cross.config.

2013-05-15  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSMessagePortNameServer.m: fix for bug #38981

2013-05-13  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/Foundation/NSKeyedArchiver.h,
	* Source/NSKeyedUnarchiver.m: Add method
	-replaceObject:withObject: from gui.

2013-05-13  Fred Kiefer <FredKiefer@gmx.de>

	* Tests/base/NSArchiver/stringEncoding.m: Use PASS_EQUAL instead
	of PASS.

2013-05-13  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/ObjectiveC2/runtime.c: when replacing a method, update the
        cache so we don't use the old version.
        * Source/NSNotificationCenter.m: trivial tweak to map release code
        and remove method caching for OSX compatibility :-(
        * Source/NSPropertyList.m: Fix bug byte swapping unicode in apple
        binary plist generation.
        * Tests/base/NSNotification/dynamic.m: Fix crash in testcase.

2013-05-13  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSURLConnection.m: Release delegate immediately after
        failure or succeess of communicationm (bug #38955).
        * Source/Additions/Unicode.m: Fix possible read beyond end of buf.

2013-04-24  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/GSMime.m: ([GSMimeParser-parse:]) fix possible infinite
        recursion when encountering a bad document.

2013-04-22  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/GSMime.m: Fix memory management error with excess bytes
        after parsing mime headers.

2013-04-18      Marcus Muller <znek@mulle-kybernetik.com>

        * Source/NSMetadata.m: Fix to expose variables to compiler building
        with non-fragile ABI.

2013-04-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GNUmakefile:
	* Source/unix/GNUmakefile:
	* Source/unix/NSMetadata.m:
	* Source/win32/GNUmakefile:
	* Source/win32/NSMetadata.m:
	* Source/NSMetadata.m:
	* Headers/Foundation/NSMetadata.h:
	Move identical system specific metadata code to generic area so we
	can have system specific subclasses inherit common functionality.
	Fix instance variables so we won't break binrary compatibility in
	future.

2013-04-15  Richard Frith-Macdonald <rfm@gnu.org>

	* cifframe.m:
	* GSString.m:
	* GSTLS.m:
	* NSArchiver.m:
	* NSCalendar.m:
	* NSCoder.m:
	* NSData.m:
	* NSDecimal.m:
	* NSDictionary.m:
	* NSDistantObject.m:
	* NSException.m:
	* NSFileManager.m:
	* NSHashTable.m:
	* NSIndexPath.m:
	* NSLocale.m:
	* NSMethodSignature.m:
	* NSNotificationCenter.m:
	* NSNumberFormatter.m:
	* NSObject.m:
	* NSPortCoder.m:
	* NSProcessInfo.m:
	* NSProxy.m:
	* NSRunLoop.m:
	* NSSocketPort.m:
	* NSString.m:
	* NSURL.m:
	* NSURLProtocol.m:
	* NSValue.m:
	* NSXMLDocument.m:
	* NSXMLNode.m:
	* NSXMLParser.m:
	More changes to avoid static analyzer false-positives/non-issues so we
	can see when real issues arise.  Changes remove around 60 warnings and
	include about half a dozen minor bugfixes.

2013-04-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/GNUstepBase/GSIMap.h:
	* Headers/GNUstepBase/NSObject+GNUstepBase.h:
	* Source/Additions/GSObjCRuntime.m:
	* Source/GSFormat.m:
	* Source/GSPrivate.h:
	* Source/GSString.m:
	* Source/NSBundle.m:
	* Source/NSJSONSerialization.m:
	* Source/NSKeyValueObserving.m:
	* Source/NSScanner.m:
	* Tools/gdomap.c:
	Tweaks to keep static analyser happy.

2013-04-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/GNUstepBase/GNUstep.h: NSInteger/NSUInteger cleanup.
	* Source/NSAffineTransform.m: Fix -isEqual: for subclassing.
	* Source/NSObject.m: Remove previously deprecarted function
	* Source/NSProxy.m: Avoid compiler warning
	* Source/NSDistantObject.m: Avoid compiler warning

2013-04-12  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSPortCoder.m:
        Fix bug looking up class version information.

2013-04-10  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSScanner.m: improve the algoritm for parsing double values
        (new algorithm based on public domain pseudo code).. should be more
        accurate (for bug #38640).

2013-04-08  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSNotificationCenter.m: Fix bug #38680

2013-04-05  Richard Frith-Macdonald <rfm@gnu.org>

        * config/pathtls.m4: Try to guess gnutls flags if no config found
        * configure: regenerate
        * Tools/AGSHtml.m: Fix error when title index missing.

2013-04-03  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSSocketPort.m: Improve/simplify invalidation.
        * Source/NSXMLParser.m:
        Fix (implement) parsing of entities inside quoted strings.

2013-03-28  Richard Frith-Macdonald <rfm@gnu.org>

        Make release 1.24.4
        * Documentation/ReleaseNotes.gsdoc:
        * Documentation/news.texi:
        * Headers/Foundation/NSFileManager.h:
        * Source/NSFileManager.m:
        Prepare documentation for release

2013-03-26  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSCalendar.m:
        * Headers/Foundation/NSCalendar.h:
        Rewrite NSCalendar instance variable usage to avoid breaking binary
        compatibility.  Fix methods for setting the first week day and
        the minimum number of days in the first week of a month.

2013-03-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSAffineTransform.m:
        Fix decoding of keyed archive containing identity transform.
	* Source/NSString.m:
	* Tests/base/NSString/tilde.m:
        Fix to standardize string if necessary to determine whether it has
        the home directory as a prefix.

2013-03-23  Fred Kiefer <FredKiefer@gmx.de>

        * Source/NSXMLNode.m (-XMLStringWithOptions:): Revert change I
	made on 2012-12-01.

2013-03-20  Richard Frith-Macdonald <rfm@gnu.org>

        * Tests/base/NSCalendar/features-10-7.m:
        * Source/NSCalendar.m:
        * Headers/Foundation/NSCalendar.h:
        New OSX 10.7 methods supplied by Lobos Dolezel and rewritten somewhat
        to avoid breaking binary compatibility.

2013-03-17  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/GSSet.m: Some optimisation for set intersection.

2013-03-16  Fred Kiefer <FredKiefer@gmx.de>

	* Tests/base/NSLocale/general.m,
	* Tests/base/NSTimeZone/use.m: Mark more tests that depend on
	locale setting as hopes.
	* Tests/base/GSXML/basic.m: Set the timezone of the GSXMLRPC to
	get the same date string in the output.

2012-03-16  Richard Frith-Macdonald <rfm@gnu.org>

	* NSTimeZones/NSTimeZones.tar:
	* Tools/gsdoc-1_0_0.dtd:
	* Tools/gsdoc-1_0_1.dtd:
	* Tools/gsdoc-1_0_2.dtd:
	* Tools/gsdoc-1_0_3.dtd:
	* Tools/gsdoc-0_6_5.dtd:
	* Tools/gsdoc-0_6_6.dtd:
	* Tools/gsdoc-0_6_7.dtd:
	* Tools/plist-0_9.dtd:
        Update/correct FSF address.

2012-03-16  reussandras@gmail.com

        * base/Source/NSCalendar.m:
        Add simple quarter calculation.
        * base/Source/NSPathUtilities.m:
        Fix bug handling defaults dir config (was treating absolute path
        as relative).

2012-03-16  Richard Frith-Macdonald <rfm@gnu.org>

	* NSTimeZones/NSTimeZones.tar: Update timezone information

2012-03-16  Emmanuel Maillard <mailing-lists@e-maillard.com>

        * configure.ac: checks for pthread library and password structure
        * Headers/GNUstepBase/config.h.in: new define for password field
        * Source/NSPathUtilities.m: use new define
        * configure: regenerate
        Changes for Android build

2012-03-12  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/GSPrivate.h: Change hash function args and add new functions
        * for incremental hash.
        * Source/NSString.m: Update to use the private hash function introduced
        for NSSortdescriptor.
        * Source/GSString.m: ditto.
        * Source/NSSortDescriptor.m: Update for new function arguments.
        * Source/GSPrivateHash.m: Add alternative version of hash functions
        (old code plus new public domain murmurhash3 code).
        * Source/GNUmakefile: Build alternative hash functions.
        build with OLDHASH defined to 0 to get new alternatives.

2012-03-10  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSFileManager.m:
        Fix some autorelease pool management issues.

2013-03-09 Sebastian Reitenbach <sebastia@l00-bugdead-prods.de>
	* Tests/base/NSFileManager/general.m
	  remove accidently snucked in header

2013-03-08 Sebastian Reitenbach <sebastia@l00-bugdead-prods.de>

        * Headers/Foundation/NSFileManager.h:
        * Source/NSFileManager.m:
        * Tests/base/NSFileManager/general.m:
        Implement methods forcoping/moving file URLs

2013-03-05  Larry Campbell <lcampbel@akamai.com>

        * Source/NSFileManager.m: Fix for ([-contentsEqualAtPath:andPath:])
        compare contents of regular files in subdirectories.

2013-03-05 Sebastian Reitenbach <sebastia@l00-bugdead-prods.de>

        * Source/NSFileManager.m:
        * Headers/Foundation/NSFileManager.h:
        ([createDirectoryAtURL:withIntermediateDirectories:attributes:error:])
        implemented.
        Also, for OSX compatibility, RFM 'fixed' the ...error: methods to
        leave the error value unmodified in the case where no error occurs.

2013-03-03 Sebastian Reitenbach <sebastia@l00-bugdead-prods.de>

	* Source/NSKeyValueObserving.m
	* Source/NSXMLParser.m
	  char is unsigned on macppc, so don't compare it
	  against negative values

2013-03-01  Richard Frith-Macdonald <rfm@gnu.org>

        * Version ... bump subminor number in preparation for next release.

2013-02-28  Richard Frith-Macdonald <rfm@gnu.org>

        Make release
	* Version:
	* Source/NSRegularExpression.m:
	* Source/NSURLResponse.m:
	* Source/NSString.m:
	* Source/DocMakefile:
	* Source/GSNetServices.h:
	* Documentation/news.texi:
	* Documentation/ReleaseNotes.gsdoc:
	* Headers/GNUstepBase/GSVersionMacros.h:
	* Headers/Foundation/NSNetServices.h:
	* Headers/Foundation/NSBundle.h:
	* Headers/Foundation/NSXMLDocument.h:
	* Headers/Foundation/NSXMLNode.h:
	* Headers/Foundation/NSObjCRuntime.h:
	* Headers/Foundation/NSXMLDTD.h:
	* Headers/Foundation/NSXMLDTDNode.h:
	* Headers/Foundation/NSXMLElement.h:
	* Headers/Foundation/NSXMLParser.h:
	* Tools/DocMakefile:
	* Tools/AGSParser.m:
        Bump version for new release, add release notes, clean up documentation.

2013-02-28  Richard Frith-Macdonald <rfm@gnu.org>

        * Tests/base/NSString/test00.m: Add a few tests for searching subrange
        of a string.
        * Source/GSString.m: ([rangeOfCharacterFromSet:options:range:])
        Fix for overrun when searching backwards ... spotted by Fred.

2013-02-17  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/GSAvahiRunLoopIntegration.m: Remove code which was clearing
        bitmask values needed to track whether watcher needed to be removed
        from run loop.

2013-02-16  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSURL.m: a data url ignores any base URL.
        * Source/GSAvahiClient.m: remove self from runloop on dealloc.

2013-02-15  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSPredicate.m: updates to output correct predicate format
        for binary operators.
        * Source/NSURL.m: unescape data for -relativePath

2013-02-10  Marcus Muller <znek@mulle-kybernetik.com>

        * Source/GSMDNSNetServices.m: enable whether a delegate is set or not.

2013-02-10  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSURL.m: For OSX compatibility, if we are creating a relative
        URL and the base URL has a different scheme from the base, then we
        ignore the base URL rather than raising an exception.

2013-02-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSThread.m: Fix error in check for perform on finished thread.

2013-01-24  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSCalendar.m: (-[dateByAddingComponents:toDate:options:]),
        ([-dateFromComponents:]) add support for missing components.

2013-01-22  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSPredicate.m: Fixup parsing of function expressions.

2013-01-14  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSLocale.m: ([-_getExemplarCharacterSet]) Fix error in handling
        returned range (bug #38118 reported by X Y <macgritsch>
        * Source/NSPropertyList.m: Fix encoding of date objects when using the
        OpenStep format to simply used the description of the3 date.
        Fixes bug #38017
        * Source/NSURLConnection.m: a synchronous download with no response
        body should return an empty data item rather than nil ... fix for
        bug #38043
        * Source/GSTLS.m: Log a warning message if we load a certificate
        which has expired or is not yet valid.

2013-01-14  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSString.m: ([stringByAppendingPathComponent:]) recalculate
        root of patch correctly before stripping trailing separators.

2013-01-13  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/Foundation/NSDistributedNotificationCenter.h,
	* Source/NSDistributedNotificationCenter.m: Correct the return
	types of the factory methods.

2013-01-08  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/GSString.m:
        When creating a substring (C) of a substring (B) or a string (A),
        we now retain the (A) in (C) rather than having (C) retain (B)
        which in turn retains (A).  This has the advantage that it is
        possible for the intermediate (B) to be released if nothing else
        ues it.

2013-01-05 00:49-EST Gregory John Casamento <greg.casamento@gmail.com>

	* Headers/Foundation/NSMetadata.h: Add _ to delegate.
	* Source/GNUmakefile: Remove reference to NSMetadata.m
	* Source/NSMetadata.m: Remove from here and add OS specific
	implementations.
	* Source/unix/GNUmakefile: Add new file...
	* Source/unix/NSMetadata.m: UNIX implementation...
	* Source/win32/GNUmakefile: Add new file..
	* Source/win32/NSMetadata.m: Windows implementation.

2012-12-18  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSNetServices.m: patch by Marcus Muller to correctly check
        that either the input or the output stream has been opened.
        * Source/GSString.m: patch by Stefan Bidi to optimise utf-8 to
        utf-16 conversion a little.

2012-12-12  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/GSMime.m: Fix parsing of final boundary in a multipart
        document so that the trailing '--' ends the boundary and no CRLF
        is required. The grammar in RFC1341 says that the final boundary
        does not need a CRLF terminator.

2012-12-08  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/GSTLS.m:
        * Source/NSNotificationCenter.m:
        * Source/NSPropertyList.m:
        Tweaks to avoid compiler warnings spotted by Fred.

2012-12-06  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSHTTPCookieStorage.m: Don't read store if it doesn't exist.
        * Source/GSTLS.h: Use time interval for caching
        * Source/GSTLS.m: More efficient caching

2012-12-06  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSPropertyList.m: remove a couple of useless debug logs.
        * Source/GSTLS.h: Add credentials object
        * Source/GSTLS.m: Implement caching of credentials so that they are
        shared between different sessions (eg a web server accepting multiple
        incoming connections can re-use the same credentials for each of them).
        This is to address a performance issue due to decoding certificate
        information from file to create new credentials when lots of incoming
        connections occur.

2012-12-05  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSFileHandle: ([-sslHandshakeEstablished:outgoing:])
        Set the connection into non-blocking mode so that the handshake
        will not block if the other end refuses to talk to us.

2012-12-01  Fred Kiefer <FredKiefer@gmx.de>

        * Source/NSXMLNode.m (-XMLStringWithOptions:): Use macros for
	versions of libxml2.

2012-11-28  Richard Frith-Macdonald <rfm@gnu.org>

        * configure.ac: Fixup ICU test error
        * configure: regenerate
        Change tests so that we no longer ignore it when icu-config tells
        us we have too old a version to use.

2012-11-27  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/GSHTTPURLHandle.m: Set content-length header in outgoing
        request if not already set.
	* Headers/Additions/GNUstepBase/GSMime.h:
        * Source/Additions/GSMime.m: Add methods to control line folding.

2012-11-25 14:39-EST Gregory John Casamento <greg.casamento@gmail.com>

	* Headers/Foundation/NSMetadata.h
	* Source/NSMetadata.m: Add NSMetadataQueryAttributeValueTuple and
	NSMetadataQueryResultGroup classes.

2012-11-21 12:10-EST Gregory John Casamento <greg.casamento@gmail.com>

	* Headers/Foundation/NSMetadata.h: Add ivars.
	* Source/NSMetadata.m: Cleanup compilation error.

2012-11-20 12:50-EST Gregory John Casamento <greg.casamento@gmail.com>

	* Headers/Foundation/NSMetadata.h: Declaratioins for constants and
	NSMetadataItem.
	* Source/NSMetadata.m: Implementation of NSMetadataItem and definition
	of constants.

2012-11-19 18:54-CET Ivan Vučica <ivan@vucica.net>

	* Source/GSInvocation.h: Renamed GSFrameInvocation to
	GSDummyInvocation, to match implementation in
	Source/NSInvocation.m.

2012-11-18 11:47-EST Gregory John Casamento <greg.casamento@gmail.com>

	* Headers/Foundation/NSMetadataQuery.h: Remove old file.
	* Source/GNUmakefile: Change name to NSMetadata.[hm].
	* Source/NSMetadata.m: Add new file with correct name.
	* Source/NSMetadataQuery.m: Remove old file.

2012-11-18 11:29-EST Gregory John Casamento <greg.casamento@gmail.com>

	* Headers/Foundation/Foundation.h: Add NSMetadataQuery.h to
	include list.
	* Headers/Foundation/NSMetadataQuery.h: New header for class.
	* Source/GNUmakefile: Add NSMetadataQuery.[hm] to makefile.
	* Source/NSMetadataQuery.m: Abstract implementation for
	NSMetdataQuery.  The idea is much like NSFileStream and other
	classes which have operating system specific implementations.
	On linux this will, most likely, interface with locate/slocate.
	I'm not certain what it will talk to on Win32.

2012-11-15  Quentin Mathe <quentin.mathe@gmail.com>

	* Source/NSAutoreleasePool.m (-emptyPool): Fixed not to push a pool to
	the cache in the ARC_RUNTIME implementation, -dealloc does it already.
	For the same current pool instance, the ARC_RUNTIME implementation was
	calling push_pool_to_cache() twice, once in -emptyPool and another
	-dealloc. Which meant a pool still in use could be reused, then it was
	possible to get stuck in an infinite loop.

2012-11-05  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Source/GSFFIInvocation.m (GSFFIInvocationCallback): Generate
	useful error message when no best typed selector can be found.

2012-11-02  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* configure.ac: Use AC_FUNC_STRERROR_R to check for presence and
	version of the strerror_r function.
	* Source/Additions/NSError+GNUstepBase.m (-_systemError:): Add
	conditional code for glibc specific version of strerror_r.
	* Source/common.h: No longer redefine feature test macros as this
	could invalidate the autoconf results.

	* configure:
	* Headers/GNUstepBase/config.h.in:
	* SSL/configure:
	* SSL/config.h.in: Regenerated by autoreconf.

2012-10-30  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/NSError+GNUstepBase.m:
	* Source/GSFileHandle.m:
	* Source/GSMDNSNetServices.m:
	* Source/NSMessagePort.m:
	* Source/NSSocketPort.m:
	* Source/NSSocketPortNameServer.m:
	* Source/NSThread.m:
	* Source/common.h:
        Changes to try to get inclusion of system specific features right.
        In particular, we want strerror_r() to be POSIX complient so that
        we get correct system erorr messages.

2012-10-28  Richard Frith-Macdonald <rfm@gnu.org>

        * Headers/Foundation/NSGeometry.m: Fix so that an empty rect can never
        intersect any other (including itsself).  Reported by Banly Kemiyatorn
        and Fred Kiefer.

2012-10-26  Richard Frith-Macdonald <rfm@gnu.org>

        * Instance/Documentation/texi.make:
        Fix installation/clean of html documents generated from texi files.

2012-10-25  Quentin Mathe <quentin.mathe@gmail.com>

	* Headers/GNUstepBase/GSConfig.h.in: Prevent redefinition warnings for
	__STDC_LIMIT_MACROS and __STC_CONSTANT_MACROS (both are ObjC++ related).

2012-10-22  Thomas Davie <tom.davie@gmail.com>

        * Headers/Foundation/NSSet.h:
        * Source/NSSet.m:
        Add -objectsPassingTest:

2012-10-22  Rene Hexel <rhexel+savannah@mac.com>

        * Source/Additions/GSXML.m:
        In libxml2 the content and use fields have become private and are only
        exposed through xmlBufContent() and xmlBufUse() since libxml-2.9.0.
        Use those macros for newer versions of libxml2.

2012-10-20  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSConnection.m: Use NSUInteger for array indexes/counters.

2012-10-18  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSXMLParser.m: Try to fix entity parsing bug #37596

2012-10-17  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSBundle.m:
        * Source/NSCalendarDate.m:
        * Source/NSFileManager.m:
        * Source/NSJSONSerialization.m:
        * Source/NSMessagePort.m:
        * Source/NSMessagePortNameServer.m:
        * Source/NSPropertyList.m:
        Avoid autoreleasing things in +initialize when there may be no
        autorelease pool present ... we don't want to either leak or
        cause recursive loops when we want to log any leaks.

2012-10-15  Eric Wasylishen  <ewasylishen@gmail.com>

	* Tests/base/NSArchiver/stringEncoding.m: add test for last commit

2012-10-15  Eric Wasylishen  <ewasylishen@gmail.com>

	* Source/NSPropertyList.m (-[GSBinaryPLGenerator storeString:):
	Write unicode strings in big-endian instead of little-endian.
	The resulting plists now load properly on OS X. Thanks to
	rdemet for bug report.

2012-10-15  Richard Frith-Macdonald <rfm@gnu.org>

        * Headers/Foundation/NSCharacterSet.h:
        * Source/NSCharacterSet.m:
        For a long time Apple's docs and headers said that the methods for
        returning standard charactersets returned 'NSCharacterSet*', which
        was annoying when they were called on NSMutableCharacterSet.
        It seems they finally changed to returning id, so we can do the same.

2012-10-12  Richard Frith-Macdonald <rfm@gnu.org>

        * Headers/GNUstepBase/NSDebug+GNUstepBase.h:
        Fix format of logs produced by two of the three method macros ...
        a bug spotted by Fred.

2012-10-03  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/GSFormat.m: for C-string formatting, avoid reading to the
        nul terminator ... limit to a number of bytes equal to the precision
        (if any) given in the format. This may be the wrong thing to do when
        handling multibyte encodings (where a natural expectation is to have
        precision mean number of characters), but seems legitimate going by
        current xopen printf documentation.

2012-10-03  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* SSL/GSSSLHandle.m (-sslSetOptions): Apply string name change
	missed during TLS reorganisation.

2012-09-30  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/GSSocketStream.m:
        * Source/GSTLS.m:
        * Source/GSHTTPURLHandle.m:
        * Source/NSURLProtocol.m:
        * Headers/Foundation/NSFileHandle.h:
        Add GNUstep TLS/SSL options when loading HTTPS URLs.

2012-09-26  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSUserDefaults.m: Fix error synchronising from changes in
        database ... was not sending the notification to say we had updated.
        * Headers/Foundation/NSFileHandle.h:
        * Source/GSSocketStream.m:
        * Source/GSTLS.h:
        * Source/GSTLS.m:
        * Source/NSFileHandle.m:
        More TLS reorganisation and adding diagnostics

2012-09-25  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/GNUmakefile:
        * Source/GSSocketStream.m:
        * Source/NSFileHandle.m:
        * Headers/Foundation/NSFileHandle.h:
        * SSL/GSSSLHandle.m:
        * Source/GSTLS.h:
        * Source/GSTLS.m:
        Restructure to separate some of the tls functionality out.

2012-09-24  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSBundle.m: Fix error spotted by Fred.

2012-09-24  Richard Frith-Macdonald <rfm@gnu.org>

        * Headers/Foundation/NSFileHandle.h: deprecate old method for setting
        certificate and add new one.
        * SSL/GSSSLHandle.m: Support new method and move generic code to
        NSFileHandle.m
        * Source/GSSocketStream.m: Implement NSFileHandle SSL/TLS support
        using GNUTLS.
        * Source/NSFileHandle.m: Some ssl/tls restructuring, use GNUTLS if
        available.
        * configure.ac: Don't build SSL bundle if isupport is built-in.
        * GNUmakefile: ditto
        * base.make.in: ditto ... plus fix to define setting to show whether
        ICU is avaiable.
        * configure: regenerate

2012-09-23  Niels Grewe <niels.grewe@halbordnung.de>

	* Source/GSSocketStream.m: Expose GSFileHandle ivars for compilation
	with the non-fragile ABI.
	* Headers/GNUstepBase/GSVersionMacros.h: Restore line that was
	accidentally commented out.

2012-09-23  Niels Grewe <niels.grewe@halbordnung.de>

	* Source/GSTimSort.m: Fix typo.

2012-09-21  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSArray.m:
        * Source/NSDate.m:
        * Source/NSDictionary.m:
        * Headers/Foundation/NSArray.h:
        Comment/documentation fixups to avoid warnings etc.
        * Tools/AGSParser.h:
        * Tools/AGSParser.m:
        Fix memory management error causing reference to deallocated object.

2012-09-20  Niels Grewe <niels.grewe@halbordnung.de>

	* Source/GSTimSort.m: A few more timsort bugfixes.

2012-09-20  Niels Grewe <niels.grewe@halbordnung.de>

	* Source/GSTimSort.m: Fix bugs in the timsort implementation.

2012-09-20  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/GSQuickSort.m: Fixed this to compile and (apparently) work.

2012-09-20  Richard Frith-Macdonald <rfm@gnu.org>

        * configure.ac: Change sort selection to use shellsort by default and
        to make sort selection internal to gnustep-base rather than public.
        * configure: regenerate
        * Headers/GNUstepBase/config.h.in: regenerate
        * Headers/GNUstepBase/GSConfig.h.in: Remove public sort selection info
        * Source/GSQuickSort.m: Use config.h to control build/not-build.
        * Source/NSSortDescriptor.m: Reference the selected sort class to
        ensure that it is linked in  and loaded at runtime.
        * Source/GSShellSort.m: Fix bug in function arguments.
        Use config.h to control build/not-build.
        * Source/GSSorting.h: tidied a little
        * Source/GSTimSort.m: Use config.h to control build/not-build.
        The changes are basically to keep sort information internal to
        base rather than exposing it and, more importantly, to get sorting
        working again.  This involves:
        1. minor fix to shellsort to get it to work.
        2. change configure script to select shellsort.
        The problems with the other sorts are:
        a. quicksort won't even compile
        b. timsort does compile, but segfaults when you try to give it
        real-world datasets to sort
        Anyone wantng to fix these, please do (it would be really cool
        to have timsort working).

2012-09-19  Niels Grewe <niels.grewe@halbordnung.de>
	* Source/GSSorting.h
	* Source/NSSortDescriptor.m:
	Add new generic interface for sorting.
	* Source/GSTimSort.m: Implement timsort sorting algorithm.
	* Source/GSQuickSort.m
	* Source/GSShellSort.m:
	Factor out previously used sorting algorithms.
	* Source/GSArray.m
	* Source/NSArray.m:
	Modify to use the new sorting interface for sorting using
	functions, NSSortDescriptor, and NSComparator. Implement
	NSComparator based sorting and insertion index searching
	methods.
	* Source/GNUmakefile: Connect new files to the build.
	* configure.ac: Add configure switch to allow selection of sort
	algorithm.
	* Headers/GNUstepBase/GSConfig.h.in: Add defines for sort
	algorithm selection.
	* configure: Regenerate
	* Headers/Foundation/NSObjCRuntime.h
	* Headers/Foundation/NSArray.h:
	Declarations for new NSComparator based sorting methods.
	* Tests/base/NSArray/general.m
	* Tests/base/NSArray/blocks.m:
	Add tests for new functionality.
	* Tests/base/NSArray/random.plist
	* Tests/base/NSArray/sorted.plist:
	Add sorting example data that is large enough to test more
	sophisticated sorting algorithms.

	Completely overhaul how we do sorting in -base. GSSorting.h now
	defines an interface that can be used for all sorting tasks in
	the library. The actual sort algorithms to use are now plugable.
	Timsort is the new default sorting algorithm, the existing
	algorithms, shellsort and quicksort can still be selected using
	a configure switch, but they do not override timsort completely
	because they are unstable.
	Also implement the new NSComparator (blocks) based sorting and
	insertion index searching methods for NSMutableArray and
	NSArray.

2012-09-17 12:03-EDT Gregory John Casamento <greg.casamento@gmail.com>
	Merged from the testplant branch.

	* Headers/Foundation/Foundation.h
	* Headers/Foundation/NSScriptWhoseTests.h
	* Source/GNUmakefile
	* Source/NSObject+NSComparisonMethods.m: Move the
	comparison methods to the header for NSScriptWhoseTests.h,
	but don't define the abstract class since we don't support
	Apple script.

2012-09-16  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSURL.m:
        * Tests/base/NSURL/basic.m:
        Add support for data: URL

2012-09-10  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSJSONSerialization.m:
        Fix quoting of string output by copying code from WebServices library.

2012-09-10  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSJSONSerialization.m:
        * Source/NSPropertyList.m:
        Improve serialisation of booleans.

2012-09-10  Richard Frith-Macdonald <rfm@gnu.org>

        * Headers/Foundation/NSDate.h: Declare new OSX method to add time
        interval to a date.
        * Source/NSDate.m: Implement it
        * Source/NSCalendarDate.m: Ditto
        * Source/NSRunLoop.m: Add exception handling for run loop performer.

2012-09-10  Sergii Stoian <stoyan255@gmail.com>

        * Source/NSFileManager.m:
        [createDirectoryAtPath:withIntermediateDirectories:attributes:error:]:
        Create directories only if it doesn't exist.

2012-09-09  Wolfgang Lux  <wolfgang.lux@gmail.com>

        * Source/NSPropertyList.m (-storeString): Add missing variable
        declaration on big-endian systems.

2012-09-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPropertyList.m:
        Don't ignore whitespace in keys and values when parsing XML ... the
        DTD says everything apart from array and dict contains #PCDATA.

2012-09-05  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSScanner.m: Compatibility tweak reported by hns@computer.org
        A string like '1.2eX' where X is not a numeric exponent, needs to be
        scanned as a float/double up to (but not including) the 'e' (or 'E')
        rather than being treated as a badly formatted float/double.

2012-09-04  Fred Kiefer <FredKiefer@gmx.de>

	* Tests/base/NSXMLDocument/cdata.m: New test case for CDATA.

2012-09-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSTimeZone.m:
	* Source/NSBundle.m:
	* Source/NSPropertyList.m:
	* Source/NSProcessInfo.m:
	* Source/NSSocketPort.m:
	* Source/NSRunLoop.m:
	* Source/NSMessagePortNameServer.m:
	* Source/NSDistributedLock.m:
	* Source/GSHTTPURLHandle.m:
	* Source/NSZone.m:
	* Source/NSPage.m:
	* Source/NSMessagePort.m:
	* Source/NSUnarchiver.m:
	* Source/win32/GSFileHandle.m:
	* Source/NSFileManager.m:
	* Source/common.h:
	* Source/NSString.m:
	* Source/Additions/NSData+GNUstepBase.m:
	* Source/Additions/Unicode.m:
	* Source/Additions/NSMutableString+GNUstepBase.m:
	* Source/Additions/NSError+GNUstepBase.m:
	* Source/Additions/GSMime.m:
	* Source/Additions/NSString+GNUstepBase.m:
	* Source/Additions/GCArray.m:
	* Source/Additions/GSXML.m:
	* Source/Additions/NSNumber+GNUstepBase.m:
	* Source/Additions/GSObjCRuntime.m:
	* Source/GSString.m:
	* Source/NSObjCRuntime.m:
	* Source/GSFormat.m:
	* Source/GSFileHandle.m:
	* Source/NSTask.m:
	On windows with mingw we can use strtoull() rather than _strtoui64().
	Also, remove redundant header includes since string.h is in common.h

2012-09-03  Niels Grewe <niels.grewe@halbordnung.de>

	* configure.ac: Fallback to the non icu-config check for ICU in
	the general case.
	* configure: Regenerate.

2012-09-01  Niels Grewe <niels.grewe@halbordnung.de>

	* configure.ac: Implement `--disable-icu-config' switch to
	configure for platforms that ship libicu but not icu-config.
	* configure: Regenerate.

2012-08-27  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSSstring.m: ([-stringByAppendingPathComponent:]) fix for
	append to an empty string with a windows path as an argument.

2012-08-26  Niels Grewe <niels.grewe@halbordnung.de>

	*  configure.ac: Check for sys/filio.h and whether we need to
	link libsocket (as on QNX).
	*  configure
	*  SSL/configure
	*  Headers/GNUstepBase/config.h.in:
	Regenerate.
	*  Source/common.h
	*  Source/GSFileHandle.m
	*  Source/NSMessagePort.m
	*  Source/NSSocketPort.m
	*  Source/NSThread.m
	*  SSL/GSSSLHandle.m:
	QNX compatibility tweaks.
	*  Tools/gdnc.m
	*  Tools/gdomap.c:
	Use slog facility for logging on QNX.

	Compatibility improvements for building for QNX.

2012-08-26  Niels Grewe <niels.grewe@halbordnung.de>

	* configure.ac: Check for QNX slog facilities.
	* Headers/GNUstepBase/config.h.in
	* configure:
	Regenerate
	* Source/NSLog.m: Implement logging to the QNX slog.

	Add support for logging to the QNX slog via NSLog().

2012-08-25  Niels Grewe <niels.grewe@halbordnung.de>

	* configure.ac: Allow a cross-compilation configuration to be
	specified using the `--with-cross-compilation-info=' switch.
	Tweak configure script to behave gracefully when
	cross-compiling.
	* configure: Regenerate.
	* cross.config: Add default values for cross-compilation.

	Make the configure script behave more friendly when
	cross-compiling.

2012-08-16  Niels Grewe <niels.grewe@halbordnung.de>

	* configure.ac: Check for objc_root_class attribute
	* configure: Regenerate
	* config/objc-common.g: Annotate root classes.
	* Headers/GNUstepBase/config.h.in: Regenerate
	* Headers/GNUstepBase/GSConfig.h.in: Add macro for root class
	attribute availability.
	* Headers/GNUstepBase/GSVersionMacros.h: Define GS_ROOT_CLASS
	depending on whether the compiler supports it.
	* Headers/Foundation/NSObject.h: Mark NSObject as a root class.
	* Headers/Foundation/NSProxy.h: Mark NSProxy as a root class.
	* Source/NSDistantObject: Mark GSDistantObjectPlaceholder as a
	root class.
	* Source/NSObject.m: Mark NSZombie as a root class.

	Changes to support clang's __attribute__((objc_root_class)).

2012-08-10  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSScanner.m: Fix error in comment
        * Tools/pldes.m: Update to more modern APIs
        * Tools/plser.m: Update to more modern APIs
        * Source/NSPropertyList.m: Update for usigned long long
        * Source/NSString.m: Make intValue, integerValue, longLongValue
        return large unsigned values as negative.
        Fixes to try to cope with property lists containing very large
        unsigned integers (top bit set).

2012-08-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPathUtilities.m:
        Fix permissions on temporary directory rarther than just failing ...
        suggestion by Wolfgang.

2012-08-10  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSFileManager.m: ([-createDirectoryAtPath:attributes:])
        OSX compatibility change to no longer create intermediate directories
        (fixing bug #35672).
        NB. Code depending on the original incorrect behavior should be
        updated to use the new method:
        -createDirectoryAtPath:withIntermediateDirectories:attributes:error:

2012-08-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSSpellServer.m:
	* Source/NSPropertyList.m:
	* Source/NSPathUtilities.m:
	* Source/NSUserDefaults.m:
	* Source/NSMessagePortNameServer.m:
	* Source/NSDistributedLock.m:
	* Source/NSMessagePort.m:
	* Source/NSHTTPCookieStorage.m:
        Use new method for creating intermediate directories rater than
        depending on incorrect behavior of the old method.

2012-08-09  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSPropertyList.m:
        Fix problem considering a lack of whitespace at the end of the
        list as an error.
        * GSeq.h: Replace tolower() with uni_tolower() where using 8bit
        strings and the internal coding is latin1 and may not be the same
        as the native encoding.

2012-08-08 Riccardo Mottola <rm@gnu.org>

	* Tools/AGSParser.m:
	Add macro detection for MacOS version 10.1 to 10.6 and make
	GS_API_LATEST the last in priority.

2012-08-08  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/GSString.m: Simplify/remove upper and lower case conversion
        to use superclass implementation avoiding toupper() and tolower().
        Change other literal string methods to check that the content
        is really utf8 in more places.  Generally simplify/cleanup a bit.

2012-08-02  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/GSValue.m: ([-isEqualToValue:]) add check for self equality
        and fix error checking tyep signature.
        * Source/Additions/GSObjCRuntime.m: (GSSelectorTypesMatch) fix to
        return a true BOOL value.

2012-07-31  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/Additions/GSMime.m: Optimisations for chunked encoding.
        a. Don't resize the buffer for each chunk ... that's very inefficient
        if the other end sends tiny chunks.  Instead, make the buffer big
        enough to handle all the available data, then shrink back to the
        decoded size.
        b. Move method call out of the loop handling individual bytes.

2012-07-30  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSData.m: ([setLength:]) increase size of buffer in chunks
        proportional to the current size ... so if we add small amounts to a
        buffer many, many times, we don't reallocate the memory for each tiny
        increment.  Should make accumulating large amounts of data into a
        buffer much more efficient.

2012-07-27  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSKeyValueObserving.m:
        Try fix for bug #36967

2012-07-27  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSXMLNode.m: Just report string value as description ...
        which appears to be what OSX does.
        * Tests/base/KVC/mutable.m: Add tests based on code by Riccardo.

2012-07-27  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSKeyValueObserving.m:
        * Source/GSFFIInvocation.m:
        * Source/GSPrivate.h:
        * Source/NSInvocation.m:
        * Source/cifframe.h:
        * Source/cifframe.m:
        Initial attempt at implementing KVO for structure setter methods in
        general via libffi.

2012-07-27  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLNode.m (-description): Remove trailing newline. This
	should fix #36976.

2012-07-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSFFCallInvocation.m:
	* Source/NSKeyValueObserving.m:
	* Source/Additions/GSObjCRuntime.m:
	* Source/NSProtocolChecker.m:
	* Source/GSValue.m:
	* Source/NSValue.m:
        Use GSSelectorTypesMatch() for type comparisons.

2012-07-12 19:26-EDT Gregory John Casamento <greg.casamento@gmail.com>

	* Source/NSFileManager.m: Correct misspelled ASSIGN which was
	causing link errors.

2012-07-11  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/Additions/GSMime.m: Don't accept documents where header lines
        contain bytes which can't be converted to a string.

2012-07-11  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSKeyedArchiver.m:
        * Source/NSCoder.m:
        * Source/Additions/GSObjCRuntime.m:
        * Source/NSArchiver.m:
        * Headers/GNUstepBase/GSObjCRuntime.h:
        Have leading type qualifiers and laout information skipped when
        encoding a value of on ObjC type, rather than objecting that the
        supplied type string is not a known type.
        Fix for bug #36824

2012-07-09  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/GSFFIInvocation.m: Fix for bug #36706
        * Source/NSObject.m: Also, apply patch by Niels Grewe with modsvn commit

2012-07-09  Sebastian Reitenbach <buzzdee>

        * Source/NSThread.m: Fixes test for posix thread scheduling.

2012-07-09  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSBundle.m: Fixes for bug #34815 ... map between old and
        new style language names and use the best language specific
        resource available.
        * Resources/Languages/Locale.canonical: Add mappings from three
        letter language names to two letter names where they exist.

2012-07-08  Richard Frith-Macdonald <rfm@gnu.org>

        * Headers/GNUstepBase/GSVersionMacros.h:
        fix for bug #36650
        * Source/NSFileManager.m: Apply rewritten patch by Sergey Golovin
        * Source/NSBundle.m: Fix for bug #34815 ... we shoudl now move to
        using ISO names.

2012-07-08  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSURL.m:
        * Source/NSURLHandle.m:
        Re-load a cached  handle if the content has been invalidated.
        Set the status of a file handle to not-loaded if the fiel is modified.
        Should fix bug #36726

2012-07-05  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSBundle.m: Don't assume that code loading won't be called
        re-entrantly.

2012-07-05  Quentin Mathe <quentin.mathe@gmail.com>

	* Source/NSPathUtilities.m: Fixed constant string comparison error
	reported by Clang SVN trunk r158230 or more recent.
	See http://llvm.org/viewvc/llvm-project?view=rev&revision=158230
        This is a workaround for a Clang compiler bug ...

2012-07-02  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSBundle.m: Attempted fix for bug #34191 ... change framework
        class association to keep a map of loaded frameworks/bundles by class
        for quick lookup and alter code to check the runtime for new frameworks
        if we are asked for the bundle for a class and we can't find it.

2012-06-27  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSScanner.m: Fix missing 'else' which was causing a
        memory leak and minor performance degradation.

2012-06-12  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSPropertyList.m: Check for nil property list argument.

2012-06-07  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Source/unix/GSRunLoopCtxt.m (-pollUntil:within:): Fix previous
	change to compile again when using select() instead of poll().

2012-06-06  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSSocketPort.m:
        * Source/unix/GSRunLoopCtxt.m:
        * Source/NSMessagePort.m:
        * Source/win32/GSRunLoopCtxt.m:
        Modify code for getting file descriptors to cope with an unlimited
        number (allocate buffer on heap if necessary) for server processes
        with very large numbers of distributed object connections.

2012-04-30 Riccardo Mottola <rm@gnu.org>

	* Source/NSString:
	Do not include malloc on OpenBSD to avoid warning (and include
        stdlib always).

2012-04-29 Riccardo Mottola <rm@gnu.org>

	* Source/common.h:
	Extend David's hack to all known non-glibc platforms

2012-02-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSArchiver.m:
	* Source/NSUnarchiver.m:
	* Source/NSPortCoder.m:
	* Source/Coder.m:
	Updates to cope with the fact that some BSD ports of gnustep-base
	used incorrect versioning, and that people have released Gorm
	files with versioning incompatible with current releases.
	1. dissociate coder -systemVersion from the actual system version,
	so that if people mess with the gnustep-base version, their
	non-standard releases will still interoperate with normal code.
	2. Implement new array encoding/decoding compatible with earlier
	versions (except if the array contains exactly 0xffffffff items).
	3. Raise exception if decoding archives with an unsupported version.
	4. Add GSCoderSystemVersion user default to override the system
	version used for encoding ... for testing and tweaking to generate
	archives in, or communicate with DO servers using an earlier version.

2012-04-23  Fred Kiefer <FredKiefer@gmx.de>

	* Tests/base/NSAutoreleasePool/autorelease_eh.m:
	Get new test to run with older compilers.

2012-04-23 12:47  theraven

	* libs/base/trunk/Source/NSAutoreleasePool.m,
	libs/base/trunk/Tests/base/NSAutoreleasePool/autorelease_eh.m:
	Fix a bug in the new autorelease pool implementation when pools
	are destroyed in the wrong order.

	Test cast by Chris Armstrong!

2012-04-22 Riccardo Mottola <rm@gnu.org>

	* Source/GSString.m
	Do not include malloc on OpenBSD to avoid warning.

2012-04-18  Fred Kiefer <FredKiefer@gmx.de>

	* Tools/pl2link.m (main): Get the category from a new entry named
	FreeDesktopCategories.
	Patch by Philippe Roussel <p.o.roussel@free.fr>.

2012-04-17  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/ObjectiveC2/runtime.c: Fi error calculating instance
	variable offset size as reported/suggested by James Cook
	<mokus@deepbondi.net>

2012-04-16  Richard Frith-Macdonald <rfm@gnu.org>

	* configure.ac: Add tests for lossy conversion using iconv and
	provide options to disable use of iconv or allow use of iconv
	where //TRANSLIT is missing.
	* configure: regenerate.

2012-04-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/Unicode.m:
	Fix test for availability of lossy conversion via iconv.

2012-04-10 Sebastian Reitenbach <sebastia@l00-bugdead-prods.de>

	* Tools/make_strings/StringsFile.m
	* Tools/pl.m
	some NSInteger -> NSUInteger changes to match return
	values of methods

2012-04-07 13:54  theraven

	* Source/NSMethodSignature.m: Fix NSMethodSignature
	generating nonsense values when it encounters a type encoding
	including blocks.

2012-04-07 10:45  theraven

	* Source/GSSocketStream.m:
	* Source/NSAffineTransform.m:
	* Source/NSXMLDTDNode.m:
	* Tools/xmlparse.m: Fix the remaining compiler
	warnings.

2012-04-07  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLDocument.m:
	* Source/NSXMLDTD.m:
	* Source/NSXMLNode.m:
	* Source/NSXMLDTDNode.m:
	* Source/NSXMLElement.m: Remove compiler warnings for clang
	reported by David Chisnall.
	* Tests/base/NSAutoreleasePool/basic.m: Get to compile again
	without -C99.

2012-04-06 12:37  theraven

	* libs/base/trunk/Source/NSConnection.m,
	libs/base/trunk/Source/NSData.m,
	libs/base/trunk/Source/NSKeyValueObserving.m: Fix a few compiler
	warnings caused by type mismatches in NSLog statements.

2012-04-06 12:23  theraven

	* libs/base/trunk/Headers/Foundation/NSArray.h,
	libs/base/trunk/Headers/Foundation/NSDictionary.h,
	libs/base/trunk/Headers/GNUstepBase/GSVersionMacros.h,
	libs/base/trunk/Source/NSArray.m,
	libs/base/trunk/Source/NSDictionary.m,
	libs/base/trunk/Tests/base/NSArray/basic.m,
	libs/base/trunk/Tests/base/NSDictionary/basic.m: Support for
	collection subscripting (NSArray and NSDictionary).

	Yes, the syntax is ugly, but no doubt people will start using it
	in June...

2012-04-06 12:02  theraven

	* libs/base/trunk/Source/NSAutoreleasePool.m,
	libs/base/trunk/Tests/base/NSAutoreleasePool,
	libs/base/trunk/Tests/base/NSAutoreleasePool/TestInfo,
	libs/base/trunk/Tests/base/NSAutoreleasePool/basic.m: Use the
	runtime's ARC autorelease pools if available.

2012-04-04  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLNode.m (+_objectForNode:): Don't create a document
	object for a private document.
	* Tests/base/NSXMLNode/transfer.m: New code for test case
	contributed by Doug Simons.

2012-04-03  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLElement.m,
	* Source/NSXMLNode.m: Fix compiler error and warning for older
	version of libxml2.

2012-04-01 Niels Grewe <niels.grewe@halbordnung.de>

	* Source/NSNumber.m: Add special small object class for floats.
	Previously, NSSmallRepeatableDouble would be used which resulted in
	the float being printed as a double when calling -stringValue or
	-description.

2012-03-27  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/Foundation/NSObject.h (-error:): Declare return type.
	Patch by Benoît Garrigues <bgarrigues@gmail.com>

2012-03-27  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLNode.m (execute_xpath): Clean up.

2012-03-27 Niels Grewe <niels.grewe@halbordnung.de>
	* configure.ac
	* config.mak.in
	* Headers/GNUstepBase/GSConfig.h.in
	* Headers/GNUstepBase/config.h.in:
	Implement configure check for libdispatch.
	* configure: Regenerate
	* Source/GSDispatch.h: Add portability header with macros for compiling
	  with or without libdispatch.
	* Source/NSArray.m
	* Source/NSDictionary.m
	* Source/NSIndexSet.m
	* Source/NSSet.m
	* Headers/Foundation/NSIndexSet.h:
	Implement libdispatch support for block enumeration methods.
	* Tests/base/NSMutableIndexSet/blocks.m
	* Tests/base/NSDictionary/blocks.m
	* Tests/base/NSArray/blocks.m:
	Test cases for new code.

	Detect the presence of libdispatch and, if available, use it for
	collection enumeration methods that take blocks as arguments. This
	allows us to implement the NSEnumerationConcurrent option of those
	methods with minimal effort.

2012-03-27 Niels Grewe <niels.grewe@halbordnung.de>

	* Source/NSOperation.m: Remove leftover debugging statements.

2012-03-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSOperation.m:
	* Source/NSRegularExpression.m:
	* Headers/GNUstepBase/GSBlocks.h:
	* Headers/Foundation/NSOperation.h:
	Get things compiling/linking again with gcc after blocks changes.

2012-03-27 Niels Grewe <niels.grewe@halbordnung.de>

	* Headers/Foundation/NSOperation.h
	* Headers/GNUstepBase/GSBlocks.h:
	Fix definitions of blocks without arguments for GCC.

2012-03-27  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLElement.m,
	* Source/NSXMLNode.m: Better support for namespaces. Corrected
	-_nodeFollowingInNaturalDirection:, -setStringValue:
	and -XMLStringWithOptions:

2012-03-26 Niels Grewe <niels.grewe@halbordnung.de>

	* Headers/Foundation/NSOperation.h
	* Source/NSOperation.m:
	Implement -setCompletionBlock: and -completionBlock.
	* Headers/GNUstepBase/GSBlocks: Make blocks without arguments callable
	* Tests/base/NSOperation/basic.m: Test whether completion blocks work.

2012-03-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSXMLPrivate.h: Change order of includes to ensure libxml2
	headers are seen early.

2012-03-23  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLNode.m (-rootDocument): Better test for private document.
	* Source/NSXMLDTDNode.m (-initWithXMLString:): Use childAtIndex:
	instead of rootElement.

2012-03-23  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLNode.m (-copyWithZone_): Use value 1 instead of 2
	for deep copy. Bug found by Doug Simons <doug.simons@testplant.com>.
	* Source/NSXMLNode.m (-rootDocument): Don't return the private document.
	* Source/NSXMLNode.m (-nextSibling, -previousSibling): Protect
	against namspace nodes.
	* Tests/base/NSXMLNode/transfer.m: New test case for problem
	reported by Doug Simons.

2012-03-22  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLElement.m,
	* Source/NSXMLNode.m: Fix memory leak for attribute private
	documents found by valgrind.
	* Tests/base/NSXMLNode/namespace.m: Use drain instead of release.

2012-03-22  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLDocument.m (-URI, -setURI:): Specific implementation.
	* Source/NSXMLPrivate.h: Remove URI ivar.
	* Source/NSXMLElement.m,
	* Source/NSXMLNode.m: Full support for namespaces.
	* Tests/base/NSXMLNode/namespace.m: Test code borrowed from Google
	data project.

2012-03-21  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLDocument.m: Correct memory management.
	* Source/NSXMLElement.m,
	* Source/NSXMLNode.m: Add partial support for namespaces.
	Try to bracket more libxml2 functions with version checks.

2012-03-21  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSXMLDocument.m:
	* Source/NSXMLDTD.m:
	* Source/NSXMLNode.m:
	* Source/NSXMLDTDNode.m:
	* Source/NSXMLElement.m:
	Bracket everything in test of HAVE_LIBXML2
	* configure.ac:
	* configure:
	Alter tests for major dependencies (ICU, XML, TLS) so that they all
	abort configuration unless specifically disabled ... we want a
	consistent build with all major features.

2012-03-20  Niels Grewe <niels.grewe@halbordnung.de>

	* Headers/Foundation/NSDictionary.h
	* Source/NSDictionary.m:
	Implement blocks related enumeration methods.
	* Tests/base/NSDictionary/blocks.m:
	Test cases for blocks support.

2012-03-20  Niels Grewe <niels.grewe@halbordnung.de>
	* Headers/Foundation/NSObjCRuntime.h: Define NS_REQUIRES_NIL_TERMINATION
	macro.

2012-03-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSException.h:
	Try to make error message more helpful when building with incompatible
	exception handling settings.

2012-03-18  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLDTDNode.m: Correct node type, at least for entity nodes.
	* Source/NSXMLDTD.m: Use predefined entities from libxml2.
	* Source/NSXMLNode.m: Rewrite the ownership transfer to preserve
	names in dictionaries.

2012-03-17  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLPrivate.h: Remvoe unused ivars.
	* Source/NSXMLDocument.m: Get DTD from node and and validation in
	init methods.
	* Source/NSXMLDTD.m: Implement.
	* Source/NSXMLNode.m: No children for attribute nodes.
	* Tests/base/NSXMLNode/basic.m: Test empty attribute children

2012-03-16  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLNode.m (-XMLStringWithOptions:): Protect the
	different format constants with version checks.

2012-03-14  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLDocument.m (-XMLDataWithOptions:): Correct convesion
	to NSData. Add some comments.

2012-03-14  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLPrivate.h: Add comments on owner policy.
	* Source/NSXMLNode.m (-XMLStringWithOptions:): Reimplement to
	allow closer control over output.
	* Source/NSXMLDocument.m (-XMLStringWithOptions:): Remove this method.

2012-03-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSXMLPrivate.h:
	* Source/NSXMLNode.m:
	* Source/NSXMLElement.m:
	Fixups to get the code to build on CentOS/RedHat linux.

2012-03-12  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLNode.m (-detach): Don't handle the namespace case.
	* Source/NSXMLElement.m (-removeNamespaceForPrefix:): Implement.
	* Tests/base/NSXMLNode/basic.m: Move tests from here ...
	* Tests/base/NSXMLElement/basic.m: ... to here.

2012-03-12  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLElement.m: Correct used namespace field.
	* Source/NSXMLNode.m: Implement special handling for namespace nodes.
	* Tests/base/NSXMLNode/basic.m: Correct method name for namespace node.

2012-03-11  Richard Frith-Macdonald & Fred Kiefer

	* Source/NSXMLNamespace.m:
	* Source/GNUmakefile:
	* Source/NSXMLPrivate.h:
	* Source/NSXMLNode.m:
	Revert most of my last change in favour of Fred's changes.

2012-03-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSXMLNamespace.m: New class for namespaces
	* Source/GNUmakefile: Build with new class
	* Source/NSXMLDocument.m:
	* Source/NSXMLPrivate.h:
	* Source/NSXMLDTD.m:
	* Source/NSXMLNode.m:
	* Source/NSXMLDTDNode.m:
	* Source/NSXMLElement.m:
	Use a new class for namespaces ... just a placeholder/skeleton so far.
	Change other classes to know the correct type of their 'node' pointer.

2012-03-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSXMLNode.m: Avoid crash when trying to get the parent of a
	namespace ... namespaces don't have parents and in fact have a
	completely different in-memory layout to other 'node' types.

2012-03-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSURLHandle.m:
	* Source/GSHTTPURLHandle.m:
	* Source/NSURLProtocol.m:
	* Headers/Foundation/NSURLProtocol.h:
	Tweak handling of debug settings to consistently write debug output
	using NSLog.

2012-03-09  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLNode.m (-copyWithZone:): Don't set object value of
	copy if it is nil.
	* Source/NSXMLNode.m (+_objectForNode:): Use correct sub class for
	decl nodes.
	* Tests/base/NSXMLNode/basic.m: More tests.

2012-03-08  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLNode.m (-detach, -_insertChild:atIndex:): Maintain
	doc pointer.
	* Source/NSXMLDTD.m: Implement a few methods.

2012-03-08  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLNode.m (+_objectForNode:): Add a few more libxml2
	node types.

2012-03-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSStream.m: Attempt to fix logic for event handling of data
	streams.

2012-03-01  Jens Alfke <jens@mooseyard.com>

	* Headers/GNUstepBase/NSURL+GNUstepBase.h:
	* Source/Additions/NSURL+GNUstepBase.m:
	* Source/NSURL.m:
	New -pathWithEscapes method to enable differentiation between '/'
	characters in the original path and '%2F' escapes in it.

2012-03-06  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLNode.m (+initialize): Add workaround for Windows
	xmlFree problem.

2012-03-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSURLProtocol.m: check for parse complete explicitly and
	remove case where complete is set to NO if using chunked coding ...
	it seems to be jsut wrong.

2012-03-06  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLNode.m (-copyWithZone:): Use objectValue ivar
	directly as the subclass NSXMLElement returns a different value.

2012-03-05  Eric Wasylishen  <ewasylishen@gmail.com>

	* Source/NSUserDefaults.m:
	* Source/NSConnection.m:
	* Source/NSCharacterSet.m:
	* Tools/make_strings/StringsFile.m:
	* Tools/pl.m: Fix instances where NSNotFound is stored in or
	compared to an unsigned or int variable.

2012-03-05  Eric Wasylishen  <ewasylishen@gmail.com>

	* Source/NSString.m: Factor out code for opening an ICU collator
	into static function GSICUCollatorOpen. Support
	NSDiacriticInsensitiveSearch.

2012-03-05  Eric Wasylishen  <ewasylishen@gmail.com>

	* Headers/Foundation/NSString.h (-compare:options:range:locale:):
	Rename locale parameter from "dict" to "locale".
	* Source/NSString.m (-compare:options:range:locale:): If locale
	paramater is not nil and not an NSLocale instance, substitute
	+[NSLocale currentLocale].
	* Source/NSString.m: Clarify some locale related documentation.

2012-03-05  Fred Kiefer <FredKiefer@gmx.de>

	* Tests/base/NSXMLElement/attributes.m: Test for changed
	exception.
	* Tests/base/NSXMLNode/basic.m: More tests.
	* Source/NSXMLNode.m: Rewrite object value handling.
	* Source/NSXMLElement.m (-objectValue): Return @"" when the value
	is nil.

2012-03-05  Eric Wasylishen  <ewasylishen@gmail.com>

	* Source/NSString.m (-rangeOfString:options:range:locale:):
	Correct result range with ICU codepath

2012-03-05  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLElement.m (-addAttribute:): Raise correct exception.
	* Tests/base/NSXMLNode/children.m: Add test cases for attributes.

2012-03-05  Eric Wasylishen  <ewasylishen@gmail.com>

	* Tests/base/NSString/locale.m: Expand test of compare:
	and rangeOfString:. Mark as hopeful for the moment. All pass
	on Mac OS 10.7.

2012-03-04  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLPrivate.h: Move private method declarations for
	NSXMLNode to here.
	* Source/NSXMLDocument.m
	* Source/NSXMLDTD.m
	* Source/NSXMLDTDNode.m
	* Source/NSXMLElement.m
	* Source/NSXMLNode.m: Clean up and add comments about missing code.

2012-03-03  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLNode.m: Remove all the extra reference handling code
	and the special retain and release methods.
	* Tests/base/NSXMLNode/basic.m,
	* Tests/base/NSXMLNode/children.m: A few more test
	cases. Validated on MacOSX 10.6.

2012-03-02  Eric Wasylishen  <ewasylishen@gmail.com>

	* Tests/base/NSString/locale.m: Add a simple test for locale sensitive
	compare: and rangeOfString: methods.

2012-03-02  Eric Wasylishen  <ewasylishen@gmail.com>

	* Source/NSString.m: Fix for ICU anchored backwards search

2012-03-02  Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSLocale.m (GSDefaultLanguageLocale): Add missing check
	for LC_MESSAGES definition.

2012-03-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m: fix for bug #35692

2012-03-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: Compatribility fix ... copy strings implicitly
	when taking a substring of a string whose buffer is not owned.

2012-03-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSURLConnection.m: Compatibility fix for bug #35686
	In this case Cocoa breaks its own convention about delegates
	not being retained, so we need to do the same.

2012-03-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/GNUstepBase/config.h.in: add missing ICU headers
	* Source/NSString.m: fix minor coding standard violations.

2012-03-01  Jens Alfke <jens@mooseyard.com>

	* Source/NSString.m:
	* Source/NSURL.m:
	Fix decoding of percent escapes with uppercase hex values
	(bug #35685)

2012-03-01  Eric Wasylishen  <ewasylishen@gmail.com>

	* Source/NSString.m: Implement a codepath using ICU for
	-compare:options:range:locale: and
	-rangeOfString:options:range:locale: when a non-nil locale
	is provided.
	* Headers/Foundation/NSString.h (-compare:options:range:locale:):
	Change type of locale parameter to id; it can be NSDictionary or
	NSLocale.
	* configure.ac: add some ICU headers used in NSString change
	* configure: regenerate

2012-03-01  Graham Lee

	* Source/GSNetworks.h: import GSPrivate.h

2012-03-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSURLResponse.h:
	* Source/NSURLResponse.m:
	Implement new initialiser from 10.7

2012-03-01  Jens Alfke <jens@mooseyard.com>

	* Source/NSJSONSerialization.m:
	Use %g for numeric output format.

2012-03-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSRunLoopWatcher.h:
	* Source/NSXMLPrivate.h:
	* Source/GSRunLoopCtxt.h:
	* Source/common.h:
	* Source/Additions/NSError+GNUstepBase.m:
	* Source/GSURLPrivate.h:
	Include config.h via common.h ... and have that turn off _GNU_SOURCE
	so GNU extensions aren't used and we stick to standard strerror_r

2012-03-01  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLNode.m: More cleanup.

2012-03-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSXMLDocument.m:
	* Source/NSXMLNode.m:
	* Source/NSXMLElement.m:
	Cleanup to conform to coding standards/conventions.
	Fix lots of functions to be local in scope.
	Add comments about needing to implement correct object ownership
	model.

2012-02-27 Doug Simons <doug.simons@testplant.com>

	* Source/NSXMLNode.m: Fix a crashing bug after an invalid xpath
	expression is used.

2012-02-29  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/NSError+GNUstepBase.m: try to ensure we always get
	the POSIX version of strerror_h.

2012-02-27  Eric Wasylishen  <ewasylishen@gmail.com>

	* Source/GSLocale.m:
	 - Deprecate GSSetLocale and GSSetLocaleC; they now do nothing
	   but print a warning.
	 - Introduce GSDefaultLanguageLocale(), which is a
	   substitute for GSSetLocale(LC_MESSAGES, nil), which just returns the
	   current setting of LC_MESSAGES.
	* Source/NSObject.m (+initialize): Remove GSSetLocaleC call,
	which was changing the libc locale.
	* Source/NSUserDefaults.m: Use GSDefaultLanguageLocale() instead of
	GSSetLocale(LC_MESSAGES, nil)

2012-02-27  Eric Wasylishen  <ewasylishen@gmail.com>

	* Source/NSArchiver.m (-resetArchiver): Write [self systemVersion] as
	the archive version instead of 0, because this is what will be stored in
	the archive if -encodeRootObject: is not called.

2012-02-27  Eric Wasylishen  <ewasylishen@gmail.com>

	* SSL/configure.ac: Change test for ssl2_clear in -lssl
	to test for SSL_clear, which is a public function and
	is acutally used by the SSL bundle. The test for ssl2_clear
	was failing with OpenSSL 1.0.0e.
	* SSL/configure: Regenerate

2012-02-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSArchiver.m:
	* Source/NSUnarchiver.m:
	* Source/NSPortCoder.m:
	* Version: Update to 12402
	Bump subminor version as suggested by eric Wasylishen, in case there
	are any archives which would be caugt by the new version number.

2012-02-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSArchiver.m:
	* Source/NSUnarchiver.m:
	Revise archive format to allow for variable sized array counts ...
	original versionallowed for variable encodings of integral types in
	archived data, but not for the count of the nuymber of items in the
	array :-(
	* Source/NSPortCoder.m: Similar fixes for encoding/decoding arrays.

2012-02-27  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLNode.m (-copyWithZone:): Copy name spaces as well.
	* Source/NSXMLDocument.m (-copyWithZone:): Rewrite copy method.
	* Source/NSXMLElement.m: Remove copy method.

2012-02-27 Doug Simons <doug.simons@testplant.com>
	Merged to trunk by: greg.casamento@gmail.com

	* Source/NSXMLDocument.m: Fix bugs in setCharacterEncoding: and
	copyWithZone: that cause a memory crash when tree is freed.
	Doug Simons <doug.simons@testplant.com>

2012-02-27  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLNode.m (+_objectForNode:): Get the actual class from
	the document.
	* Source/NSXMLNode.m (-description): Add a simple description method.
	* Source/NSXMLDocument.m: Further cleanup. Exchange the contents of
	-initWithData:... and initWithXMLString:...

2012-02-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSArchiver.m:
	* Source/NSUnarchiver.m:
	Alter to support encoding and decoding arrays with NSUInteger counts
	(ie more than 2^32 objects if on a 64bit system).

2012-02-26  Eric Wasylishen <ewasylishen@gmail.com>

	* Source/NSData.m: Various 64-bit compatibility fixes, mostly changing
	unsgined to NSUInteger.

2012-02-26  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLNode.m (execute_xpath): Use correct node for
	relative paths.
	* Source/NSXMLNode.m (isEqualTree): Correct equality test to
	ignore siblings.
	* Source/NSXMLNode.m (+elementWithName:stringValue:): Correct
	recursive call.
	Patch by Ivan Vučica <ivucica@gmail.com>
	* Source/NSXMLElement.m: Add FIXME comments for name space methods.

2012-02-23  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLElement.m: Implement namespace methods.

2012-02-22  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLNode.m (-_nodeFollowingInNaturalDirection:): Correct
	this method.
	* Source/NSXMLDocument.m,
	* Source/NSXMLElement.m: Clean up children methods.

2012-02-22  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLNode.m: Further clean up.
	* Source/NSXMLDTDNode.m (-initWithXMLString:): Move comment about
	missing code to here.
	* Source/NSXMLElement.m (-initWithName:stringValue:): Move subnode
	creation to here.

2012-02-21  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSXMLNode.m: Clean up helper functions.

2012-02-20  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSAffineTransform.m (-initWithCoder:, -encodeWithCoder:):
	Add key coding and decoding for NSAffineTransform.

2012-02-19 22:37-EST Gregory John Casamento <greg.casamento@gmail.com>
	Doug Simons <doug.simons@testplant.com>

	* Source/NSXMLDocument.m
	* Source/NSXMLDTD.m
	* Source/NSXMLDTDNode.m
	* Source/NSXMLElement.m
	* Source/NSXMLNode.m
	* Source/NSXMLPrivate.h: Reimplementation of all DOM classes based on
	libxml2.  Implementation of all methods using libxml2 functions.
	* Tests/base/NSXMLDocument/basic.m
	* Tests/base/NSXMLElement/attributes.m
	* Tests/base/NSXMLElement/children.m
	* Tests/base/NSXMLNode/basic.m
	* Tests/base/NSXMLNode/children.m
	* Tests/base/NSXMLNode/kinds.m: Changes to test for new functionality.

2012-02-08  Lubomir Rintel <lubo.rintel@gooddata.com>

	* Source/NSHTTPCookie.m:
	* Source/NSHTTPCookieStorage.m:
	* Source/NSURLConnection.m:
	* Source/NSURLProtocol.m:
	* Source/NSURLRequest.m:
	Enable the use of cookies by default ... addse setting of cookies
	in requests and improves caching/storing.  Original patches rewritten
	by maintainer to conform to coding standards and for clarity.

2012-02-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSConcreteValueTemplate.m: Don't ask a non-retained object
	to describe itsself (in case it has gon away) bug#35477

2012-02-07  Niels Grewe <niels.grewe@halbordnung.de>

	* configure.ac: Check for threading library on QNX.
	* configure: Regenerate.

2012-02-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Version: 1.24.1 ... still binary compatibile with 1.24.0
	* Source/NSTextCheckingResult.m:
	* Headers/Foundation/NSTextCheckingResult.h: coding style tidyups

2012-02-03  Adam Fedor  <fedor@gnu.org>

	* Bump version

2012-02-03  Adam Fedor  <fedor@gnu.org>

	* Version 1.24.0
	* Update announcements

2012-02-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSURL.m: Fixup for bug #35437

2012-01-31  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSJSONSerialization.m: bugfix for empty strings.
	* Tests/base/NSJSONSerialization/json.m: add a few emtpy element
	tests and fixup to be more readable

2012-01-31  Richard Frith-Macdonald <rfm@gnu.org>

	* Version: revert last change as Fred pointed out I got it wrong and
	we shoudl be updating version immediately *after* release.

2012-01-31  Fred Kiefer <FredKiefer@gmx.de>

	* Tests/base/NSURLRequest/basic.m: Remove two astray @ characters.

2012-01-30  Richard Frith-Macdonald <rfm@gnu.org>

	* Version: Bump version to 1.24.0 in preparation for release.
	* NSTimeZones/NSTimeZones.tar: Update timezone information

2012-01-30  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSJSONSerialization.m:
	Fix buffer overrun reported by Lubomir Rintel <lubo.rintel@gooddata.com>

2012-01-30  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSKeyValueCoding.m:
	* Source/NSAffineTransform.m:
	* Source/NSNotificationCenter.m:
	* Source/NSConnection.m:
	* Source/GSString.m:
	Avoid a few static analyser warnings.

2012-01-29  Richard Frith-Macdonald <rfm@gnu.org>

	* configure.ac:
	* Headers/GNUstepBase/config.h.in:
	* Source/GSFFIInvocation.m:
	* Source/GSPrivate.h:
	* Source/NSInvocation.m:
	If modern ffi is available, use ffi_prep_closure_loc and ffi closure
	memory management so we get the benefit of ffi library code to work
	around restrictions of selinux etc.

2012-01-29  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: Try to deal with the case where a language
	has been set to the ISO standard name rather than an OpenStep name
	by converting to an Openstep name as an alternative lookup key.
	* Source/NSXMLNode.m: Add warning that the DOM classes are not really
	functional in this release.

2012-01-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m: Fix copying for large files (issue #35381)

2012-01-25 Stefan Bidigaray <stefanbidi@gmail.com>

	* Source/NSNumberFormatter.m: Call unum_format* only once.

2012-01-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSSocketStream.m: fix possible nul pointer dereference.
	* Source/NSHost.m: cache failed lookup by name so that repeated
	lookups for a band host name do not cause repeated DNS queries.

2012-01-24  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSURLRequest.m: be tolerant about missing URL on init.

2012-01-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSFFIInvocation.m: Fix selector types comparison to use the
	correct function for checking equivalent types.

2012-01-10  Richard Frith-Macdonald <rfm@gnu.org>

	* config/pathtls.m4:
	* config/pathxml.m4:
	Remove incorrect sed call to tidy flags (as suggested by Felix Geyer
	in bug #34835).

2012-01-16  Eric Wasylishen  <ewasylishen@gmail.com>

	* Source/NSBundle.m (addBundlePath): Handle nested subdirectories
	(e.g.
	[NSBundle pathForLibraryResource:
	@"Generic-PostScript_Printer-Postscript" ofType: @"ppd"
	inDirectory: @"PostScript/PPD"] was previously failing.)

2012-01-12 10:10  theraven

	* libs/base/trunk/Headers/Foundation/NSException.h: Tweak the
	exception mismatch handling so that if base is using native exceptions
	and the user doesn't specify an exception mode then we just don't define
	the NS_ macros, so code that uses @try etc. compiles without requiring
	every cc line to specify a long -D flag just to be allowed to #import
	Foundation.h.

2012-01-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSBundle.m: Remove cached paths when the owning bundle is
	deallocated.  Use cache to determine which resource directories to
	search.

2012-01-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSBundle.m: Crude/simple caching of directory contents to
	test impact on theme loading ... needs reverting or improving.

2012-01-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSConcretePointerFunctions.m:
	* Source/NSSocketPort.m:
	* Source/unix/NSStream.m:
	* Source/NSKeyedUnarchiver.m:
	* Source/NSZone.m:
	* Source/NSMessagePort.m:
	* Source/win32/GSFileHandle.m:
	* Source/NSInvocation.m:
	* Source/NSURLProtocol.m:
	* Source/Additions/GSMime.m:
	* Source/Additions/GSXML.m:
	* Source/NSData.m:
	* Source/GSAvahiNetService.m:
	* Source/NSTextCheckingResult.m:
	Use PRIdPTR and PRIuPTR rather than ld and lu for printf formatting
	of NSInteger and NSUInteger values.

2012-01-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/ObjectiveC2/objc/capabilities.h:
	* Headers/ObjectiveC2/objc/Availability.h:
	* Headers/ObjectiveC2/objc/blocks_runtime.h:
	* Headers/ObjectiveC2/objc/runtime.h:
	Moved to subdirectory.
	* Source/Makefile.postamble:
	* Source/ObjectiveC2/runtime.c:
	* Source/ObjectiveC2/caps.c:
	* Source/ObjectiveC2/NSBlocks.m:
	* Source/ObjectiveC2/blocks_runtime.m:
	* Headers/GNUstepBase/GSObjCRuntime.h:
	* Tests/GNUmakefile:
	* base.make.in:
	Move ObjectiveC2 headers to objc subdirectory so that we can refer
	to them using the same objc/headername path as OSX, and use a -I
	directive to point to the ObjectiveC2 directory to avoid installing
	on top of the real objc2 library or vie versa. Should make it easier
	to figure out how to cleanly swith between raeal/emulated objc2
	runtimes.  This should also mean that old emulated objc2 headers are
	*not* found at configure time, so configure should be able to tell if
	a real objc2 runtime has been installed on a system which previously
	used the old objc runtime.

2012-01-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSXMLDocument.m:
	* Source/NSXMLPrivate.h:
	* Source/NSXMLNode.m:
	* Source/NSXMLElement.m:
	Replace missing assertion (needed for OSX compatibility) also fix
	several other issues in node hierarchy handling ... all rather
	academic since greg's going to rewrite, but these fixes do mean
	the current code passes the testsuite. It's a bad idea to leave
	the code and testsuite in an inconsistent state, and the testsuite
	represents accumulated information about OSX, so we want our code
	to pass all tests rather than removing tests.

2012-01-06 17:57-EST Gregory John Casamento <greg.casamento@gmail.com>

	* Source/NSXMLElement.m: Removing assertion that
	parent must not be nil per Cocoa documentation for
	-(id)parent method in NSXMLNode.

2012-01-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSXMLDocument.m:
	* Source/NSXMLElement.m:
	* Source/NSXMLNode.m:
	* Source/NSXMLPrivate.h:
	Rewrote node hierarchy handling to match OSX documentation and
	behaviors. Also implemented -hash and -isEqual: to match OSX for
	NSXMLNode.

2012-01-05 22:20-EST Doug Simons <doug.simons@testplant.com>

	* Source/NSXMLDocument.m: Modify XMLStringWithOptions: to only include
	the header when version, encoding, or standalone has been set.

2012-01-05 22:20-EST Gregory John Casamento <greg.casamento@gmail.com>

	* Source/NSXMLElement.m: in setChildren: set the childCount.

2012-01-05 22:07-EST Gregory John Casamento <greg.casamento@gmail.com>

	* Source/NSXMLElement.m: Correct warning in copyWithZone: added
	return.  Correct issue with childCount being out of sync.

2012-01-05 21:33-EST Gregory John Casamento <greg.casamento@gmail.com>

	* ChangeLog
	* Source/NSXMLDocument.m
	* Source/NSXMLElement.m
	* Source/NSXMLNode.m: Implement copyWithZone:, correct issues
	with previous revert.

2012-01-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSXMLDocument.m:
	* Source/NSXMLElement.m:
	Replace a few lines accidentally lost.

2012-01-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSXMLDocument.h:
	* Headers/Foundation/NSXMLNode.h:
	* Headers/Foundation/NSXMLDTD.h:
	* Headers/Foundation/NSXMLDTDNode.h:
	* Headers/Foundation/NSXMLElement.h:
	* Source/NSXMLDocument.m:
	* Source/NSXMLPrivate.h:
	* Source/NSXMLDTD.m:
	* Source/GSInternal.h:
	* Source/NSXMLNode.m:
	* Source/NSXMLDTDNode.m:
	* Source/NSXMLElement.m:
	The last revert still left lot's of ABI breakage, but reverting much
	further would lose a lot of work ... so here's an attempt to fix the
	ABI breakage by re-hiding instance variables again.

2012-01-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSMDNSNetServices.m:
	* Source/NSJSONSerialization.m:
	Cosmetic tweaks (whitespace)

2012-01-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSXMLDocument.m:
	* Source/NSXMLNode.m:
	* Source/NSXMLElement.m:
	* Headers/Foundation/NSXMLDocument.h:
	* Headers/Foundation/NSXMLNode.h:
	* Headers/Foundation/NSXMLDTD.h:
	* Headers/Foundation/NSXMLElement.h:
	Revert latest changes to restore scheme for preventing ABI breakage
	and supporting both fragile and non-fragile ABIs..

2012-01-04  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/Foundation/NSXMLDocument.h,
	* Headers/Foundation/NSXMLDTD.h: Comment out duplicate declaration of
	ivars to get base to compile again.

2012-01-03 16:33-EST Gregory John Casamento <greg.casamento@gmail.com>

	* Headers/Foundation/NSXMLDocument.h
	* Headers/Foundation/NSXMLElement.h
	* Headers/Foundation/NSXMLNode.h: Move declarations.
	* Source/NSXMLDocument.m: Correct parsing issues.
	* Source/NSXMLElement.m: Remove local declaration of _children
	* Source/NSXMLNode.m: Remove internal.  Move all declarations here
	directly.

2012-01-03 14:22-EST Gregory John Casamento <greg.casamento@gmail.com>

	* Source/NSXMLDocument.m: Implement XMLStringWithOptions:

2012-01-03 13:03-EST Gregory John Casamento <greg.casamento@gmail.com>

	* Headers/Foundation/NSXMLElement.h
	* Headers/Foundation/NSXMLNode.h
	* Source/NSXMLElement.m
	* Source/NSXMLNode.m: Move _URI to NSXMLNode.
	change dealloc accordingly.

2012-01-03 12:42-EST Gregory John Casamento <greg.casamento@gmail.com>

	* Source/NSXMLNode.m: Implement copyWithZone:

2012-01-03 12:17-EST Gregory John Casamento <greg.casamento@gmail.com>

	* Headers/Foundation/NSXMLNode.h: Add _stringValue
	* Source/NSXMLNode.m: Change stringValue and setStringValue:
	resolvingEntities: to assign to _stringValue instead of _objectValue.

2012-01-03 12:06-EST Gregory John Casamento <greg.casamento@gmail.com>

	* Source/NSXMLDocument.m: Change stack implementation to
	use lastObject/removeLastObject to implement the stack instead
	of inserting and deleting at index 0.
	* Source/NSXMLElement.m: Implemented XMLStringWithOptions:
	* Source/NSXMLNode.m: Implemented XMLStringWithOptions:,
	skeletal implementation of setStringValue:resolvingEntities:

2012-01-03  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSException.m (-raise): Only set the stack when the
	exception gets first raised. This fixes bug #35192
	Patch by Larry Campbell <lcampbel@akamai.com>

2012-01-02 22:26-EST Gregory John Casamento <greg.casamento@gmail.com>

	* Headers/Foundation/NSXMLElement.h: Change _attributes to be
	a NSMutableDictionary instead of an NSMutableArray.
	* Source/NSXMLElement.m: Change implementation of some methods
	to use an NSMutableDictionary instead of arrays.  Initialize
	ivars in initializer.
	* Source/NSXMLPrivate.h: Remove redundant method.

2012-01-02  Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSSocketStream.m (-initWithInput:output:): Attempt to
	replace deprecated GNUTLS functions with newer ones for GNUTLS >= 2.12.

2012-01-02  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSArray.m (-objectsAtIndexes:): Fix comparision of
	unsigned variable with NSNotFound.

2012-01-02 02:26-EST Gregory John Casamento <greg.casamento@gmail.com>

	* Source/NSXMLNode.m: Minor correction. Move setName out of
	private category.
	* Tests/base/NSXMLNode/children.m: Update test.

2012-01-01  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/Foundation/NSXMLDTDNode.h,
	* Headers/Foundation/NSXMLDTD.h: Remove duplicate declaration of
	ivar _name to get base to compile again.

2011-12-30  Doug Simons <doug.simons@testplant.com>

	* Source/NSXMLElement.m: Set Elements to be NSXMLElementKind.

2011-12-30 14:22-EST Gregory John Casamento <greg.casamento@gmail.com>

	* Headers/Foundation/NSXMLDocument.h
	* Headers/Foundation/NSXMLElement.h
	* Headers/Foundation/NSXMLNode.h
	* Source/NSXMLDocument.m
	* Source/NSXMLElement.m
	* Source/NSXMLNode.m
	* Source/NSXMLPrivate.h
	* Tests/base/NSXMLNode/children.m
	* Tests/base/NSXMLNode/kinds.m: First cut at NSXMLDocument
	implementation.

2011-12-29  Doug Simons <doug.simons@testplant.com>

	* Source/NSCalendarDate.m: Fix -addTimeInterval: to copy calendarFormat
	of original date.

2011-12-24  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSConnection.m: Fix retain rount error spotted by
	<rajendra@teamf1.com> (bug #35164)

2011-12-23  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Headers/Foundation/NSTextCheckingResult.h:
	* Source/NSTextCheckingResult.m	(-resultByAdjustingRangesWithOffset:):
	Implement method.

2011-12-23  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Headers/Foundation/NSTextCheckingResult.h:
	* Source/NSTextCheckingResult.m: Add copyright notice.

	* Source/NSTextCheckingResult.m(-result, -range): Raise exception
	in abstract base class implementation. This is what OS X does.

	* Source/NSTextCheckingResult.m(-rangeAtIndex): Implement in
	abstract base class.  Raise exception in both method
	implementations when the index is too big.

	* Source/NSTextCheckingResult.m(-numberOfRanges): Change incorrect
	name rangeCount into numberOfRanges.

	* Source/NSTextCheckingResult.m(-regularExpression): Implement
	method in the concrete subclass where it was omitted.

2011-12-23  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Source/NSRegularExpression.m (-rangeOfFirstMatchInString:...):
	Return range (NSNotFound, 0) when no match is found.

2011-12-22  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Source/NSRegularExpression.m (-initWithPattern:options:error:,
	-pattern, setupRegex, -enumerateMatchesInString:options:range:,
	FAKE_BLOCK_HACK, -replaceMatchesInString:options:range:,
	-stringByReplacingMatchesInString:options:range:withTemplate:,
	replacementStringForResult:inString:offset:template:): Introduce
	support for libicu versions prior to 4.4, which don't provide the
	UText interface to regular expressions.

2011-12-22  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Source/NSSocketPort.m	(+portNumber:onHost:forceAddress:listener):
	Fix an uninitialized variable bug, which could lead to returning
	ports with an incorrect port number.

2011-12-19 Riccardo Mottola <rm@gnu.org>

	* Source/GSString.m:
	Fix blocking compiler warning (ggc 4.5.3)

2011-12-17  Richard Frith-Macdonald <rfm@gnu.org>

	* configure.ac: Try to make detection of compilers which don't support
	locale/characterset handling for string literals somewhat friendly.
	* configure: regenerate

2011-12-17  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSPortCoder.m (-versionForClassName:): Use NSInteger for
	version to avoid compiler warning on 64-bit system.

2011-12-17  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m:
	Whenever we synchronize in a state where we have changes to write,
	but are in read-only mode (no database existed on startup, or we
	couldn't create the lock file on startup), check to see if the
	database is now writable (we can create the lock file).
	Should fix problem where new defaults files were not getting created.

2011-12-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSProcessInfo.m:
	* Source/NSSocketPort.m:
	* Source/NSMessagePortNameServer.m:
	* Source/NSDebug.m:
	* Source/NSDistributedLock.m:
	* Source/GSHTTPURLHandle.m:
	* Source/NSMessagePort.m:
	* Source/NSFileManager.m:
	* Source/NSString.m:
	* Source/NSObject.m:
	* Source/NSThread.m:
	* Source/NSData.m:
	* Source/GSNetwork.h:
	* Source/GSFormat.m:
	* Source/GSFileHandle.m:
	* Source/NSTask.m:
	* SSL/GSSSLHandle.m:
	* SSL/configure.ac:
	* SSL/configure:
	* SSL/config.h.in:
	* configure.ac:
	* configure:
	* Headers/GNUstepBase/config.h.in:
	* Tools/gdnc.m:
	Support fcntl.h and signal.h not being in the 'sys' subdirectory
	(for android and any other systems with that header layout).

2011-12-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSObject.h:
	* Headers/Foundation/NSObjCRuntime.h:
	Move a few declarations between headers to match OSX, and update
	NSNotFound to be NSIntegerMax for compatibility on 64bit platforms.

2011-12-13  Richard Frith-Macdonald <rfm@gnu.org>

	* SSL/GSSSLHandle.m: Allow cipher list to be set using GSCipherList
	default.

2011-12-08  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* configure.ac: Fix pkg-config configuration for libffi to make it
	really work on systems where additional include options are
	needed.
	* configure: Regenerated.

2011-12-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSParser.m: Fix suggested by Daniel Santos (ifStack was
	created with incorrect initial content).

2011-12-06  Richard Frith-Macdonald <rfm@gnu.org>

	* configure.ac: use pkg-config for libffi if/when available.
	* configure: regenerate

2011-12-05  Eric Wasylishen  <ewasylishen@gmail.com>

	* Source/NSFileManager.m:
	* Headers/Foundation/NSFileManager.h: Add removeItemAtPath:error:
	method, as a simple wrapper around removeFileAtPath:handler: with
	no handler.

2011-12-02  Richard Frith-Macdonald <rfm@gnu.org>

	* config/config.constant-string-encoding.c: test for string literal
	encoding behavior ... irrespective of source encoding we need to put
	utf-8 in the executable.  Can't check all cases, so just check the
	most common one ... that building latin1 source in a latin1 locale
	produces a utf8 string literal in the executable.
	* configure.ac: add check for encoding.
	* config.mak.in: specify charset for string literal in source
	* base.make.in: specify charset for string literal in executable
	* configure: regenerate
	Check compiler behavior ... if well behaved, that's OK, no action to
	take.  If well behaved when given specific options to control input
	and output encodings, then note the options to be used when building.
	If neither, then abort with an error message giving the option of
	disabling unicode string literal checks.

2011-11-21  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: rewrite to store defaults in multiple files,
	one for each persistent domain.
	Probably needs lots of testing and performance tuning.

2011-11-18  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSJSONSerialization.m: Fix errors in BOM handling and tidy.

2011-11-17  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: Fix to compile again (use ifdef to consistently
	have/not-have tiny strings), and tidy use of whitespace for readability
	and coding standards.
	I like the experimental tiny strings idea... will definitely save
	space, but will need a lot of optimisation (like that of literal
	strings) to stop it being slow.
	Until it's about as fast as literal strings, we should probably only
	enable it on platforms where memory footprint is an issue.
	Not sure how to do that though.

2011-11-16 20:48  theraven

	* Source/GSString.m: Store tiny strings (up to 8
	ASCII characters) inside the pointer. Strings of this length are
	fairly common, and this makes them very cheap to store/copy/compare
	(pointer comparisons test for equality). 8 characters seems to be
	enough for quite a lot of common uses, such as path components and
	tokens.
	There are possibly still some things constructing tiny strings and not
	using these.

2011-11-16 17:29  theraven

	* Source/NSNumber.m: Implement the double boxing
	techniques used by Smalltalk/X and Cincom Smalltalk. Now we can
	conceal most doubles inside a pointer. This is most useful for
	LanguageKit, but should save some memory / malloc overhead / heap
	fragmentation in any code that uses a lot of NSNumbers (e.g.
	anything that deals with big plists). OS X 10.7 employs a similar
	trick.

2011-11-15  Adam Fedor  <fedor@gnu.org>

	* Source/win32/GSFileHandle.m: Fix include location

2011-11-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPathUtilities.m: Deal with old FIXME saying that whether
	we create the GNUstep/Library directory should be configurable.
	Also, break long lines to confiorm to coding standards and for
	consistency.

2011-11-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: ([-setObject:forKey:]) replace missing
	return statement after removing object.

2011-11-07  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/Foundation/NSXMLParser.h: Turn the
	NSXMLParserDelegateEventAdditions informal protocol into the
	protocol NSXMLParserDelegate.

2011-11-07  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSValueTransformer.m
	([NSUnarchiveFromDataTransformer-reverseTransformedValue])
	([NSUnarchiveFromDataTransformer-transformedValue]): Use archiver
	instead of keyed archiver.

2011-11-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m: ([+decodeBase64:]) tolerate missing
	padding and also use of '-' and '_' rather than '+' and '/' as
	permitted in the "URL and Filename safe" variation given in RFC 4648

2011-11-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDate.m:  ([-timeIntervalSinceDate:]) return NaN if other
	date is nil (OSX compatibility).

2011-11-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSNumber.m: Fix alignment error when encoding/decoding ...
	buffer must be aligned so that any datatype can go in it.
	* Source/cifframe.m: Fix buffer size for small scalar values on
	64bit sparc
	* Source/GSFileHandle.m: Modify read/write to cope with interrupts.

2011-11-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: Partial restructuring suggested by Fred, plus
	some more minor optimisation of equality checks for literal strings.

2011-10-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: Fix error (spotted by Fred) in check of UTF-8
	string length against fixed character size string length.

2011-10-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: Implement more efficient equality tests for
	utf-8 literal strings and strings in internal representation.
	Implement rangeOfComposedCharacterSequenceAtIndex: for utf8 literal
	strings.

2011-10-29  Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSeq.h: Replace unsigned with NSUInteger.

2011-10-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: Fix bug when widening mutable string in
        replaceOccurrencesOfString:...range:
	* Source/GSString.m: more efficient check to see if a literal string
	can be converted to ascii or latin1.  Remove unnecessary constraint
	on when we need to widen strings.

2011-10-28  Fred Kiefer <FredKiefer@gmx.de>

	* Tests/base/NSMutableString/basic.m: Add test for
	replaceOccurrencesOfString:...range:

2011-10-27  Richard Frith-Macdonald <rfm@gnu.org>

	* configure.ac: Do not redefine GNUSTEP_CONFIG_FILE in case it confuses
	gnustep-config.  Add check that gnustep-config returns something when
	asked for the objc libraries.
	* configure: Regenerate
	* base.make.in: Add flag to tell compiler to use UTF-8 for literal
	string constants.

2011-10-25  Richard Frith-Macdonald <rfm@gnu.org>

	* configure.ac: fix erroneous define of HAVE_GNUTLS to zero, and add
	check for building with a  different compiler from that used by make.

2011-10-24  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSAffineTransform.m (-initWithCoder:, encodeWithCoder:):
	Don't do anything for the keyed coding case.
	* Source/NSDictionary.m (-initWithCoder:): Add another keyed
	coding case.

2011-10-22  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSProcessInfo.m: Add includes needed for the HAVE_PROCFS
	case.
	* Source/common.h: Correct last commit, the #endif was placed
	incorrectly.

2011-10-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/common.h: Attempt to workaround clang __block problem

2011-10-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPathUtilities.m:
	Fix for bug #34603

2011-10-19  Richard Frith-Macdonald <rfm@gnu.org>

	* configure.ac: fixes for gnutls detection and to use the objc
	libraries provided by gnustep-config.

2011-10-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/GNUstepBase/GSFileHandle.h: remove
	* Source/GSFileHandle.h: add
	* Source/GNUmakefile: Don't install private header
	* Source/NSFileHandle.m:
	* Source/GSFileHandle.m:
	* SSL/GSSSLHandle.m:
	Update to make GSFileHandle.h: private as it should be.

2011-10-19  Sebastian Reitenbach

	* configure.ac: fix typo on gnutls detection.

2011-10-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPathUtilities.m:
	Fix failure to load global defaults when system layout/config is
	locked down (problem reported by Julian Mayer).

2011-10-18  Richard Frith-Macdonald <rfm@gnu.org>

	* standalone.conf: example configuration file for a standalone
	package installation.
	* Documentation/Base.gsdoc:
	Documentation improvements for packaging

2011-10-17  Richard Frith-Macdonald <rfm@gnu.org>

	* configure.ac: Make sourcing of default config file more reliable.
	* configure: regenerate.

2011-10-17  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSBundle.m:
	* Source/NSPropertyList.m:
	* Source/NSFileHandle.m:
	* Source/NSString.m:
	* Source/DocMakefile:
	* Documentation/Base.gsdoc:
	* Headers/Foundation/NSString.h:
	* Headers/Foundation/NSBundle.h:
	Documentation cleanups.

2011-10-17  Quentin Mathe <quentin.mathe@gmail.com>

	* Headers/Foundation/NSXMLNode.h:
	* Source/NSXMLNode.m:
	Fixed NSXMLNode compilation when using the "pure" non-fragile ABI
	(--disable-mixedabi was passed to Base configure).

2011-10-17  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSString.m (-initWithCoder:): In keyed coding the key
	"NS.bytes" may contain either an NSData or an NSString object. Not
	sure about the encoding, I am using UTF8.

2011-10-17  Richard Frith-Macdonald <rfm@gnu.org>

	* standalone.conf: First draft at a layout for standalone system
	deployment.

2011-10-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/common.h: Added Quentin's fix to get Clang to compile this
	without warnings.

2011-10-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/ObjectiveC2/NSBlocks.m:
	* Source/Additions/GSObjCRuntime.m:
	Fixes to build with latest gcc.

2011-10-15  Gregory Casamento <greg.casamento@gmail.com>

	* Documentation/GNUmakefile:
	* Documentation/README.initialize: Documentation referred to by
	NSThread warning.

2011-10-15  Richard Frith-Macdonald <rfm@gnu.org>

	* config.mak.in:
	Shift the responsibility for setting up macros controlling thread
	safety to gnustep-make, and use the compiler -pthread option there.

2011-10-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/unix/Makefile.preamble:
	* Source/win32/Makefile.preamble:
	* Source/ObjectiveC2/Makefile.preamble:
	* Source/Additions/Makefile.preamble:
	* Source/Makefile.preamble:
	* config.mak.in:
	It seems various BSD operating systems have bugs in their _XOPEN_SOURCE
	implementation, so we can't generally use it.  Try _POSIX_C_SOURCE
	instead.

2011-10-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/unix/Makefile.preamble:
	* Source/win32/Makefile.preamble:
	* Source/ObjectiveC2/Makefile.preamble:
	* Source/Additions/Makefile.preamble:
	* Source/Makefile.preamble:
	Define _REENTRANT as well as _XOPEN_SOURCE for maximum portability.

2011-10-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSBundle.m:
	* Source/NSPathUtilities.m:
	* Source/NSProcessInfo.m:
	* Source/NSSocketPort.m:
	* Source/NSRunLoop.m:
	* Source/NSMessagePortNameServer.m:
	* Source/unix/GSRunLoopCtxt.m:
	* Source/unix/NSStream.m:
	* Source/GSHTTPURLHandle.m:
	* Source/NSPage.m:
	* Source/NSMessagePort.m:
	* Source/win32/GSFileHandle.m:
	* Source/NSInvocation.m:
	* Source/NSFileManager.m:
	* Source/common.h:
	* Source/NSString.m:
	* Source/NSThread.m:
	* Source/NSData.m:
	* Source/NSHost.m:
	* Source/GSNetwork.h:
	* Source/NSPipe.m:
	* Source/NSLog.m:
	* Source/GSFormat.m:
	* Source/GSFileHandle.m:
	* Source/NSTask.m:
	* SSL/GSSSLHandle.m:
	* Tools/gdnc.m:
	Move/wrap include of unistd.h to work around clang problem.

2011-10-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/Unicode.m:
	Fix test for availability of lossy conversion via iconv.

2011-10-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: Implement -hash for literal UTF-8 performance.
	* Source/NSScanner.m: Fix initialisation bug which could cause
	scanning to fail on some strings.
	* Source/inet_pton.m:
	* Source/NSProcessInfo.m:
	* Source/NSSocketPort.m:
	* Source/NSUserDefaults.m:
	* Source/unix/NSStream.m:
	* Source/inet_ntop.m:
	* Source/GSHTTPURLHandle.m:
	* Source/NSMessagePort.m:
	* Source/GSPrivate.h:
	* Source/win32/GSFileHandle.m:
	* Source/win32/NSMessagePort.m:
	* Source/win32/NSMessagePortNameServer.m:
	* Source/NSFileManager.m:
	* Source/Additions/Unicode.m:
	* Source/Additions/NSError+GNUstepBase.m:
	* Source/NSThread.m:
	* Source/GSNetwork.h:
	* Source/GSFileHandle.m:
	* Source/NSLock.m:
	* Source/Makefile.preamble:
	Fix for thread-safe errno on solaris ... define _XOPEN_SOURCE to 600

2011-10-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSPrivate.h:
	* Source/NSString.m:
	* Source/GSString.m: Use UTF-8 literal constant strings now that we
	require a compiler version which supports them.
	* Tests/base/NSString/test07.m: Simple test for UTF-8 in literal.
	* Tests/base/GNUmakefile.super: Ensure all tests are compiled with
	UTF-8 set as the source code characterset.
	Shuld fix bug #34486

2011-10-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: Fix boundary error when getting cString into a
	buffer.  Fix floatValue and doubleValue to support arbitrary length
	of leading white space.
	* Source/GSNetwork.h: Check for EAGAIN on nonblocking socket.

2011-10-08  Niels Grewe <niels.grewe@halbordnung.de>

	* Source/Additions/GSMime.m (GSMimeParser -scanToken:): Return an empty
	string instead of nil when parsing an empty quoted string.

2011-10-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSFileHandle.m:
	* Source/GSNetwork.h:
	* Source/GSSocketStream.m:
	* Source/NSMessagePort.m:
	* Source/NSSocketPort.m:
	* Source/NSURLProtocol.m:
	Check for EALREADY as well as EINPROGRESS as an indicator of an
	incomplete system call on a non-blocking descriptor.

2011-10-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSHTTPURLHandle.m:
	Be aggressive about checking for close n the 'connection' header
	and shutting down the network connection immediately.

2011-10-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSURLProtocol.m:
	* Source/NSURLConnection.m:
	Ensure that a synchronous load returns the response.
	* Tests/base/NSURLConnection/basic.m: add test for above change.

2011-10-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSURL.h: Document that methods creating file URLs
	raise an exception on being given a nil argument.
	* Source/NSURL.m: Make file URL initialisers raise on nil argument.
	* Source/NSBundle.m: Fix to check for nil path when reating file
	URLs (fix for bug #34468).

2011-10-03  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSPropertyList.m (GSBinaryPLParser -objectAtIndex:): Use
	long long for all integer types. Before we used signed types which
	resulted wrong values for negative integers.
	* Source/NSKeyedUnarchiver.m (-_decodeObject:): Handle the string
	"$null" as nil all the times.

2011-10-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSHost.m: Update to use inet_pton() and inet_ntop() and to
	understand IPV6 addresses.
	* Source/GSNetwork.h: New private functions to work with the internals
	of a sockaddr irrespective of whether it's IP v4 or v6
	* Source/GSSocketStream.h: Move a declaration to GSNetwork.h
	* Source/GSSocketStream.m: Use new functions.
	* Source/NSSocketPort.m: Change to be IP v4/v6 agnostic
	* Source/NSMessagePort.m: Fix header include order.
	* Source/GSFileHandle.m: Changes to be IP v4/v6 agnostic
	* Headers/GNUstepBase/GSFileHandle.h: make setter use sockaddr type
	rather than sockaddr_in so we can use it for ipv6

2011-10-03  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSData.m (-initWithCoder:, -encodeWithCoder): Correct
	keyed encoding/decoding.

2011-10-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSFileManager.h
	* Source/NSFileManager.m
	* Tests/base/NSFileManager/general.m
	* Headers/Foundation/NSUserDefaults.h
	* Source/NSUserDefaults.m
	* Tests/base/NSUserDefaults/basic.m
	Add a few newer OSX methods for compatibility.

2011-10-01  Niels Grewe <niels.grewe@halbordnung.de>

        * Source/NSXMLNode.m: Properly implement -initWithKind: initializer.
        Stub out some tree traversal stuff.
	* Tests/base/NSXMLNode/basic.m: Fix test.

	Initial work on NSXMLNode.

2011-10-01  Niels Grewe <niels.grewe@halbordnung.de>

	* Tests/base/NSXMLNode/children.m: Test for child de-/re-attachment
	behaviour.

2011-09-29  julian <julian@corecode.at>

	* Source/NSBundle.m: ([objectForInfoDictionaryKey:])
	Add missing one-line implementation.

2011-09-29  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSNumberFormatter.m: Check for _C_BOOL definition.

2011-09-07  Eric Wasylishen  <ewasylishen@gmail.com>

	* Source/NSUserDefaults.m:
	- Refactoring of the code to read the system language list
	  into a separate function, systemLanguages().
	- Add support for the LANGUAGE environment variable, a GNU extension.
	  It holds a colon-separated list of locales, and is intended to let
	  the user specify a list of their preferred languages in order.
	  For example, the language settings GUI in Ubuntu modifies the
	  LANGUAGE variable.

	  More info here:
	  http://www.gnu.org/software/gettext/manual/gettext.html#The-LANGUAGE-variable
	- When populating NSLanguages, "expand" locales into a list of
	  related variants, formed by stripping off region suffixes. This
	  ensures that if a user's environment is set to a regional version
	  of a language (say CanadaFrench) but an application is only
	  traslated into French, the plain French translation will still be used.

	  e.g. if the system locales are {fr_CA, en_CA}, expand the list to
	  {fr_CA, fr, en_CA, en}.
	* Headers/GNUstepBase/GSLocale.h:
	* Source/GSLocale.m:
	New functions GSLocaleVariants and GSLanguagesFromLocale

2011-09-28  Niels Grewe <niels.grewe@halbordnung.de>

	* Tests/base/NSXMLNode/*: Some initial tests for NSXMLNode. Passes on
	Mac OS X, marked as hopes until GNUstep implements this.

2011-09-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Version: Bump version and set required gcc to 4.0.0

2011-09-18  Richard Frith-Macdonald <rfm@gnu.org>

	* Documentation/news.texi:
	* Documentation/ReleaseNotes.gsdoc:
	Update release notes for ...
	Version 1.23.0

2011-09-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSConnection.m: When getting the local type information for
	comparison with that supplied by the remote system, do so by sending
	-methodSignatureForSelector: to the receiver of the message.

2011-09-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSFFIInvocation.m: Check that we have a typed selector
	during invocation (copy types from method signature if necessary)
	so that forwarding won't fail if the runtime does a callback to
	us without providing the receiver for us to check ... workaround
	for proxying issues with very old runtimes.

2011-08-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSLock.m: Fix bug #34154 ... logic error locking before date.

2011-08-26  Richard Frith-Macdonald <rfm@gnu.org>

	* libs/base/trunk/config/config.objc.m: If we don't assume Object
        exists in libobjc, we must implement +initialize so that the runtime
        won't crash when it tries to initialize our class.

2011-08-25  Fred Kiefer <FredKiefer@gmx.de>

	* Tests/base/NSObject/test01.m: Only test for -isClass on GNUstep base.
	* Tests/base/NSObject/initialize.m: Make test compile on MinGW.

2011-08-22  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSObject.m (__builtin_offsetof): Add
	workaround for build in missing in old versions of gcc.

2011-08-20  Fred Kiefer <FredKiefer@gmx.de>

	* Source/Additions/GSMime.m,
	* Source/unix/NSStream.m,
	* Source/NSData.m,
	* Source/NSDistantObject.m,
	* Source/NSInvocation.m,
	* Source/NSMessagePort.m,
	* Source/NSNumber.m,
	* Source/NSSocketPort.m,
	* Source/NSURLProtocol.m,
	* Tools/autogsdoc.m:
	Temporary revert David's change to use PRIxPTR, PRIuPTR and
	PRIdPTR. Old compilers don't handled these well. (That change
	didn't have a ChangeLog entry)

2011-08-17  Fred Kiefer <FredKiefer@gmx.de>

	* Source/Additions/GSMime.m: Use specific IMP type for method
	returning BOOL value.

2011-08-17  Niels Grewe <niels.grewe@halbordnung.de>

	* config/objc-common.h: Include stdlib.h for the prototype of calloc().

2011-08-17  Riccardo Mottola <rm@gnu.org>

	* Headers/GSIMap.h
	Additional cast to void* to keep OpenBSD compiler happy.

2011-08-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m:
	Redo fix for incorrect handling of documents with empty headers.

2011-08-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m:
	Revert attempted fix for header end parsing error.

2011-08-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m:
	Attempt fix for recording of excess data in the case where we are
	parsing mime headers only and the headers are incomplete.

2011-08-13 15:28 David Chisnall <theraven@gna.org>

	* libs/base/trunk/Source/NSBundle.m,
	  libs/base/trunk/Source/NSDateFormatter.m,
	  libs/base/trunk/Source/NSLocale.m,
	  libs/base/trunk/Source/NSNumberFormatter.m,
	  libs/base/trunk/Source/NSRegularExpression.m: Fix the build with
	  the pure non-fragile ABI by declaring macros before using them.

2011-08-13 13:28 David Chisnall <theraven@gna.org>

	* libs/base/trunk/config/config.objc.m: Don't assume Object exists
	  in libobjc.

2011-08-11  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSAffineTransform.m (-appendTransform:)
	(-prependTransform:): Fix bug in optimisation code by using a
	local variable.

2011-08-09 08:43 David Chisnall <theraven@gna.org>

	* libs/base/trunk/Source/NSConcreteHashTable.m,
	  libs/base/trunk/Source/NSConcreteMapTable.m: Replace the
	  implementations of NSFastEnumeration in NSConcrete{Hash,Map}Table
	  with ones that work and don't cause people to dereference
	  pointers that are set to random integer values.

2011-08-07 18:00 David Chisnall <theraven@gna.org>

	* libs/base/trunk/Source/NSObject.m: In -finalize, we're pretending
	  to be the Objective-C runtime, so we need to
	  actually use isa directly, rather than the safe version. A better
	  solution
	  would be to call object_dispose(), but this only works for
	  objects created with
	  class_createInstance().

2011-08-07 16:56 David Chisnall <theraven@gna.org>

	* libs/base/trunk/Source/NSObject.m: When calling -.cxx_dealloc,
	  look up the superclass before calling. This method
	  may destroy the receiver's class, if it's a user-generated one,
	  so we can't
	  guarantee that it is valid after the call.

2011-08-05 17:34 David Chisnall <theraven@gna.org>

	* libs/base/trunk/Source/NSNumber.m: Bracket the runtime.h include
	  in a check.

2011-08-03 12:04 David Chisnall <theraven@gna.org>

	* libs/base/trunk/Headers/Foundation/NSRegularExpression.h,
	  libs/base/trunk/Source/NSRegularExpression.m,
	  libs/base/trunk/Source/NSString.m,
	  libs/base/trunk/Tests/base/NSString/regex.m: Clean up
	  NSRegularExpression, so that it compiles without warnings with or
	  without ICU, but we don't pretend that we support things that we
	  don't and silently return nonsense results to make debugging
	  difficult for GNUstep users.

2011-08-03  Fred Kiefer <FredKiefer@gmx.de>

	* Tests/base/NSMutableData/general.m
	* Tests/base/NSData/general.m
	* Tests/base/NSFileManager/unrepresentable_filenames.m
	* Tests/base/NSDate/create.m
	* Tests/base/GSMime/test01.m
	* Tests/base/Functions/runtime.m
	* Tests/base/NSInvocation/general.m
	* Tests/base/KVC/mutable.m
	* Tests/base/KVC/path.m
	* Tests/base/KVC/array.m
	* Tests/base/NSMapTable/create.m
	* Tests/base/NSHashTable/create.m
	* Tests/base/GenericTests/generic.m
	* Tests/base/NSBundle/resources.m: Remove warnings generated by tests.

2011-08-02  Fred Kiefer <FredKiefer@gmx.de>

	* Tests/base/NSJSONSerialization/json.m: Get it compile without
	C99.
	* Tests/base/NSString/regex.m: Use an autorelease pool.

2011-08-02  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSThread.m (GSCurrentThread): Use C string in assert, not
	ObjC string.
	* Headers/Foundation/NSRegularExpression.h: Add the pattern as ivar.
	* Source/NSRegularExpression.m: Rewrite to compile with less
	warnings on systems not supporting ICU.

2011-07-31 16:19 David Chisnall <theraven@gna.org>

	* libs/base/trunk/Headers/Foundation/NSObject.h: Remove the
	  duplicate definition of the NSObject protocol methods in the
	  NSObject class (redundant since they are implicitly added by the
	  class adopting
	  the protocol, and stupid because there was already one
	  copy-and-paste error
	  where they differed slightly). Also replaced all of the
	  references to
	  nonexistent documentation with actual documentation.

2011-07-31 15:31 David Chisnall <theraven@gna.org>

	* libs/base/trunk/Headers/Foundation/NSAutoreleasePool.h,
	  libs/base/trunk/Headers/Foundation/NSException.h,
	  libs/base/trunk/Headers/Foundation/NSObjCRuntime.h,
	  libs/base/trunk/Headers/Foundation/NSObject.h,
	  libs/base/trunk/Source/GSArray.m,
	  libs/base/trunk/Source/GSBlocks.m,
	  libs/base/trunk/Source/GSString.m,
	  libs/base/trunk/Source/NSBundle.m,
	  libs/base/trunk/Source/NSConnection.m,
	  libs/base/trunk/Source/NSDate.m,
	  libs/base/trunk/Source/NSIndexPath.m,
	  libs/base/trunk/Source/NSMessagePort.m,
	  libs/base/trunk/Source/NSNull.m,
	  libs/base/trunk/Source/NSNumber.m,
	  libs/base/trunk/Source/NSPort.m,
	  libs/base/trunk/Source/NSSocketPort.m,
	  libs/base/trunk/Source/NSTimeZone.m,
	  libs/base/trunk/Source/NSURLProtocol.m,
	  libs/base/trunk/Source/NSValue.m: Cleanup:
	  - (void)release;
	  to
	  - (oneway void)release;
	  so everything implementing -release actually implements the one
	  declared in the NSObject protocol.

	  Start marking things that are unavailable in ARC mode as
	  unavailable in ARC mode.

2011-07-26 David Chisnall <theraven@gna.org>
	* Source/NSObject.m:
	Change the order of the retain count and the padding, so the retain count
	is always the word before isa.

	Switch to using the correct kind of alignof (the ABI alignment in
	structures, not the preferred alignment of the type - this stops us from
	allocating 4 bytes of padding on x86-32 where there is no need for any)

	* Source/NSNumber.m:
	Use the small object support in libobjc2 trunk for 31 / 61-bit signed
	NSNumbers on 32 / 64-bit platforms respectively.  Still to do: add an
	NSSmallFloat equivalent for 64-bit platforms, storing a float.

2011-07-26  Quentin Mathe <quentin.mathe@gmail.com>

	* Headers/Foundation/NSObject.h:
	* Headers/Foundation/NSProxy.h:
	* Source/NSProxy.m:
	Fixed missing oneway qualifier on -release return type. Recent Clang
	trunk complains about it.

2011-07-25 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSJSONSerialization.m: Get this file to compile with
	standard gcc settings fro GNUstep.

2011-07-25 15:50  David Chisnall <theraven@gna.org>

	* libs/base/trunk/Headers/Foundation/Foundation.h,
	  libs/base/trunk/Headers/Foundation/NSJSONSerialization.h,
	  libs/base/trunk/Source/GNUmakefile,
	  libs/base/trunk/Source/NSJSONSerialization.m,
	  libs/base/trunk/Tests/base/NSJSONSerialization,
	  libs/base/trunk/Tests/base/NSJSONSerialization/TestInfo,
	  libs/base/trunk/Tests/base/NSJSONSerialization/json.m: Added
	  NSJSONSerialization (10.7) implementation. The code path reading
	  from an NSInputStream is not well tested - please try and break
	  it!

2011-07-25 Fred Kiefer <FredKiefer@gmx.de>

	* libs/base/trunk/Headers/GNUstepBase/GSIMap.h
	(GSIMapAddKeyNoRetain): Correct previous change.

2011-07-24 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSAssertionHandler.m,
	* Headers/GNUstepBase/GSConfig.h.in: Clean up after last commit.
	* Headers/GNUstepBase/preface.h.in: Remove this obsolete file.

2011-07-24 13:09 David Chisnall <theraven@gna.org>

	* Headers/Foundation/NSArray.h,
	  Headers/Foundation/NSDictionary.h,
	  Headers/Foundation/NSEnumerator.h,
	  Headers/Foundation/NSInvocation.h,
	  Headers/GNUstepBase/GSFileHandle.h,
	  Headers/GNUstepBase/GSIMap.h,
	  Headers/GNUstepBase/preface.h.in,
	  Source/Additions/GCDictionary.m,
	  Source/Additions/GSInsensitiveDictionary.m,
	  Source/Additions/GSLock.m,
	  Source/Additions/NSData+GNUstepBase.m,
	  Source/GSArray.m,
	  Source/GSDictionary.m,
	  Source/GSInvocation.h,
	  Source/NSArray.m,
	  Source/NSAssertionHandler.m,
	  Source/NSCharacterSet.m,
	  Source/NSConcreteHashTable.m,
	  Source/NSConcreteMapTable.m,
	  Source/NSConcretePointerFunctions.h,
	  Source/NSConnection.m,
	  Source/NSCountedSet.m,
	  Source/NSData.m, libs/base/trunk/Source/NSDate.m,
	  Source/NSDebug.m,
	  Source/NSDictionary.m,
	  Source/NSDistantObject.m,
	  Source/NSHost.m,
	  Source/NSIndexPath.m,
	  Source/NSInvocation.m,
	  Source/NSKeyValueObserving.m,
	  Source/NSPointerArray.m,
	  Source/NSProcessInfo.m,
	  Source/NSPropertyList.m,
	  Source/NSTimeZone.m,
	  Source/NSValue.m,
	  Source/unix/NSStream.m,
	  Tests/base/NSHashTable/weak.m,
	  Tests/base/NSPointerArray/weak.m: Lots of little
	  fixes to make -base compile with -Werror (now builds without
	  warnings).

	  Richard: I'm unsure about three of these, which were fixes in
	  memset() calls in:
	  - NSConcreteMapTable.m
	  - NSConcreteHashTable.m
	  - Additions/NSData+GNUstepBase.m

	  Please can you check them? I think they are intended to zero the
	  entire object
	  (rather than the first word), but the lack of comments makes me
	  unsure.

	  Most changes were just tweaks to variable types. I've also
	  removed some dead code from NSInvocation. This was small group of
	  things that were marked for internal use only, but not actually
	  referenced in the code anywhere.

	  Other improvements:

	  - NSArray / NSDictionary fixed up to use the 10.7 (ARC-friendly)
	  prototypes.
	  - getObjects:andKeys: implemented for NSDictionary (10.5 method)
	  - NSPointerArray and NSHashTable now properly support weak
	  objects.
	  - Tests for weak objects in collections.

2011-07-23 16:16 David Chisnall <theraven@gna.org>

	* libs/base/trunk/Headers/GNUstepBase/GSIMap.h,
	  libs/base/trunk/Source/NSConcreteMapTable.m,
	  libs/base/trunk/Source/NSConcretePointerFunctions.h,
	  libs/base/trunk/Tests/base/NSMapTable/weak.m: Add support (and
	  test) for weak keys and values in NSMapTable. This support should
	  work in GC mode. It also works if the runtime supports ARC, even
	  if the compiler does not use this support.

2011-07-23 12:19 David Chisnall <theraven@gna.org>

	* libs/base/trunk/Source/NSObject.m: Remove the zone pointer from
	  objects. Now we always query the zones to find the relevant
	  pointer. Zones are still supported, but we now optimise for the
	  case where they are not used.

	  To disable zone support completely, NSAllocateObject() should
	  ignore the zone and NSDeallocateObject() should skip the zone
	  lookup.

2011-07-22 16:07 David Chisnall <theraven@gna.org>

	* libs/base/trunk/Headers/Foundation/NSArray.h,
	  libs/base/trunk/Source/GSArray.m,
	  libs/base/trunk/Source/NSArray.m: Change id* -> id[] for OS X
	  10.7 compatibility in NSArray. This change is required for ARC:
	  now, id* means pointer to a single object, id[] means array.

2011-07-22 14:38 David Chisnall <theraven@gna.org>

	* Source/NSRegularExpression.m:
	Added stub implementation for when GNUstep is built without ICU.

2011-07-20  Eric Wasylishen  <ewasylishen@gmail.com>

	* Source/NSNumberFormatter.m
	(-attributedStringForObjectValue:withDefaultAttributes:):
	Guard against initializing an NSAttributedString with a nil string.

2011-07-20  Eric Wasylishen  <ewasylishen@gmail.com>

	* Source/GSAttributedString.m: Throw an exception if the string object
	passed to -initWithString:attributes: doesn't respond to -length, or if
	it is nil. This is the same behaviour as OS X.
	* Source/NSAttributedString.m (-init): Call -initWithString:attributes:
	with @"" instead of nil, since passing nil now causes an exception
	to be thrown.

2011-07-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Makefile.postamble:
	Install ObjectiveC2 compatibility headers only if that is built (which
	should be only if no 'real' objc2 library is available).
	Also generate an objc/runtime.h header to include objectiveC2/runtime.h
	so that people can just include objc/runtime.h to use the new runtime
	API irrespective of whether the API is provided by the actual runtime
	library or by the compatibility library.

2011-07-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GNUmakefile:
	* Source/GSRunLoopWatcher.h:
	* Source/NSXMLPrivate.h:
	* Source/unix/GSRunLoopCtxt.m:
	* Source/win32/GSFileHandle.m:
	* Source/win32/NSMessagePort.m:
	* Source/win32/GSRunLoopCtxt.m:
	* Source/win32/NSStream.m:
	* Source/common.h:
	* Source/Additions/GSXML.m:
	* Source/Additions/GSFunctions.m:
	* Source/Additions/GSObjCRuntime.m:
	* Source/GSURLPrivate.h:
	* SSL/GSSSLHandle.m:
	* Makefile.postamble:
	* configure.ac:
	* Headers/GNUstepBase/GSConfig.h.in:
	* Headers/GNUstepBase/GSFunctions.h:
	* Headers/GNUstepBase/GSObjCRuntime.h:
	* Headers/Foundation/NSZone.h:
	* Tools/make_strings/make_strings.m:
	* configure: regenerate
	Remove references to obsolete header.

2011-07-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSThread.m: Fix faulty assert.

2011-07-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileHandle.m:
	* SSL/GSSSLHandle.m:
	* Headers/Foundation/NSFileHandle.h:
	Fixup to let certificate information contain a chaing with intermediate
	certificate authorities.  Simplify handshake using common routine for
	non-blocking handshake attempt.

2011-07-11 14:31 David Chisnall <theraven@gna.org>

	* Source/NSAutoreleasePool.m,
	  Source/NSThread.m: Lazily initialize POSIX
	  threads, matching OS X behaviour and stopping us from crashing
	  when calling autorelease from a thread that was not previously
	  registered explicitly (yuck!)

	  Also do some quite hacky (and not totally correct) things to try
	  to make sure that we aren't confused into thinking that the first
	  NSThread is the main thread, if it's created on a separate
	  thread. Currently only supported on FreeBSD and OpenBSD.

2011-07-11 12:36 David Chisnall <theraven@gna.org>

	* Source/NSNumber.m: [NSNumber -init] should not
	  destroy itself when called as [super init]. This behaviour was
	  breaking anything that subclassed NSNumber in user code (e.g.
	  PyObjC).

2011-07-11 Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSLocale.m (GSLanguageFromLocale): Handle local "C.UTF-8"
	correctly. Needed for Cygwin.

2011-07-11 Fred Kiefer <FredKiefer@gmx.de>

	* config/config.ffi.c: Move declaration of g_dbl to begin of
	function.
	Patch by Sebastian Reitenbach <sebastia@l00-bugdead-prods.de>

2011-07-11 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSTimeZone.m (+systemTimeZone): Support the OpenSuse key
	TIMEZONE in /etc/sysconfig/clock.

2011-07-10  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Source/NSObject.m (+zone): Override to ensure that -zone returns
	a valid zone pointer when it is called on a class object.

2011-07-05 Fred Kiefer <FredKiefer@gmx.de>

	* macosx/gnustep.pbproj/project.pbxproj,
	* Tools/make_strings/GNUmakefile.preamble: Remove references to
	obsolete directory Headers/Additions.

2011-07-05 Fred Kiefer <FredKiefer@gmx.de>

	* Headers/GNUstepBase/GNUstep.h: Define the __has_feature macro,
	as this file may be used without preface.h being included first.
	Fixes bug #33708. Patch by Tim Kack <timkack@gmail.com>.

2011-07-04 11:31 David Chisnall <theraven@gna.org>

	* Source/NSObject.m:
	  Switch the order of the reference count and the zone so that the
	  reference count (in reference counted mode) is always immediately in
	  front of the object. Please test this!!

	  Opt NSObject into the fast path for ARC. ARC will now not call
	  the retain / release / autorelease methods on NSObject or any
	  classes that inherit their implementation of these methods from
	  NSObject. In quick and dirty testing, this gives about a 10-20%
	  speedup.

2011-06-30 14:44 David Chisnall <theraven@gna.org>

	* Headers/Foundation/NSArray.h,
	  Headers/Foundation/NSProxy.h,
	  Headers/GNUstepBase/GSVersionMacros.h,
	  Headers/GNUstepBase/preface.h.in,
	  Source/NSProxy.m: Rewrote NSProxy's -retain /
	  -release to be the same as NSObject, not its own ad-hoc thing.

	  Added declaration of __bridge for use in non-ARC mode.

	  Tweaked arrayWithObjects:count: to take a const id* parameter, to
	  avoid ARC
	  treating it as a write-back parameter.

2011-06-29 15:21 David Chisnall <theraven@gna.org>

	* Headers/Foundation/NSNotification.h,
	  Headers/Foundation/NSZone.h,
	  Headers/GNUstepBase/preface.h.in,
	  Tools/make_strings/make_strings.m: More ARC
	  fixes. We don't want to be using __strong void* in ARC mode (it
	  only makes sense in GC mode and is invalid in ARC mode).

2011-06-29 13:13  David Chisnall <theraven@gna.org>

	* Source/NSObject.m: Add support to NSObject for
	  automatically zeroing __weak references when using ARC.

2011-06-29 11:50  David Chisnall <theraven@gna.org>

	* Headers/Foundation/NSAutoreleasePool.h,
	  Headers/Foundation/NSEnumerator.h,
	  Headers/Foundation/NSException.h,
	  Headers/Foundation/NSZone.h,
	  Headers/GNUstepBase/preface.h.in:
	  ARC-compatibility tweaks in the headers. ARC will not track
	  objects inside structures and rejects code that uses object types
	  that are not __unsafe_unretained qualified inside structures.

	  This quick fix just added this type qualifier on all such
	  structures. Several of these should probably not be in headers at
	  all.

2011-06-26  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Source/NSString.m(-_getStart:end:contentsEnd:forRange:lineSep:,
	-getLineStart:end:contentsEnd:forRange:,
	-getParagraphStart:end:contentsEnd:forRange):
	Fix implementation of getParagraphStart:end:contentsEnd:forRange:.

2011-06-26  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* configure.ac:
	* config/config.ffi.c (cls_struct_combined_fn): Fix the broken
	test whether libffi works. The test program always failed, but
	this failure was masked by an incorrect use of AC_TRY_RUN.

	* configure: Regenerated.

2011-06-23 Fred Kiefer <FredKiefer@gmx.de>

	* Headers/Foundation/NSBundle.h,
	* Source/NSBundle.m: Add a few 10.6 NSURL methods.
	Based on patch by julian.

2011-06-20  Sebastian Reitenbach <sebastia@l00-bugdead-prods.de>

	* SSL/GSSSLHandle.m:
	* Headers/GNUstepBase/GSFileHandle.h:
	Avoid compiler warnings

2011-06-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Keep zombie working until after atext stuff has
	run.
	* Source/NSUserDefaults.m: fix possible deref of nul pointer.
	* Source/Additions/NSObject+GNUstepBase.m:
	* Headers/GNUstepBase/NSObject+GNUstepBase.h:
	Make clanup code a bit more flexible by allowin different cleanup
	methods to be registered.

2011-06-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/GNUstepBase/NSObject+GNUstepBase.h:
	* Source/Additions/NSObject+GNUstepBase.m:
	* Source/NSArray.m:
	* Source/NSNotificationCenter.m:
	* Source/NSObject.m:
	* Source/NSString.m:
	* Source/NSTimeZone.m:
	* Source/NSUserDefaults.m:
	* Source/NSValue.m:
	More leak cleanup.

2011-06-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/GNUstepBase/NSObject+GNUstepBase.h:
	* Source/Additions/NSObject+GNUstepBase.m:
	Add new category with methods for cleanup of long-lived data structures
	on process exit.
	* Source/NSObject.m: Check GNUSTEP_SHOULD_CLEAN_UP environment variable
	and call +shouldCleanUp: if it is set.
	* Documentation/Base.gsdoc: Document new environment variable.
	* Source/GSLocale.m:
	* Source/NSDistributedNotificationCenter.m:
	* Source/NSUserDefaults.m:
	* Source/NSNotificationCenter.m:
	* Source/GSPrivate.h:
	* Source/externs.m:
	* Source/NSString.m:
	Add some cleanup support.

	Classes may perform cleanup in a +atExit method which is automatically
	called on process exit.
	Classes may use [NSObject+leak:] to 'leak' an object so that it is
	retained for the life of the process, but released immediately before
	the +atExit methods are called if GNUSTEP_SHOULD_CLEAN_UP is YES.
	See the NSObject(AtExit) category documentation for details.

2011-06-18  Sebastian Reitenbach <sebastia@l00-bugdead-prods.de>

	* Source/NSObject.m: fix for clang
	* SSL/GNUmakefile: don't link libobjc ... depend on gnustep-make

2011-06-18  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSURL.h:
	* Source/NSURL.m: more 10.6 methods

2011-06-17  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSXMLParser.m: Fix error with whitespace at end of attributes.
	* Headers/GNUstepBase/NSURL+GNUstepBase.h: Add method to build a URL
	from separate components.
	* Headers/Foundation/NSURL.h: Add some OSX 10.6 methods for path
	handling, and incorporate documentation from source file.
	* Source/NSURL.m: Add some OSX 10.6 methods for path handling, fix
	minor bug checking resource availability, and move documentation to
	header.
	* Source/Additions/NSURL+GNUstepBase.m: Add method to build a URL from
	components.
	We NEED testcases for these.

2011-06-13 Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSAvahiRunLoopIntegration.m: Declare the local methods in
	the interface.
	Patch by Sebastian Reitenbach <sebastia@l00-bugdead-prods.de>

2011-06-11 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSDateFormatter.m,
	* Source/NSTimeZone.m,
	* Source/NSCalendar.m: Protect the name id.
	Patch by Sebastian Reitenbach <sebastia@l00-bugdead-prods.de>

2011-06-09  Richard Frith-Macdonald <rfm@gnu.org>

	* configure: Regenerate
	* config.mak.in:
	* configure.ac:
	* Source/Makefile.preamble:
	* Tools/Makefile.postamble:
	* Tools/Makefile.preamble:
	Add --with-gdomap-port= to specify an alternative port

2011-06-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSLock.m:
	Remove notification observation on dealloc.

2011-06-04  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/Foundation/NSURL.h,
	* Source/NSURL.m: Add -checkResourceIsReachableAndReturnError:

2011-06-03  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Source/NSString.m: [(-getLineStart:end:contentsEnd:forRange:)]
	Fix off-by-one error in reported contents end for DOS style lines.

2011-06-02 Riccardo Mottola <rm@gnu.org>

	* Source/NSTimeZone.m: Disable use of tzname on OpenBSD too.

2011-06-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSTimeZone.m: Allow for quotes around zone name in
	/etc/sysconfig/time on redhat/centos.

2011-06-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSTimeZone.m: Disable use of tzname on FreeBSD as it's not
	fully implemented there.  Add a couple of new mechanisms for
	guessing the timezone on debina and redhat.

2011-06-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSString.h: Add explicit warnings about OSX
	compatible modifications to values returned by path methods.
	* Source/NSTimeZone.m: Don't guess at tzname[0] if the value of
	daylight shows it's not valid.

2011-05-31  Niels Grewe <niels.grewe@halbordnung.de>

	* Source/NSCallBacks.h: Adjust callback prototypes to use
	NSUInteger.

2011-05-31  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/GNUstepBase/GNUstep.h:
	Deprecate autorelease pool macros and make them always create the
	pool.

2011-05-31  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSHashTable.h:
	* Headers/Foundation/NSMapTable.h:
	* Source/Additions/GSMime.m:
	* Source/Additions/GSXML.m:
	* Source/GSAvahiNetService.m:
	* Source/NSCallBacks.m:
	* Source/NSConcreteHashTable.m:
	* Source/NSConcreteMapTable.m:
	* Source/NSConnection.m:
	* Source/NSMessagePort.m:
	* Source/NSSocketPort.m:
	* Source/NSTask.m:
	* Source/NSTimeZone.m:
	* Source/unix/GSRunLoopCtxt.m:
	* Source/win32/GSRunLoopCtxt.m:
	Update to use new NSInteger... callback names rather than NSInt...
	for compatibility with OSX
	* Source/NSNotificationCenter.m: revert/rewrite recent GC changes to
	simplify code and preprocessor conditionals and to avoid overheads
	of using a class as an observation except for GC with cland/libobc2.
	Is it really needed even then?  I guess it would be if we weren't
	using the Boehm GC library, and were stuck with a GC system which
	didn't support zeroing weak pointers in unscanned memory.

2011-05-29  Richard Frith-Macdonald <rfm@gnu.org>

	* configure.ac: Fix broken atomic ops again.
	* configure: regenerate

2011-05-30 11:40  David Chisnall <theraven@gna.org>

	* Source/NSData.m:
	Add a couple of __strong annotations to pointers. Any non-id pointer
	that can store GC'd memory must be __strong. Currently, this annotation
	is largely ignored, because the runtime is a lot more lax about what
	may store pointers than Apple's, but this will be tightened up in the
	future.

2011-05-28  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSNotificationCenter.m,
	* Source/NSUserDefaults.m: Remove compiler warnings.

2011-05-28 18:05  David Chisnall <theraven@gna.org>

	* Source/NSPointerArray.m:
	Make NSPointerArray insert the correct read / write barriers in GC mode.
	* Source/NSConcretePointerFunctions.h:
	Add some helper functions to NSConcretePointerFunctions.h that make it
	easier to do this in the other collections that need to support GC.

2011-05-28  Eric Wasylishen  <ewasylishen@gmail.com>

	* configure.ac: Tweak atomic ops detection
	* Sourcen/NSObject.m: Re-enable atomic ops

2011-05-28 14:51 David Chisnall <theraven@gna.org>

	* Source/NSAutoreleasePool.m,
	* Source/NSObject.m,
	* Source/NSZone.m:
	First pass at hybrid GC mode.  This will try use retain-release mode if
	the collector is not running. Code will run in retain/release mode
	unless something compiled with -fobjc-gc-only is loaded.

2011-05-28  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSString.m (-initWithFormat:locale:): Make sure va_end()
	gets called.
	Patch by Stefan Bidigaray <stefanbidi@gmail.com>.

2011-05-28 12:49  David Chisnall <theraven@gna.org>

	* Source/NSNotificationCenter.m:
	__weak is only allowed on ivars and globals, so we need to turn the
	Observation structure into a class.

2011-05-28  Niels Grewe <niels.grewe@halbordnung.de>

	* Source/NSObject.m: Disable atomic ops detection for the time being.

2011-05-27 11:48  David Chisnall <theraven@gna.org>

	* Source/NSAutoreleasePool.m:
	Make -drain and -release in NSAutoreleasePool do the same thing (rather
	than one calling the other) in non-GC mode.

	* Source/Additions/GSMime.m,
	* Source/Additions/GSObjCRuntime.m,
	* Source/Additions/NSCalendarDate+GNUstepBase.m,
	* Source/Additions/NSData+GNUstepBase.m,
	* Source/NSBundle.m,
	* Source/NSConnection.m,
	* Source/NSDebug.m,
	* Source/NSDistributedNotificationCenter.m,
	* Source/NSException.m,
	* Source/NSFileManager.m,
	* Source/NSKeyedArchiver.m,
	* Source/NSLog.m,
	* Source/NSMessagePort.m,
	* Source/NSMessagePortNameServer.m,
	* Source/NSPort.m,
	* Source/NSProcessInfo.m,
	* Source/NSRunLoop.m,
	* Source/NSTask.m,
	* Source/NSTimeZone.m,
	* Source/NSUserDefaults.m,
	* Tools/AGSHtml.m,
	* Tools/AGSIndex.m,
	* Tools/AGSOutput.m,
	* Tools/AGSParser.m,
	* Tools/HTMLLinker.m,
	* Tools/gspath.m
	* Tools/pl.m:
	Replace all -release messages sent to autorelease pools with -drain. In
	non-GC mode, these are equivalent.
	In GC mode, these trigger a collection.

2011-05-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Remove useless leftover #define.
	* configure.ac: Get -march flag passed to build process
	* configure: regenerate

2011-05-26  Niels Grewe <niels.grewe@halbordnung.de>

	* configure.ac: Add test to check for availability of atomic builtins.
	* configure: Regenerate.
	* Headers/GNUstepBase/config.h.in: Regenerate.
	* Source/NSObject.m: Fix typo.

	Attempt to set the compiler and linker flags needed to enable compiler
	intrinsics for atomic operations on platforms where those are available.

2011-05-26 18:29  David Chisnall <theraven@gna.org>

	* Source/simple-load.h:
	Use RTLD_NOLOAD, if it's supported.

2011-05-26 13:24  David Chisnall <theraven@gna.org>

	* Headers/Foundation/NSNotification.h,
	* Source/Additions/GSLock.m,
	* Source/Additions/GSObjCRuntime.m,
	* Source/Additions/Unicode.m,
	* Source/GSString.m,
	* Source/NSThread.m,
	* Source/NSZone.m:
	  More GC fixes. Most notably,
	  mark the thread object as not collectable, since it's hidden away
	  in TLS where the GC can't find it.

2011-05-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m:
	Further tweak of atomic assembly code ... don't really know what I'm
	doing here ... perhaps theoriginal author (mostly David?) knows more
	about this assmebly stuff and implementation of atomic primitives on
	different architectures?

2011-05-25 11:15  David Chisnall <theraven@gna.org>

	* Headers/Foundation/NSZone.h,
	* Source/GSString.m,
	* Source/NSData.m,
	* Source/NSMethodSignature.m,
	* Source/NSNotificationCenter.m,
	* Source/NSObject.m,
	* Source/NSZone.m:
	More tweaks for garbage collection mode, including making
	NSNotificationCenter use weak pointers (things are never removed if it
	uses strong pointers because they remove themselves in the -dealloc
	method, which is never called, and can't remove themselves in the
	-finalize method because the -finalize method would not be called
	until after they have been removed - this is consistent with Apple
	behaviour).
	Gorm now works correctly when built with GC enabled.

2011-05-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m:
	Attempt fix for atomic assembler on x86 (bug #33392)

2011-05-24 David Chisnall <theraven@gna.org>

	* Source/NSBundle.m
	* Source/NSGarbageCollector.m
	* Source/NSKeyValueObserving.m
	* Source/NSZone.m
	* Source/NSObject.m
	* Source/NSAutoreleasePool.m
	First pass at supporting fully Apple-compatible GC in -base.
	Code sitting
	on top of -base should not require modifying (in theory, at least, and
	unless it does the sort of evil tricks that LanguageKit does for
	performance).

2011-05-24  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSAutoreleasePool.m:
	Try to better cope with bad code which leaks autorelease pools.
	1. check number of pools in thread when creating a new one, and
	raise an exception if too many are created.
	2. when deallocating a pool, avoid recursively deallocating child
	pools so that a large number of pools won't cause stack overflow.

2011-05-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSBundle.m:
	Fix to resolve links and standardize path to current executable.

2011-05-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m:
	Fixes for encoding quoted-printable document body content.

2011-05-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPortCoder.m:
	* Source/NSMethodSignature.m:
	* Source/GSFFCallInvocation.m:
	* Source/GSFFIInvocation.m:
	* Source/NSUnarchiver.m:
	* Source/NSCoder.m:
	* Source/cifframe.m:
	* Source/Additions/GSObjCRuntime.m:
	* Source/NSConnection.m:
	* Source/NSData.m:
	* Source/NSObjCRuntime.m:
	* Source/NSArchiver.m:
	Fixup objc header includes for gcc-4.6

2011-05-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSFileHandle.m:
	* Source/GSHTTPURLHandle.m:
	* Source/win32/NSMessagePort.m:
	* Source/win32/NSMessagePortNameServer.m:
	Include/use errno.h for thread-safe errno support.

2011-05-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPortCoder.m:
	* Source/GSConcreteValueTemplate.m:
	* Source/GSFFCallInvocation.m:
	* Source/NSKeyedUnarchiver.m:
	* Source/GSFFIInvocation.m:
	* Source/NSUnarchiver.m:
	* Source/NSCoder.m:
	* Source/NSURL.m:
	* Source/cifframe.m:
	* Source/NSConnection.m:
	* Source/NSData.m:
	* Source/NSObjCRuntime.m:
	* Source/GSValue.m:
	* Source/NSValue.m:
	* Source/NSArchiver.m:
	updates for old/new objc api change.

2011-05-12  Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSArray.m: Fix keyed decoding for GSMutableArray and
	GSPlaceholderArray.

2011-05-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSXMLParser.m: treat unknown/undefined encodings as utf-8
	so we tolerate bad xml documents better.

2011-05-02  Eric Wasylishen  <ewasylishen@gmail.com>

	* Source/Additions/GSObjCRuntime.m (GSSelectorFromNameAndTypes):
	With gcc 4.6 libobjc, GSSelectorFromNameAndTypes was calling some
	functions like sel_get_any_typed_uid that were not declared (they're
	declared in objc/objc-api.h which cannot be imported). I had to copy
	over these function declarations, otherwise incorrect function calls
	are generated which corrupt selectors (at least on x86-64).

2011-05-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSNumberFormatter.m: Fix broken copying of formatters,
	cleanup/simplify decoding, cleanup/simplify by removif macros.

2011-04-30  Quentin Mathe <quentin.mathe@gmail.com>

	* Tools/autogsdoc.m: Fixed OrderedSymbolDeclarations.plist content to
	take in account that existing .gsdoc files are usually not regenerated.
	We now create the plist by merging it with the previously output plist
	file.

2011-04-26  Eric Wasylishen  <ewasylishen@gmail.com>

	* Source/NSNumberFormatter.m: Move the body of -init to a method called
	-_NSNumberFormatterInit, and call this in -initWithCoder: so that
	instances created with -initWithCoder: are initialized correctly.

2011-04-26  Eric Wasylishen  <ewasylishen@gmail.com>

	* Headers/Foundation/NSObjCRuntime.h: Add CGFLOAT_MIN and CGFLOAT_MAX

2011-04-14  Adam Fedor  <fedor@gnu.org>

	* VERSION: Bump version

2011-04-14  Adam Fedor  <fedor@gnu.org>

	* Version 1.22.0

2011-04-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSObjCRuntime.m (GSSelectorFromNameAndTypes):
	Comment out case for __GNU_LIBOBJC__ to avoid breakage with gcc-4.6
	* Source/NSPathUtilities.m: Minor tweak for running testcases.
	* Tests/base/NSBundle/resources.m:
	* Tests/base/NSBundle/basic.m:
	Skip gnustep library bundle tests if not installed.
	* Tests/base/NSNumberFormatter/basic.m:
	Changed a test to a hope for the next release

2011-04-10  Quentin Mathe <quentin.mathe@gmail.com>

	* Tools/AGSOutput.m (-fitWords:from:to:maxSize:output:): Ensure all
	paragraphs are output in the same way. Each paragraph starts on a new
	line now, which results in a GSDoc output that looks a bit better and
	is easier to parse.

2011-04-09  Nicola Pero  <nicola.pero@meta-innovation.com>

	* Source/Additions/GSObjCRuntime.m (GSSelectorFromNameAndTypes):
	Uncommented case for __GNU_LIBOBJC__.

2011-04-09  Nicola Pero  <nicola.pero@meta-innovation.com>

	* configure.ac: Updated the checks to enable native Objective-C
	exceptions.  If native exceptions were enabled in gnustep-make -
	because the compiler supports them -, but are disabled here
	because there is no uncaught exception handler in the runtime,
	print an explanation without aborting; we now disable them via
	base.make.
	* configure: Regnerated.
	* base.make.in: Set USE_OBJC_EXCEPTIONS to no if we disabled
	native exceptions when configuring.

2011-04-09  Nicola Pero  <nicola.pero@meta-innovation.com>

	* Tests/GNUmakefile: Updated comments.

2011-04-08  Nicola Pero  <nicola.pero@meta-innovation.com>

	* Tests/GNUmakefile: Include rules.make instead of test-tool.make.
	(TOP_DIR): Define using ':=' instead of '='.
	(TEST_TOOL_NAMES): Variable removed.

2011-04-08  Nicola Pero  <nicola.pero@meta-innovation.com>

	* Tools/pl2link.m (main): Fixed determining the installation
	location with the current filesystem layout (Problem reported by
	"Philippe Roussel" <p.o.roussel@free.fr>).

2011-04-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m: Fix failure to connect to mail server.

2011-04-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSNmberFormatter.m: Tweak macros to avoid compiler warnings.

2011-04-07  Chris Armstrong <carmstrong@fastmail.com.au>

	* Source/NSFileManager.m: Fix bug creating intermediary directories.
	* Tests/base/NSFileManager/general.m: Add test for whether intermediary
	directories are created.

2011-04-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSparser.m: ignore __attribute__ in declarator to fix bug
	#33008

2011-04-05  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Tests/base/coding/decoding.m: Fix bogus byte swap code for
	big-endian hosts.

2011-04-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Attempt to fixup C++ constructor/destructor
	handling to work for all setups.

2011-04-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSTimeZone.m: on mingw release self and return nil if
	initialiser can't find named timezone.

2011-04-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSBundle.m: ([+initialize]) change to use 'right' path
	handling so that our core paths are established correctly even if
	an app has set the wrong path handling mode for the currenty platform.
	* Tests/base/NSURL/basic.m:
	* Tests/base/NSString/test02.m:
	Fix path portability bugs in tests.

2011-04-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSThread.m: fix leak spotted by Fred.

2011-04-03  Sebastian Reitenbach <sebastia@l00-bugdead-prods.de>

	* Source/GNUmakefile:
	* Source/NSObject.m:
	* Source/NSTask.m:
	Tweaks for OpenBSD build

2011-04-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/unix/GSRunLoopCtxt.m:
	* Source/win32/GSRunLoopCtxt.m:
	Fix pointer ownership issue in callbacks in GC environment so we let
	the garbage collector handle watchers rather than trying to free them
	explicitly when we shouldn't.

2011-04-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Fix problem with finalization of proxies and
	remove obsolete runtime call to see if a class respons to selector.

2011-03-31 Riccardo Mottola <rm@gnu.org>

	* Source/ObjectiveC2/Makefile.preamble
	Add directory of the local headers.

2011-03-31  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/unicode/gsm0338.h:
	Fix error mapping capital C-cedilla.

2011-03-29  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/GNUstepBase/GSUnion.h: Remove problematic types.
	* Source/unix/Makefile.preamble: Remove unused include directory
	* Source/win32/Makefile.preamble: ditto
	* Source/ObjectiveC2/Makefile.preamble: ditto
	* Source/Additions/Makefile.preamble: ditto
	* Source/Additions/Makefile.postamble: link to extra headers for apple
	so we can build the additons library on a pure apple system again.

2011-03-29  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/GNUstepBase/GSIMap.h:
	* Headers/GNUstepBase/GSUnion.h:
	* Source/GSAttributedString.m:
	* Source/NSArchiver.m:
	* Source/NSConnection.m:
	* Source/NSKeyedArchiver.m:
	* Source/NSNotificationCenter.m:
	* Source/NSPortCoder.m:
	* Source/NSSerializer.m:
	Fixes for problem spotted by David Chisnall ... on a 64bit system where
	the size of an integer is not the same as the size of a pointer the
	union holding map keys and values will have undefined content if we
	assign an integer to it and then use it as a pointer!
	So, we change to use the .nsu accessor for a pointer sized integer
	throughout, and we remove all the odd sized union members.

2011-03-28 Riccardo Mottola <rm@gnu.org>

	* Source/NSPathUtilities.m:
	safer and more portable pointer access

	* Headers/Foundation/NSNetServices.h
	Remove forward protocol declarations as they break gcc 2.95.

2011-03-24  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSAutoreleasePool.m: Clarify/add to comments about linked
	list operation and remove redundant/useless line of code.

2011-03-23  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSNumberFormatter.m (-stringForObjectValue:): Swapped a
	few lines of fraction handling code to get the test suite to pass.

2011-03-22  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Source/NSObject.m (-methodSignatureForSelector:): Get method
	right again in case the method is called on a class object and the
	old runtime is used.

2011-03-21 Riccardo Mottola <rm@gnu.org>

	* Tests/base/NSNumberFormatter/basic.m:
	Added new test.

2011-03-18  Nicola Pero  <nicola.pero@meta-innovation.com>

	* Documentation/GNUmakefile (CODING-STANDARDS_TEXI_FILES,
	CODING-STANDARDS_DOC_INSTALL_DIR, CODING-STANDARDS_TEXT_MAIN):
	Removed.
	(DOCUMENT_TEXT_NAME, TOP_DOC_FILES): Fixed names of files to
	generate; for example, INSTALL instead of install.

2011-03-18 Riccardo Mottola <rm@gnu.org>

	* Source/NSSortDescriptor.m:
	Use Cocoa values for the coding keys.

2011-03-18  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSObjCRuntime.m: Use old API to work around bug in
	current sel_registerTypedName().
	* Source/GSFFIInvocation.m: Use sel_getTypedName() to safely get a
	typed selector.

2011-03-17  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Source/NSProcessInfo.m (_gnu_process_args): Use C runtime system
	functions to access command line arguments and the environment
	under Darwin/Mac OS X.

	* configure.ac: Add special case to disable fake-main by default
	on Darwin/OS X.

	* configure: Regenerated.

2011-03-17 15:02  David Chisnall <theraven@gna.org>

	* Source/NSObject.m: Correctly call C++
	  constructors / destructors for C++ 'objects' in ObjC++ ivars.

2011-03-16  Richard Frith-Macdonald <rfm@gnu.org>

	* NSTimeZones/NSTimeZones.tar: regenerated wityh latest zone info.
	* Tests/base/NSCalendarDate: Updated to use standardised locale

2011-03-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSThread.m: Make +initialize thread safety warning optional
	(disabled using GSSilenceInitializeWarning user default) and more
	informative.

2011-03-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSNumberFormatter.m: Padding for fractional part comes at the
	start rather than at the end.

2011-03-14  Stefan Bidigaray <stefanbidi@gmail.com>

	* Source/NSNumberFormatter.m (-getObjectValue:forString:errorDescription:):
	Add implementation.

2011-03-14  Stefan Bidigaray <stefanbidi@gmail.com>

	* Source/NSNumberFormatter.m (-getObjectValue:forString:range:error:):
	Added implementation.
	* Headers/NSNumberFormatter.h: Fixed a couple of typos.

2011-03-14  Nicola Pero  <nicola.pero@meta-innovation.com>

	* Resources/GNUmakefile
	(base-resources_RESOURCE_FILES_INSTALL_DIR): Removed.

2011-03-13  Richard Frith-Macdonald <rfm@gnu.org>

	* configure.ac:
	* configure:
	* Headers/Additions/GNUstepBase:
	* Headers/Additions/GNUstepBase/Additions.h:
	* Headers/Additions/GNUstepBase/config.h.in:
	* Headers/Additions/GNUstepBase/.cvsignore:
	* Headers/Additions/GNUstepBase/CXXException.h:
	* Headers/Additions/GNUstepBase/DistributedObjects.h:
	* Headers/Additions/GNUstepBase/GCObject.h:
	* Headers/Additions/GNUstepBase/GNUstep.h:
	* Headers/Additions/GNUstepBase/GSBlocks.h:
	* Headers/Additions/GNUstepBase/GSConfig.h.in:
	* Headers/Additions/GNUstepBase/GSFileHandle.h:
	* Headers/Additions/GNUstepBase/GSFunctions.h:
	* Headers/Additions/GNUstepBase/GSIArray.h:
	* Headers/Additions/GNUstepBase/GSIMap.h:
	* Headers/Additions/GNUstepBase/GSLocale.h:
	* Headers/Additions/GNUstepBase/GSLock.h:
	* Headers/Additions/GNUstepBase/GSMime.h:
	* Headers/Additions/GNUstepBase/GSObjCRuntime.h:
	* Headers/Additions/GNUstepBase/GSUnion.h:
	* Headers/Additions/GNUstepBase/GSVersionMacros.h:
	* Headers/Additions/GNUstepBase/GSXML.h:
	* Headers/Additions/GNUstepBase/NSArray+GNUstepBase.h:
	* Headers/Additions/GNUstepBase/NSAttributedString+GNUstepBase.h:
	* Headers/Additions/GNUstepBase/NSBundle+GNUstepBase.h:
	* Headers/Additions/GNUstepBase/NSCalendarDate+GNUstepBase.h:
	* Headers/Additions/GNUstepBase/NSData+GNUstepBase.h:
	* Headers/Additions/GNUstepBase/NSDebug+GNUstepBase.h:
	* Headers/Additions/GNUstepBase/NSFileHandle+GNUstepBase.h:
	* Headers/Additions/GNUstepBase/NSLock+GNUstepBase.h:
	* Headers/Additions/GNUstepBase/NSMutableString+GNUstepBase.h:
	* Headers/Additions/GNUstepBase/NSNetServices+GNUstepBase.h:
	* Headers/Additions/GNUstepBase/NSNumber+GNUstepBase.h:
	* Headers/Additions/GNUstepBase/NSObject+GNUstepBase.h:
	* Headers/Additions/GNUstepBase/NSProcessInfo+GNUstepBase.h:
	* Headers/Additions/GNUstepBase/NSStream+GNUstepBase.h:
	* Headers/Additions/GNUstepBase/NSString+GNUstepBase.h:
	* Headers/Additions/GNUstepBase/NSTask+GNUstepBase.h:
	* Headers/Additions/GNUstepBase/NSThread+GNUstepBase.h:
	* Headers/Additions/GNUstepBase/NSURL+GNUstepBase.h:
	* Headers/Additions/GNUstepBase/preface.h.in:
	* Headers/Additions/GNUstepBase/Unicode.h:
	* Headers/GNUstepBase:
	* Headers/GNUstepBase/config.h.in:
	* Headers/ObjectiveC2:
	* Headers/ObjectiveC2/Availability.h:
	* Headers/ObjectiveC2/blocks_runtime.h:
	* Headers/ObjectiveC2/capabilities.h:
	* Headers/ObjectiveC2/runtime.h:
	* Makefile.postamble:
	* Source/DocMakefile:
	* Source/GNUmakefile:
	* Source/Makefile.postamble:
	* Source/Makefile.preamble:
	* Source/ObjectiveC2/Availability.h:
	* Source/ObjectiveC2/blocks_runtime.h:
	* Source/ObjectiveC2/capabilities.h:
	* Source/ObjectiveC2/caps.c:
	* Source/ObjectiveC2/GNUmakefile:
	* Source/ObjectiveC2/NSBlocks.m:
	* Source/ObjectiveC2/runtime.h:
	* SSL/Makefile.preamble:
	* Tests/GNUmakefile:
	* Tools/Makefile.preamble:
	Simplify header layout.

2011-03-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/CXXException.m: fix error in include
	* Tests/GNUmakefile: add info for testing local copy of library

2011-03-13  Richard Frith-Macdonald <rfm@gnu.org>

	* configure.ac:
	* configure:
	* config.mak.in:
	* Source/GNUmakefile:
	* Headers/Additions/GNUstepBase/config.h.in:
	Add config check for blocks support.
	* Source/NSObject.m:
	* Source/ObjectiveC2/blocks_runtime.m:
	Fixups for mingw

2011-03-12  Stefan Bidigaray <stefanbidi@gmail.com>

	* Source/NSNumberFormatter.m: Cache property values and reset them
	along with the formatter.
	* Source/NSLocale.m: Add 2 missing unlocks.

2011-03-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSBlocks.m: Added header
	* Headers/Additions/GNUstepBase/GSBlocks.h: Added header
	* Headers/Foundation/NSRegularExpression.h: Added header
	Added missing copyright headers etc.

2011-03-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: Fix bug in resetting ... was ending up
	with an immutable dictionary for the registration domain.
	* Source/NSObject.m: fix references to isa.
	* Source/NSPropertyList.m: Fix unused increments.
	* Source/NSRunLoop.m: Remove unused code.
	* Source/NSSocketPort.m: Remove unused code.
	* Source/NSSocketPortNameServer.m: Remove unused code.
	* Source/NSTimeZone.m: Fix unused increment.
	* Source/NSUnarchiver.m: Fix unused assignment.

2011-03-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSAttributedString.m: remove unused assignment
	* Source/GSFormat.m: remove unused increments
	* Source/GSHTTPAuthentication.m: remove unused assignment, fix possible
	use of nil as a dictionary key.
	* Source/GSHTTPURLHandle.m: remove unused assignment, check length.
	* Source/GSSocketStream.m: remove unused assignments
	* Source/GSString.m: remove unused assignments
	* Source/NSAttributedString.m: (-description) fix leak
	* Source/NSAutoreleasePool.m: tweak for clang static analyser
	* Source/NSBundle.m: fix memory leak
	* Source/NSCachedURLResponse.m: fix error in -copy
	* Source/NSCalendarDate.m: remove unused increments.
	* Source/NSDate.m: fix parsing string with ordering too long
	* Source/NSHTTPCookie.m: remove unused assignments
	* Source/GSMime.m: fix unused assignments
	* Source/NSInvocation.m: remove unused code
	* Source/unix/NSStream.m: remove unused ivar
	* Tools/gdomap.c: remove unused code

2011-03-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSInternal.h:
	* Source/NSDateFormatter.m:
	* Source/NSNumberFormatter.m:
	Fix for object copying in non-fragile-ivar build spotted by
	Chris Armstrong.

2011-03-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSObjCRuntime.m:
	* Source/Additions/GSXML.m:
	* Source/Additions/NSData+GNUstepBase.m:
	* Source/Additions/NSError+GNUstepBase.m:
	* Source/Additions/Unicode.m:
	* Source/dld-load.h:
	* Source/GSFormat.m:
	* Source/GSMDNSNetServices.m:
	* Source/GSSocketStream.m:
	* Source/GSValue.m:
	* Source/NSArchiver.m:
	* Source/NSCalendarDate.m:
	* Source/NSData.m:
	* Source/NSDebug.m:
	* Source/NSFileManager.m:
	* Source/NSHost.m:
	* Source/NSInvocation.m:
	* Source/NSKeyValueCoding.m:
	* Source/NSMessagePort.m:
	* Source/NSMessagePortNameServer.m:
	* Source/NSMethodSignature.m:
	* Source/NSObject.m:
	* Source/NSPathUtilities.m:
	* Source/NSPortCoder.m:
	* Source/NSProcessInfo.m:
	* Source/NSString.m:
	* Source/NSTask.m:
	* Source/NSTimeZone.m:
	* Source/NSUnarchiver.m:
	* Source/NSURL.m:
	* Tools/cvtenc.m:
	* Tools/defaults.m:
	* Tools/locale_alias.m:
	Avoid strcpy and strcat to get rid if some bsd warnings.

2011-03-06  Richard Frith-Macdonald <rfm@gnu.org>

	* config/config.initialize.m: Correct formatting.  Increase time
	allowed for threads to do their job, to minimise the chance of a
	heavily loaded machine giving a wrong result because threads
	don't get scheduled in time.
	* configure.ac: check for stck return address extraction
	* configure: regenerate
	* Headers/Additions/GNUstepBase/config.h.in: regenerate
	* Source/NSDebug.m: use function to get return address.

2011-03-06 Thomas Gamper <icicle@cg.tuwien.ac.at>

	* config/config.initialize.m: add missing include to fix build.
	Use correct thread handles, adapt sleep times to worst case.
	Remove C99-ism.

2011-03-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSThread.m: remove obsolete call to objc_set_thread_callback().
	* Source/NSDebug.m: Try to improve getting return addresses from stack.

2011-03-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSInternal.h:
	* Source/NSDateFormatter.m:
	* Source/NSNumberFormatter.m:
	* Headers/Foundation/NSPortCoder.h:
	* Headers/Foundation/NSCache.h:
	* Headers/Foundation/NSSpellServer.h:
	* Headers/Foundation/NSDecimalNumber.h:
	* Headers/Foundation/NSBundle.h:
	* Headers/Foundation/NSTimer.h:
	* Headers/Foundation/NSScanner.h:
	* Headers/Foundation/NSDistributedNotificationCenter.h:
	* Headers/Foundation/NSComparisonPredicate.h:
	* Headers/Foundation/NSUndoManager.h:
	* Headers/Foundation/NSDateFormatter.h:
	* Headers/Foundation/NSAutoreleasePool.h:
	* Headers/Foundation/NSUserDefaults.h:
	* Headers/Foundation/NSXMLNode.h:
	* Headers/Foundation/NSThread.h:
	* Headers/Foundation/NSHost.h:
	* Headers/Foundation/NSRegularExpression.h:
	* Headers/Foundation/NSKeyedArchiver.h:
	* Headers/Foundation/NSProtocolChecker.h:
	* Headers/Foundation/NSError.h:
	* Headers/Foundation/NSPortMessage.h:
	* Headers/Foundation/NSFileHandle.h:
	* Headers/Foundation/NSDistributedLock.h:
	* Headers/Foundation/NSPort.h:
	* Headers/Foundation/NSSortDescriptor.h:
	* Headers/Foundation/NSLocale.h:
	* Headers/Foundation/NSTask.h:
	* Headers/Foundation/NSArchiver.h:
	* Headers/Foundation/NSInvocation.h:
	* Headers/Foundation/NSFileManager.h:
	* Headers/Foundation/NSNumberFormatter.h:
	* Headers/Foundation/NSPortNameServer.h:
	* Headers/Foundation/NSXMLParser.h:
	* Headers/Foundation/NSIndexPath.h:
	* Headers/Additions/GNUstepBase/GSMime.h:
	Tweaks for running in a garbage collecting environment.

2011-03-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSBundle.m: AbsolutePathOfExecutable() attempt to fix this
	to return a fully standardised path without symbolic links.
	* Source/NSFileManager.m:
	* Headers/Foundation/NSFileManager.h:
	Rudimentary implementation of a couple of new methods.

2011-03-05  Tom Davie <beelsebob2>

	* Source/NSSet.m:
	* Headers/Foundation/NSSet.h:
	Add block enumeration.

2011-03-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: Small optimisation suggested by Fred.
	* config/config.initialize.m: Test for working +initialize
	* configure.ac: Use test for +initialize thread safety
	* Headers/Additions/GNUstepBase/config.h.in: regenerate
	* configure: regenerate
	* Source/NSThread.m: Log warning when going multithreaded without
	a reliable runtime.

2011-03-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSNumberFormatter.m: Make error text compatible with OSX
	* Source/NSSpellServer.m: Use NSLanguages user default
	* Source/NSBundle.m: Use NSLanguages user default
	* Source/NSUserDefaults.m:
	Revert recent attempt to avoid deadlocks (broke thread-safety).
	Rewrite shared defaults initialisation and user language management
	to break the complicated interrelationshp between methods which
	made the  initialisation fragile and incomprehensible.
	Language information derived from operating system or environment
	variables (rather than the defaults database) is now stored in a
	new volatile domain.
	The +userLanguages method just returns the NSLanguages default,
	and +setUserLanguages: now sets NSLanguages in the new volatile domain.
	Simplify setup of shared user defaults to avoid deadlocks.

2011-03-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSOperation.m: retain operation while finishing so that it
	doesn't get deallocated too soon (when the queue removes it).

2011-03-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSNumberFormatter.m: Fix -setAllowsFloats to only operate
	in input strings.

2011-03-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSKeyValueObserving.m: Fix possible thread race condition.
	* Source/ObjectiveC2/runtime.c: Fix bogus warning messages.

2011-03-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSOperation.m: re-introduce per-queue thread pool.

2011-03-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSOperation.m: reorganise and simplify code, removing the
	pool of threads for handling operations (need to re-add this at a
	later point, but probably as a separate class) ... implement
	support for 'concurrent' operations (ones which manage their own
	executions rather than running in a thread provided by the queue.

2011-03-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/Unicode.m: Review memory management ... fix possible
	free of non-heap memory.

2011-03-02 Riccardo Mottola <rm@gnu.org>

	* base/NSNumberFormatter/basic.m:
	Add test for checking leading zeroes in fractional part.

2011-03-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: ([-isMemberOfClass:]) test the class returned
	by the -class method rather than using the runtime to get the actual
	class pointer ... fixes for when one class is pretending to be
	another (key value observing).

2011-03-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSKeyValueObserving.m:
	Retain object while sending notifications so we don't get deallocated
	during the process.

2011-03-01  Niels Grewe <niels.grewe@halbordnung.de>

	* Source/GSNetServices.h
	* Headers/Additions/GNUstepBase/NSNetServices+GNUstepBase.h:
	Declare a protocol for GNUstep specific delegate methods in
	NSNetServices.

2011-02-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSAutoreleasePool.m:
	Implement dummy version for use with garbage collecting runtime.

2011-02-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSTimeZone.m:
	* Source/NSPortCoder.m:
	* Source/NSBundle.m:
	* Source/NSPropertyList.m:
	* Source/NSDistributedNotificationCenter.m:
	* Source/NSProcessInfo.m:
	* Source/NSRunLoop.m:
	* Source/NSOperation.m:
	* Source/NSUserDefaults.m:
	* Source/GSArray.m:
	* Source/NSMessagePortNameServer.m:
	* Source/NSKeyedArchiver.m:
	* Source/NSDebug.m:
	* Source/NSPort.m:
	* Source/NSMessagePort.m:
	* Source/win32/NSMessagePortNameServer.m:
	* Source/NSFileManager.m:
	* Source/NSException.m:
	* Source/NSString.m:
	* Source/Additions/NSData+GNUstepBase.m:
	* Source/Additions/GSMime.m:
	* Source/Additions/NSCalendarDate+GNUstepBase.m:
	* Source/Additions/GSXML.m:
	* Source/Additions/GSObjCRuntime.m:
	* Source/GSSet.m:
	* Source/NSConnection.m:
	* Source/NSThread.m:
	* Source/GSeq.h:
	* Source/NSLog.m:
	* Source/NSTask.m:
	Tweaks to avoid compiler warnings in garbage collecting environment.

2011-02-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Tests/GNUmakefile: Use gnustep-make to supply targets.

2011-02-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSFFCallInvocation.m:
	* Source/ObjectiveC2/runtime.c:
	* Source/ObjectiveC2/runtime.h:
	* Source/Additions/GSObjCRuntime.m:
	Avoid messy runtime differences by using old runtime api for typed
	selector features not in the Apple runtime.

2011-02-27  Banlu Kemiyatorn <object@gmail.com>

	* Source/NSOperation.m: Fix error checking condition for dependencies.

2011-02-27  Richard Frith-Macdonald <rfm@gnu.org>

	* configure.ac: Look for gc.h in gc subdirectory
	* configure: regenerate
	* Headers/Additions/GNUstepBase/config.h.in: regenerate
	* Source/GNUmakefile: Don't attempt to build GSBlocks.m until it works
	without causing link failures.
	* Source/NSPortCoder.m:
	* Source/NSKeyedArchiver.m:
	* Source/NSGarbageCollector.m:
	* Source/NSZone.m:
	* Source/GSDictionary.m:
	* Source/GSCountedSet.m:
	* Source/NSNotificationCenter.m:
	* Source/GSAttributedString.m:
	* Source/NSObject.m:
	* Source/NSConcreteMapTable.m:
	* Source/Additions/GSMime.m:
	* Source/Additions/GSObjCRuntime.m:
	* Source/GSSet.m:
	* Source/NSConnection.m:
	* Source/NSThread.m:
	* Source/NSConcreteHashTable.m:
	Modify location of gc.h header.

2011-02-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/ObjectiveC2/runtime.c:
	* Headers/Additions/GNUstepBase/preface.h.in:
	* Headers/Additions/GNUstepBase/GSObjCRuntime.h:
	Remove last vestiges of runtime specific memory allocation apart from
	obsolete macros (marked as deprecated).

2011-02-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDecimal.m:
	Fix NaN comparison in GSDecimalCompare()
	* Source/NSNumber.m:
	Better match OSX for double comparison.

2011-02-24  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSNumber.m:
	Fix error in float comparison.

2011-02-24 Niels Grewe <niels.grewe@halbordnung.de>

	* Source/NSUserDefaults.m
	* Source/NSKeyValueObserving.m:
	Fix typos.

2011-02-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSCalendarDate.m:
	* Source/NSArray.m:
	* Source/NSDebug.m:
	* Source/NSCalendar.m:
	* Source/NSURLResponse.m:
	* Source/NSObject.m:
	* Source/NSDecimalNumber.m:
	* Source/Additions/GSMime.m:
	* Source/NSDateFormatter.m:
	* Source/NSDate.m:
	* Source/NSDictionary.m:
	* Source/NSSet.m:
	* Headers/Foundation/NSCalendarDate.h:
	* Headers/Foundation/NSDecimalNumber.h:
	* Headers/Foundation/NSDate.h:
	* Headers/Foundation/NSArray.h:
	* Headers/Foundation/NSDictionary.h:
	* Headers/Foundation/NSSet.h:
	Tweaks to avoid compiler warnings on mingw and to make the
	-descriptionWithLocale: method consistently take an id argument
	as it now does on OSX.

2011-02-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: Fix bugs in upper and lower casing of constant
	strings.
	* Source/NSTask.m: Force check of termination status when we call
	-isRunning.

2011-02-22  Nicola Pero  <nicola.pero@meta-innovation.com>

	* Source/GSFFIInvocation.m (gs_find_best_typed_sel): Implemented
	for __GNU_LIBOBJC__.  Tidied up documentation.

2011-02-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSBundle.m: Make private executable path be an absolute path.
	* Source/NSDateFormatter.m:
	* Source/NSLocale.m:
	* Source/NSNumberFormatter.m:
	* Source/NSTimeZone.m:
	Remove a few bogus underscores (pointed out by David) which could
	potentially cause problems with compiler/linker etc.

2011-02-21  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: Modified stringByStandardizingPath and
	stringByDeletingLastPathComponent to better match OSX behavior.

2011-02-21  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSNumberFormatter.m:
	* Headers/Foundation/NSNumberFormatter.h:
	If we don't have ICU then the actual behavior is 10.0 style
	irrespective of the formatter behavior setting.

2011-02-21 11:05  David Chisnall <theraven@gna.org>

	* Source/GSFFIInvocation.m: Some changes to method
	  type lookup when forwarding. Alway use the compiler-supplied type
	  information if it exists - this is guaranteed to by the correct
	  type encoding for the call frame and lets us deconstruct it
	  correctly. We can then fail gracefully later on when trying to
	  invoke the selector if the types in the callee don't match,
	  rather than by reading nonsense from the stack now.

	  When using the GNUstep runtime, use the safe mechanism for
	  checking whether there is more than one typed selector, and only
	  use that as a guess if it is safe to do so. With the GCC runtime,
	  we are still stuck using the API that it is impossible to use
	  safely (we might be better off just giving up at this point), but
	  now we call this after -methodSignatureForSelector:, so the app
	  developer gets a chance to do the right thing before we do the
	  wrong thing.

	  Also changed the assert to throw an exception if no type
	  signature can be found. This behaviour is consistent with Mac OS
	  X.

2011-02-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSMethodSignature.m:
	* Source/GSArray.m:
	* Source/NSKeyValueObserving.m:
	* Source/GSPrivate.h:
	* Source/GSDictionary.m:
	* Source/NSURLProtocol.m:
	* Source/NSURL.m:
	* Source/NSObject.m:
	* Source/NSDecimalNumber.m:
	* Source/Additions/GSObjCRuntime.m:
	* Source/Additions/GSInsensitiveDictionary.m:
	* Source/Additions/GSLock.m:
	* Source/GSSet.m:
	* Source/GSString.m:
	* Source/NSConnection.m:
	* Source/NSData.m:
	* Headers/Additions/GNUstepBase/GSObjCRuntime.h:
	Expose class pointer swizzling function in GSObjCRuntime.
	Replace direct references to 'isa' pointer with objc_getClass() and
	objcSetClass() calls (or occasionally calls to the -class method if
	it seems more appropriate).

2011-02-20  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSNumberFormatter.m (-init): Only check the formatter in
	the ICU case.

2011-02-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSFFIInvocation.m:
	* Source/NSCopyObject.m:
	* Source/NSObject.m:
	Replace old code directly referencing class_pointer ivar with calls
	to the new runtime API treating objects as opaque pointers.

2011-02-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPortCoder.m:
	* Source/common.h:
	* Source/NSObject.m:
	* Source/NSAutoreleasePool.m:
	* Source/NSProxy.m:
	* Source/NSSerializer.m:
	Replace all calls to get_imp() with the new runtime API
	class_getMethodImplementation().

2011-02-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDistributedNotificationCenter.m:
	* Source/GSFFCallInvocation.m:
	* Source/GSFFIInvocation.m:
	* Source/common.h:
	* Source/NSConnection.m:
	* Source/NSData.m:
	Use GSObjCRuntime functions for selector types until/unless we can get
	a standard runtime API that handles them.

2011-02-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSBundle.m:
	* Source/NSProcessInfo.m:
	* Source/NSConcretePointerFunctions.m:
	* Source/GSFFCallInvocation.m:
	* Source/NSZone.m:
	* Source/NSCallBacks.m:
	* Source/win32/NSMessagePortNameServer.m:
	* Source/NSFileManager.m:
	* Source/NSURLProtocol.m:
	* Source/objc-load.m:
	* Source/NSException.m:
	* Source/cifframe.m:
	* Source/NSLog.m:
	* Tools/defaults.m:
	* Tests/base/NSInvocation/Resources/InvokeProxy.m:
	Remove obsolete calls to objc_malloc() in favour of NSZoneMalloc() or
	malloc() where using zones is not appropriate.

2011-02-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSFFCallInvocation.m: Updated two obsolete runtime calls
	* Source/common.h: Revert last change as it seemed pointless to
	define macros within a private header which reproduce functions
	we don't actually use (or want to use) within base. I think/hope
	that the tiny change to GSFFcallInvocation.m is all that was needed.

2011-02-19 16:02  David Chisnall <theraven@gna.org>

	* Source/common.h: Add some macros that map some
	libobjc functions to their runtime-specific variants.
	This avoids the need for ugly #ifdefs everywhere (the next commit
	will try to clean up some of this mess), and lets us use the _np
	function names everywhere to explicitly note that we are using
	runtime functions that are not present on OS X - apparently the
	new GCC runtime does not add this suffix for some reason.

2011-02-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDecimalNumber.m:
	* Source/NSNumber.m:
	Quick hacks to try to get NaN comparison working.

2011-02-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDateFormatter.m:
	* Source/NSNumberFormatter.m:
	Fix -initWithCoder: methods to create internal ivar storage.

2011-02-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m:
	* Documentation/coding-standards.texi:
	* Headers/Foundation/NSXMLParser.h:
	Documentation tweaks.

2011-02-16  Jens Ayton <jens@ayton.se>

	* Source/NSPropertyList.m: Fix to support 64bit integers when parsing
	an XML property list.

2011-02-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Tests/base: import the testsuite here
	* Tests/GNUmakefile: add trivial makefile to run tests

2011-02-16  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Resources/German.lproj/Localizable.strings: Add translation for
	undo menu item strings.

2011-02-16  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Source/NSDateFormatter.m (-initWithCoder:, -initWithDateFormat:):
	Add missing calls to super/self initialization.

2011-02-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/common.h:
	* Headers/Additions/GNUstepBase/GNUstep.h:
	Implement David's idea of allowing some generalisation of the _()
	macro by using a preprocessor define to set the bundle to be used
	to lookup localisation information.

2011-02-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSInternal.h:
	* Source/NSDateFormatter.m:
	* Source/NSNumberFormatter.m:
	* Headers/Foundation/NSPortCoder.h:
	* Headers/Foundation/NSCache.h:
	* Headers/Foundation/NSSpellServer.h:
	* Headers/Foundation/NSDecimalNumber.h:
	* Headers/Foundation/NSBundle.h:
	* Headers/Foundation/NSTimer.h:
	* Headers/Foundation/NSScanner.h:
	* Headers/Foundation/NSDistributedNotificationCenter.h:
	* Headers/Foundation/NSComparisonPredicate.h:
	* Headers/Foundation/NSUndoManager.h:
	* Headers/Foundation/NSDateFormatter.h:
	* Headers/Foundation/NSAutoreleasePool.h:
	* Headers/Foundation/NSXMLNode.h:
	* Headers/Foundation/NSUserDefaults.h:
	* Headers/Foundation/NSThread.h:
	* Headers/Foundation/NSHost.h:
	* Headers/Foundation/NSRegularExpression.h:
	* Headers/Foundation/NSKeyedArchiver.h:
	* Headers/Foundation/NSProtocolChecker.h:
	* Headers/Foundation/NSError.h:
	* Headers/Foundation/NSPortMessage.h:
	* Headers/Foundation/NSFileHandle.h:
	* Headers/Foundation/NSDistributedLock.h:
	* Headers/Foundation/NSPort.h:
	* Headers/Foundation/NSSortDescriptor.h:
	* Headers/Foundation/NSLocale.h:
	* Headers/Foundation/NSTask.h:
	* Headers/Foundation/NSArchiver.h:
	* Headers/Foundation/NSInvocation.h:
	* Headers/Foundation/NSFileManager.h:
	* Headers/Foundation/NSNumberFormatter.h:
	* Headers/Foundation/NSPortNameServer.h:
	* Headers/Foundation/NSXMLParser.h:
	* Headers/Foundation/NSIndexPath.h:
	* Headers/Additions/GNUstepBase/GSMime.h:
	* Headers/Additions/GNUstepBase/GSVersionMacros.h:
	* Headers/Additions/GNUstepBase/GSObjCRuntime.h:
	More work on clarifying the use of the reserved/private data
	pointer.  Reinstate accidentally lost '@private', and add the
	GS_UNUSED_IVAR attribute as requested by David to avoid static
	analyser warnings where the reserved pointer is not actually used
	yet. Tidy up latest files to use GSInternal.h

2011-02-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSLocale.m:
	* Source/NSTimeZone.m:
	* Source/NSBundle.m:
	* Source/NSProcessInfo.m:
	* Source/NSUndoManager.m:
	* Source/NSFileHandle.m:
	* Source/NSSortDescriptor.m:
	* Source/NSFileManager.m:
	* Source/common.h:
	* Source/externs.m:
	* Source/NSException.m:
	* Source/NSString.m:
	* Source/Additions/Unicode.m:
	* Source/Additions/GSXML.m:
	* Source/NSLocale.m:
	* Source/NSTask.m:
	As suggested by Wolfgang, change the _() macro for localization when
	used inside base to use the base library bundle rather than the main
	bundle.

2011-02-14  Stefan Bidigaray <stefanbidi@gmail.com>

	* Headers/Foundation/NSDateFormatter.m:
	* Source/NSDateFormatter.m: Changes for ABI compatibility.
	* Source/NSNumberFormatter.m: Use unum_clone to copy formatter.

2011-02-14  German Arias <german@xelalug.org>

	* Resources/Spanish.lproj/Localizable.strings: Added localized strings
	for undo/redo.
	* Source/NSUndoManager.m: Added GSBaseLocalizedString() function.

2011-02-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m:
	* Source/GSInternal.h:
	* Source/DocMakefile:
	* Source/Additions/GSMime.m:
	* Source/Additions/GSObjCRuntime.m:
	* Source/NSConnection.m:
	* Source/NSDateFormatter.m:
	* Documentation/coding-standards.texi:
	* Headers/Foundation/NSBundle.h:
	* Headers/Foundation/NSPropertyList.h:
	* Headers/Foundation/NSConnection.h:
	* Headers/Foundation/NSObjCRuntime.h:
	* Headers/Foundation/NSFileHandle.h:
	* Headers/Additions/GNUstepBase/GSMime.h:
	* Tools/DocMakefile:
	* Tools/AGSParser.m:
	Documentation cleanups and fixes ... add new macros to list of symbols
	to ignore.  Add support for @optional and @required. Add support for
	method attributes.

2011-02-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSPortCoder.h:
	* Headers/Foundation/NSCache.h:
	* Headers/Foundation/NSSpellServer.h:
	* Headers/Foundation/NSDecimalNumber.h:
	* Headers/Foundation/NSBundle.h:
	* Headers/Foundation/NSTimer.h:
	* Headers/Foundation/NSScanner.h:
	* Headers/Foundation/NSDistributedNotificationCenter.h:
	* Headers/Foundation/NSComparisonPredicate.h:
	* Headers/Foundation/NSUndoManager.h:
	* Headers/Foundation/NSDateFormatter.h:
	* Headers/Foundation/NSAutoreleasePool.h:
	* Headers/Foundation/NSUserDefaults.h:
	* Headers/Foundation/NSXMLNode.h:
	* Headers/Foundation/NSThread.h:
	* Headers/Foundation/NSHost.h:
	* Headers/Foundation/NSRegularExpression.h:
	* Headers/Foundation/NSKeyedArchiver.h:
	* Headers/Foundation/NSProtocolChecker.h:
	* Headers/Foundation/NSError.h:
	* Headers/Foundation/NSPortMessage.h:
	* Headers/Foundation/NSFileHandle.h:
	* Headers/Foundation/NSDistributedLock.h:
	* Headers/Foundation/NSPort.h:
	* Headers/Foundation/NSSortDescriptor.h:
	* Headers/Foundation/NSLocale.h:
	* Headers/Foundation/NSTask.h:
	* Headers/Foundation/NSArchiver.h:
	* Headers/Foundation/NSInvocation.h:
	* Headers/Foundation/NSFileManager.h:
	* Headers/Foundation/NSNumberFormatter.h:
	* Headers/Foundation/NSPortNameServer.h:
	* Headers/Foundation/NSXMLParser.h:
	* Headers/Foundation/NSIndexPath.h:
	* Headers/Additions/GNUstepBase/GSMime.h:
	* Headers/Additions/GNUstepBase/GSVersionMacros.h:
	Make the presence of the pointer for reserved/private data clearer
	and more explicit to try to ensure we actually remember to use it
	to prevent ABI breakage.
	* Source/NSNumberFormatter.m:
	Modified to store new/extra ivars via the _reserved pointer so that
	NSNumberFormatter can be safely subclassed by code outside the
	library.

2011-02-13  Stefan Bidigaray <stefanbidi@gmail.com>

	* Source/NSNumberFormatter.m: Moved 10.4+ functionality to a subclass.

2011-02-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPathUtilities.m: NSFullUserName() ... use short name if
	no long one is available.

2011-02-13  Philippe Roussel <p.o.roussel@free.fr>

	* Source/NSPointerArray.m: replace memcpy with memmove for safety.

2011-02-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/NSObject+GNUstepBase.m:
	Use more runtime functions directly.  Standardise exception formats.
	* Source/ObjectiveC2/runtime.c: Fix some cases of dereferencing null
	pointers.

2011-02-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Obtain NSZombie class pointer using
	objc_lookUpClass() to avoid the use of NSString inside the NSObject
	initialize method. Re-order code for safety. Add lots of comments.

2011-02-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPortCoder.m:
	* Source/GSPrivate.h:
	* Source/NSNotificationCenter.m:
	* Source/NSConcreteMapTable.m:
	* Source/NSThread.m:
	* Source/NSSerializer.m:
	* Headers/Additions/GNUstepBase/GSVersionMacros.h:
	Update with new GS_CONSUMED macro to try to avoid static analyzer
	false positives.

2011-02-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSLocale.m: fix memory leak
	* Source/NSThread.m:
	* Source/NSNotificationCenter.m:
	* Source/NSPortCoder.m:
	* Source/NSSerializer.m:
	* Source/NSUserDefaults.m:
	* Source/GSPrivate.h:
	* Source/Additions/NSObject+GNUstepBase.m:
	Add code to try to prevent clang static analyser false warnings.

2011-02-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSPrivate.h:
	* Source/NSObject.m:
	* Source/Additions/NSObject+GNUstepBase.m:
	Remove (unused) code for cleanup at program exit. Let's think of a
	better way (eg runtime support to call a +atExit method).

2011-02-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSThread.m: Avoid some unnecessary locking.
	I think this completes recommitting of all the changes made with
	bugfixes to get them all to at least compile/link on my centos and
	windowsxp systems and to pass the testsuite on centos.

2011-02-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSPrivate.h: Fixed the new GS_BEGINITEMBUF()
	code ... was causing hard-to-track-down memory corruption which
	unfortunately didn't show up in the testsuite (or I'd not have
	re-comitted this code in the first place).

2_011-02-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSKeyValueObserving.m: Recommit
	Reviewed and tested.
	* Source/NAutoreleasePool.m: Make +initialize do nothing so that it
	won't interfere with anythign else when called by [NSObject+initialize]

2011-02-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSLocale.m: Recommit
	* Source/NSUnarchiver.m: Recommit
	I have now test these two and recommited them as working.
	* Source/NSPropertyList.m: Revert
	These was quietly modified/broken since my last commit ...
	reverting to the previous tested/working version.

2011-02-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSArray.m: Recommit fixed version
	* Source/GSICUString.h: Formatting fixups
	* Source/GSICUString.m: Recommit
	* Source/NSAttributedString.m: Recommit
	* Source/NSData.m: Recommit
	* Source/NSMethodSignature.m: Recommit

2011-02-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPropertyList.m: Recommit with modification fixed and tested.
	* Source/NSOperation.m: new tweak to avoid compiler warning.
	* Source/GSPrivate.h: Recommit most recent version after testing.

2011-02-11  Richard Frith-Macdonald <rfm@gnu.org>

	Revert everything back from boken code at 32071 to wrking code at 32051
	due to loads of commits of code which have been occurring to fast for
	anyone to review, and either don't compile or fail the testsuite.
	Lets go through things checking that they at least compile with gcc
	and pass the testsuite before we recommit them!

2011-02-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSICUString.m:
	Fix leak spotted by static analyser.
	* Source/NSArray.m:
	Fix error in enumeration changes causing compile failure.

2011-02-11 12:06  David Chisnall <theraven@gna.org>

	* Source/GSPrivate.h: Added exception-safe version
	  of the GS_BEGINITEMBUF() macro. As a side effect, this should
	  silence the zero-sized VLA warnings in the static analyser.

	  Note: This macro is currently only used on GCC 4+ and clang. It
	  depends on __attribute__((cleanup)), which was introduced some
